/*********************************************************************
	Rhapsody	: 6.1 
	Login		: Masood Khosroshahy
	Component	: DefaultComponent 
	Configuration 	: DefaultConfig
	Model Element	: Initiator_and_dns
//!	Generated Date	: Wed, 19, Apr 2006  
	File Path	: DefaultComponent/DefaultConfig/Initiator_and_dns.h
*********************************************************************/


#ifndef Initiator_and_dns_H 

#define Initiator_and_dns_H 

#include <oxf/oxf.h>
#include <aom/aom.h>
#include "sip.h"
// class Initiator_and_dns 
#include "iDNSLookupInitRes.h"
// class OutBound 
#include "iDNSLookupResInit.h"

//## package sip 

//----------------------------------------------------------------------------
// Initiator_and_dns.h                                                                  
//----------------------------------------------------------------------------

#ifdef _OMINSTRUMENT
class OMAnimatedInitiator_and_dns;
#endif // _OMINSTRUMENT


//## class Initiator_and_dns 
class Initiator_and_dns : public iDNSLookupInitRes {
public :
    
        
        //## ignore 
        class pDNSServer_C  {
        public :
            class InBound_C;
            class OutBound_C;
            
        public :
            
                
                //## ignore 
                class InBound_C : public iDNSLookupInitRes {
                
                
                ////    Constructors and destructors    ////
                public :
                    
                    //## auto_generated 
                    InBound_C();
                    
                    //## auto_generated 
                    virtual ~InBound_C();
                
                
                ////    Operations    ////
                public :
                    
                    //## operation send(IOxfEvent*,const IOxfEventGenerationParams&) 
                    bool send(IOxfEvent* event, const IOxfEventGenerationParams& params);
                    
                    //## operation send(IOxfEvent*) 
                    bool send(IOxfEvent* event);
                
                
                ////    Additional operations    ////
                public :
                    
                    //## auto_generated 
                    iDNSLookupInitRes* getItsIDNSLookupInitRes() const;
                    
                    //## auto_generated 
                    void setItsIDNSLookupInitRes(iDNSLookupInitRes* p_iDNSLookupInitRes);
                    
                    //## auto_generated 
                    pDNSServer_C* getPort() const;
                    
                    //## auto_generated 
                    void setPort(pDNSServer_C* p_pDNSServer_C);
                
                
                ////    Framework operations    ////
                public :
                    
                    //## auto_generated 
                    void __setPort(pDNSServer_C* p_pDNSServer_C);
                    
                    //## auto_generated 
                    void _setPort(pDNSServer_C* p_pDNSServer_C);
                    
                    //## auto_generated 
                    void _clearPort();
                
                protected :
                    
                    //## auto_generated 
                    void cleanUpRelations();
                
                
                ////    Relations and components    ////
                protected :
                    
                    iDNSLookupInitRes* itsIDNSLookupInitRes;		//## link itsIDNSLookupInitRes 
                    
                    
                    pDNSServer_C* port;		//## link port 
                    
                
                
                };
                
            
                
                //## ignore 
                class OutBound_C : public iDNSLookupResInit {
                
                
                ////    Constructors and destructors    ////
                public :
                    
                    //## auto_generated 
                    OutBound_C();
                    
                    //## auto_generated 
                    virtual ~OutBound_C();
                
                
                ////    Operations    ////
                public :
                    
                    //## operation send(IOxfEvent*,const IOxfEventGenerationParams&) 
                    bool send(IOxfEvent* event, const IOxfEventGenerationParams& params);
                    
                    //## operation send(IOxfEvent*) 
                    bool send(IOxfEvent* event);
                
                
                ////    Additional operations    ////
                public :
                    
                    //## auto_generated 
                    OMReactive* getItsIDNSLookupResInit() const;
                    
                    //## auto_generated 
                    void setItsIDNSLookupResInit(OMReactive* p_OMReactive);
                
                
                ////    Framework operations    ////
                protected :
                    
                    //## auto_generated 
                    void cleanUpRelations();
                
                
                ////    Relations and components    ////
                protected :
                    
                    OMReactive* itsIDNSLookupResInit;		//## link itsIDNSLookupResInit 
                    
                
                
                };
                
            
        //## ignore 
        
        
        ////    Constructors and destructors    ////
        public :
            
            //## auto_generated 
            pDNSServer_C();
            
            //## auto_generated 
            virtual ~pDNSServer_C();
        
        
        ////    Operations    ////
        public :
            
            //## operation connectInitiator_and_dns(Initiator_and_dns*) 
            void connectInitiator_and_dns(Initiator_and_dns* part);
            
            //## operation getItsIDNSLookupInitRes() 
            iDNSLookupInitRes* getItsIDNSLookupInitRes();
            
            //## operation getItsIDNSLookupResInit() 
            iDNSLookupResInit* getItsIDNSLookupResInit();
            
            //## operation setItsIDNSLookupInitRes(iDNSLookupInitRes*) 
            void setItsIDNSLookupInitRes(iDNSLookupInitRes* p_iDNSLookupInitRes);
            
            //## operation setItsIDNSLookupResInit(OMReactive*) 
            void setItsIDNSLookupResInit(OMReactive* p_iDNSLookupResInit);
        
        
        ////    Additional operations    ////
        public :
            
            //## auto_generated 
            InBound_C* getInBound() const;
            
            //## auto_generated 
            OutBound_C* getOutBound() const;
        
        
        ////    Framework operations    ////
        public :
            
            //## auto_generated 
            void destroy();
        
        protected :
            
            //## auto_generated 
            void initRelations();
        
        
        ////    Attributes    ////
        protected :
            
            int _p_;		//## attribute _p_ 
            
        
        ////    Relations and components    ////
        protected :
            
            InBound_C InBound;		//## classInstance InBound 
            
            
            OutBound_C OutBound;		//## classInstance OutBound 
            
        
        
        };
        
    
        
        //## ignore 
        class pDNS_A_C  {
        public :
            class InBound_C;
            class OutBound_C;
            
        public :
            
                
                //## ignore 
                class InBound_C : public iDNSLookupInitRes {
                
                
                ////    Constructors and destructors    ////
                public :
                    
                    //## auto_generated 
                    InBound_C();
                    
                    //## auto_generated 
                    virtual ~InBound_C();
                
                
                ////    Operations    ////
                public :
                    
                    //## operation send(IOxfEvent*,const IOxfEventGenerationParams&) 
                    bool send(IOxfEvent* event, const IOxfEventGenerationParams& params);
                    
                    //## operation send(IOxfEvent*) 
                    bool send(IOxfEvent* event);
                
                
                ////    Additional operations    ////
                public :
                    
                    //## auto_generated 
                    iDNSLookupInitRes* getItsIDNSLookupInitRes() const;
                    
                    //## auto_generated 
                    void setItsIDNSLookupInitRes(iDNSLookupInitRes* p_iDNSLookupInitRes);
                    
                    //## auto_generated 
                    pDNS_A_C* getPort() const;
                    
                    //## auto_generated 
                    void setPort(pDNS_A_C* p_pDNS_A_C);
                
                
                ////    Framework operations    ////
                public :
                    
                    //## auto_generated 
                    void __setPort(pDNS_A_C* p_pDNS_A_C);
                    
                    //## auto_generated 
                    void _setPort(pDNS_A_C* p_pDNS_A_C);
                    
                    //## auto_generated 
                    void _clearPort();
                
                protected :
                    
                    //## auto_generated 
                    void cleanUpRelations();
                
                
                ////    Relations and components    ////
                protected :
                    
                    iDNSLookupInitRes* itsIDNSLookupInitRes;		//## link itsIDNSLookupInitRes 
                    
                    
                    pDNS_A_C* port;		//## link port 
                    
                
                
                };
                
            
                
                //## ignore 
                class OutBound_C : public iDNSLookupResInit {
                
                
                ////    Constructors and destructors    ////
                public :
                    
                    //## auto_generated 
                    OutBound_C();
                    
                    //## auto_generated 
                    virtual ~OutBound_C();
                
                
                ////    Operations    ////
                public :
                    
                    //## operation send(IOxfEvent*,const IOxfEventGenerationParams&) 
                    bool send(IOxfEvent* event, const IOxfEventGenerationParams& params);
                    
                    //## operation send(IOxfEvent*) 
                    bool send(IOxfEvent* event);
                
                
                ////    Additional operations    ////
                public :
                    
                    //## auto_generated 
                    OMReactive* getItsIDNSLookupResInit() const;
                    
                    //## auto_generated 
                    void setItsIDNSLookupResInit(OMReactive* p_OMReactive);
                
                
                ////    Framework operations    ////
                protected :
                    
                    //## auto_generated 
                    void cleanUpRelations();
                
                
                ////    Relations and components    ////
                protected :
                    
                    OMReactive* itsIDNSLookupResInit;		//## link itsIDNSLookupResInit 
                    
                
                
                };
                
            
        //## ignore 
        
        
        ////    Constructors and destructors    ////
        public :
            
            //## auto_generated 
            pDNS_A_C();
            
            //## auto_generated 
            virtual ~pDNS_A_C();
        
        
        ////    Operations    ////
        public :
            
            //## operation connectInitiator_and_dns(Initiator_and_dns*) 
            void connectInitiator_and_dns(Initiator_and_dns* part);
            
            //## operation getItsIDNSLookupInitRes() 
            iDNSLookupInitRes* getItsIDNSLookupInitRes();
            
            //## operation getItsIDNSLookupResInit() 
            iDNSLookupResInit* getItsIDNSLookupResInit();
            
            //## operation setItsIDNSLookupInitRes(iDNSLookupInitRes*) 
            void setItsIDNSLookupInitRes(iDNSLookupInitRes* p_iDNSLookupInitRes);
            
            //## operation setItsIDNSLookupResInit(OMReactive*) 
            void setItsIDNSLookupResInit(OMReactive* p_iDNSLookupResInit);
        
        
        ////    Additional operations    ////
        public :
            
            //## auto_generated 
            InBound_C* getInBound() const;
            
            //## auto_generated 
            OutBound_C* getOutBound() const;
        
        
        ////    Framework operations    ////
        public :
            
            //## auto_generated 
            void destroy();
        
        protected :
            
            //## auto_generated 
            void initRelations();
        
        
        ////    Attributes    ////
        protected :
            
            int _p_;		//## attribute _p_ 
            
        
        ////    Relations and components    ////
        protected :
            
            InBound_C InBound;		//## classInstance InBound 
            
            
            OutBound_C OutBound;		//## classInstance OutBound 
            
        
        
        };
        
    
        
        //## ignore 
        class pDNS_Bh_C  {
        public :
            class InBound_C;
            class OutBound_C;
            
        public :
            
                
                //## ignore 
                class InBound_C : public iDNSLookupInitRes {
                
                
                ////    Constructors and destructors    ////
                public :
                    
                    //## auto_generated 
                    InBound_C();
                    
                    //## auto_generated 
                    virtual ~InBound_C();
                
                
                ////    Operations    ////
                public :
                    
                    //## operation send(IOxfEvent*,const IOxfEventGenerationParams&) 
                    bool send(IOxfEvent* event, const IOxfEventGenerationParams& params);
                    
                    //## operation send(IOxfEvent*) 
                    bool send(IOxfEvent* event);
                
                
                ////    Additional operations    ////
                public :
                    
                    //## auto_generated 
                    iDNSLookupInitRes* getItsIDNSLookupInitRes() const;
                    
                    //## auto_generated 
                    void setItsIDNSLookupInitRes(iDNSLookupInitRes* p_iDNSLookupInitRes);
                    
                    //## auto_generated 
                    pDNS_Bh_C* getPort() const;
                    
                    //## auto_generated 
                    void setPort(pDNS_Bh_C* p_pDNS_Bh_C);
                
                
                ////    Framework operations    ////
                public :
                    
                    //## auto_generated 
                    void __setPort(pDNS_Bh_C* p_pDNS_Bh_C);
                    
                    //## auto_generated 
                    void _setPort(pDNS_Bh_C* p_pDNS_Bh_C);
                    
                    //## auto_generated 
                    void _clearPort();
                
                protected :
                    
                    //## auto_generated 
                    void cleanUpRelations();
                
                
                ////    Relations and components    ////
                protected :
                    
                    iDNSLookupInitRes* itsIDNSLookupInitRes;		//## link itsIDNSLookupInitRes 
                    
                    
                    pDNS_Bh_C* port;		//## link port 
                    
                
                
                };
                
            
                
                //## ignore 
                class OutBound_C : public iDNSLookupResInit {
                
                
                ////    Constructors and destructors    ////
                public :
                    
                    //## auto_generated 
                    OutBound_C();
                    
                    //## auto_generated 
                    virtual ~OutBound_C();
                
                
                ////    Operations    ////
                public :
                    
                    //## operation send(IOxfEvent*,const IOxfEventGenerationParams&) 
                    bool send(IOxfEvent* event, const IOxfEventGenerationParams& params);
                    
                    //## operation send(IOxfEvent*) 
                    bool send(IOxfEvent* event);
                
                
                ////    Additional operations    ////
                public :
                    
                    //## auto_generated 
                    OMReactive* getItsIDNSLookupResInit() const;
                    
                    //## auto_generated 
                    void setItsIDNSLookupResInit(OMReactive* p_OMReactive);
                
                
                ////    Framework operations    ////
                protected :
                    
                    //## auto_generated 
                    void cleanUpRelations();
                
                
                ////    Relations and components    ////
                protected :
                    
                    OMReactive* itsIDNSLookupResInit;		//## link itsIDNSLookupResInit 
                    
                
                
                };
                
            
        //## ignore 
        
        
        ////    Constructors and destructors    ////
        public :
            
            //## auto_generated 
            pDNS_Bh_C();
            
            //## auto_generated 
            virtual ~pDNS_Bh_C();
        
        
        ////    Operations    ////
        public :
            
            //## operation connectInitiator_and_dns(Initiator_and_dns*) 
            void connectInitiator_and_dns(Initiator_and_dns* part);
            
            //## operation getItsIDNSLookupInitRes() 
            iDNSLookupInitRes* getItsIDNSLookupInitRes();
            
            //## operation getItsIDNSLookupResInit() 
            iDNSLookupResInit* getItsIDNSLookupResInit();
            
            //## operation setItsIDNSLookupInitRes(iDNSLookupInitRes*) 
            void setItsIDNSLookupInitRes(iDNSLookupInitRes* p_iDNSLookupInitRes);
            
            //## operation setItsIDNSLookupResInit(OMReactive*) 
            void setItsIDNSLookupResInit(OMReactive* p_iDNSLookupResInit);
        
        
        ////    Additional operations    ////
        public :
            
            //## auto_generated 
            InBound_C* getInBound() const;
            
            //## auto_generated 
            OutBound_C* getOutBound() const;
        
        
        ////    Framework operations    ////
        public :
            
            //## auto_generated 
            void destroy();
        
        protected :
            
            //## auto_generated 
            void initRelations();
        
        
        ////    Attributes    ////
        protected :
            
            int _p_;		//## attribute _p_ 
            
        
        ////    Relations and components    ////
        protected :
            
            InBound_C InBound;		//## classInstance InBound 
            
            
            OutBound_C OutBound;		//## classInstance OutBound 
            
        
        
        };
        
    
        
        //## ignore 
        class pDNS_Bw_C  {
        public :
            class InBound_C;
            class OutBound_C;
            
        public :
            
                
                //## ignore 
                class InBound_C : public iDNSLookupInitRes {
                
                
                ////    Constructors and destructors    ////
                public :
                    
                    //## auto_generated 
                    InBound_C();
                    
                    //## auto_generated 
                    virtual ~InBound_C();
                
                
                ////    Operations    ////
                public :
                    
                    //## operation send(IOxfEvent*,const IOxfEventGenerationParams&) 
                    bool send(IOxfEvent* event, const IOxfEventGenerationParams& params);
                    
                    //## operation send(IOxfEvent*) 
                    bool send(IOxfEvent* event);
                
                
                ////    Additional operations    ////
                public :
                    
                    //## auto_generated 
                    iDNSLookupInitRes* getItsIDNSLookupInitRes() const;
                    
                    //## auto_generated 
                    void setItsIDNSLookupInitRes(iDNSLookupInitRes* p_iDNSLookupInitRes);
                    
                    //## auto_generated 
                    pDNS_Bw_C* getPort() const;
                    
                    //## auto_generated 
                    void setPort(pDNS_Bw_C* p_pDNS_Bw_C);
                
                
                ////    Framework operations    ////
                public :
                    
                    //## auto_generated 
                    void __setPort(pDNS_Bw_C* p_pDNS_Bw_C);
                    
                    //## auto_generated 
                    void _setPort(pDNS_Bw_C* p_pDNS_Bw_C);
                    
                    //## auto_generated 
                    void _clearPort();
                
                protected :
                    
                    //## auto_generated 
                    void cleanUpRelations();
                
                
                ////    Relations and components    ////
                protected :
                    
                    iDNSLookupInitRes* itsIDNSLookupInitRes;		//## link itsIDNSLookupInitRes 
                    
                    
                    pDNS_Bw_C* port;		//## link port 
                    
                
                
                };
                
            
                
                //## ignore 
                class OutBound_C : public iDNSLookupResInit {
                
                
                ////    Constructors and destructors    ////
                public :
                    
                    //## auto_generated 
                    OutBound_C();
                    
                    //## auto_generated 
                    virtual ~OutBound_C();
                
                
                ////    Operations    ////
                public :
                    
                    //## operation send(IOxfEvent*,const IOxfEventGenerationParams&) 
                    bool send(IOxfEvent* event, const IOxfEventGenerationParams& params);
                    
                    //## operation send(IOxfEvent*) 
                    bool send(IOxfEvent* event);
                
                
                ////    Additional operations    ////
                public :
                    
                    //## auto_generated 
                    OMReactive* getItsIDNSLookupResInit() const;
                    
                    //## auto_generated 
                    void setItsIDNSLookupResInit(OMReactive* p_OMReactive);
                
                
                ////    Framework operations    ////
                protected :
                    
                    //## auto_generated 
                    void cleanUpRelations();
                
                
                ////    Relations and components    ////
                protected :
                    
                    OMReactive* itsIDNSLookupResInit;		//## link itsIDNSLookupResInit 
                    
                
                
                };
                
            
        //## ignore 
        
        
        ////    Constructors and destructors    ////
        public :
            
            //## auto_generated 
            pDNS_Bw_C();
            
            //## auto_generated 
            virtual ~pDNS_Bw_C();
        
        
        ////    Operations    ////
        public :
            
            //## operation connectInitiator_and_dns(Initiator_and_dns*) 
            void connectInitiator_and_dns(Initiator_and_dns* part);
            
            //## operation getItsIDNSLookupInitRes() 
            iDNSLookupInitRes* getItsIDNSLookupInitRes();
            
            //## operation getItsIDNSLookupResInit() 
            iDNSLookupResInit* getItsIDNSLookupResInit();
            
            //## operation setItsIDNSLookupInitRes(iDNSLookupInitRes*) 
            void setItsIDNSLookupInitRes(iDNSLookupInitRes* p_iDNSLookupInitRes);
            
            //## operation setItsIDNSLookupResInit(OMReactive*) 
            void setItsIDNSLookupResInit(OMReactive* p_iDNSLookupResInit);
        
        
        ////    Additional operations    ////
        public :
            
            //## auto_generated 
            InBound_C* getInBound() const;
            
            //## auto_generated 
            OutBound_C* getOutBound() const;
        
        
        ////    Framework operations    ////
        public :
            
            //## auto_generated 
            void destroy();
        
        protected :
            
            //## auto_generated 
            void initRelations();
        
        
        ////    Attributes    ////
        protected :
            
            int _p_;		//## attribute _p_ 
            
        
        ////    Relations and components    ////
        protected :
            
            InBound_C InBound;		//## classInstance InBound 
            
            
            OutBound_C OutBound;		//## classInstance OutBound 
            
        
        
        };
        
    
        
        //## ignore 
        class pDNS_C_C  {
        public :
            class InBound_C;
            class OutBound_C;
            
        public :
            
                
                //## ignore 
                class InBound_C : public iDNSLookupInitRes {
                
                
                ////    Constructors and destructors    ////
                public :
                    
                    //## auto_generated 
                    InBound_C();
                    
                    //## auto_generated 
                    virtual ~InBound_C();
                
                
                ////    Operations    ////
                public :
                    
                    //## operation send(IOxfEvent*,const IOxfEventGenerationParams&) 
                    bool send(IOxfEvent* event, const IOxfEventGenerationParams& params);
                    
                    //## operation send(IOxfEvent*) 
                    bool send(IOxfEvent* event);
                
                
                ////    Additional operations    ////
                public :
                    
                    //## auto_generated 
                    iDNSLookupInitRes* getItsIDNSLookupInitRes() const;
                    
                    //## auto_generated 
                    void setItsIDNSLookupInitRes(iDNSLookupInitRes* p_iDNSLookupInitRes);
                    
                    //## auto_generated 
                    pDNS_C_C* getPort() const;
                    
                    //## auto_generated 
                    void setPort(pDNS_C_C* p_pDNS_C_C);
                
                
                ////    Framework operations    ////
                public :
                    
                    //## auto_generated 
                    void __setPort(pDNS_C_C* p_pDNS_C_C);
                    
                    //## auto_generated 
                    void _setPort(pDNS_C_C* p_pDNS_C_C);
                    
                    //## auto_generated 
                    void _clearPort();
                
                protected :
                    
                    //## auto_generated 
                    void cleanUpRelations();
                
                
                ////    Relations and components    ////
                protected :
                    
                    iDNSLookupInitRes* itsIDNSLookupInitRes;		//## link itsIDNSLookupInitRes 
                    
                    
                    pDNS_C_C* port;		//## link port 
                    
                
                
                };
                
            
                
                //## ignore 
                class OutBound_C : public iDNSLookupResInit {
                
                
                ////    Constructors and destructors    ////
                public :
                    
                    //## auto_generated 
                    OutBound_C();
                    
                    //## auto_generated 
                    virtual ~OutBound_C();
                
                
                ////    Operations    ////
                public :
                    
                    //## operation send(IOxfEvent*,const IOxfEventGenerationParams&) 
                    bool send(IOxfEvent* event, const IOxfEventGenerationParams& params);
                    
                    //## operation send(IOxfEvent*) 
                    bool send(IOxfEvent* event);
                
                
                ////    Additional operations    ////
                public :
                    
                    //## auto_generated 
                    OMReactive* getItsIDNSLookupResInit() const;
                    
                    //## auto_generated 
                    void setItsIDNSLookupResInit(OMReactive* p_OMReactive);
                
                
                ////    Framework operations    ////
                protected :
                    
                    //## auto_generated 
                    void cleanUpRelations();
                
                
                ////    Relations and components    ////
                protected :
                    
                    OMReactive* itsIDNSLookupResInit;		//## link itsIDNSLookupResInit 
                    
                
                
                };
                
            
        //## ignore 
        
        
        ////    Constructors and destructors    ////
        public :
            
            //## auto_generated 
            pDNS_C_C();
            
            //## auto_generated 
            virtual ~pDNS_C_C();
        
        
        ////    Operations    ////
        public :
            
            //## operation connectInitiator_and_dns(Initiator_and_dns*) 
            void connectInitiator_and_dns(Initiator_and_dns* part);
            
            //## operation getItsIDNSLookupInitRes() 
            iDNSLookupInitRes* getItsIDNSLookupInitRes();
            
            //## operation getItsIDNSLookupResInit() 
            iDNSLookupResInit* getItsIDNSLookupResInit();
            
            //## operation setItsIDNSLookupInitRes(iDNSLookupInitRes*) 
            void setItsIDNSLookupInitRes(iDNSLookupInitRes* p_iDNSLookupInitRes);
            
            //## operation setItsIDNSLookupResInit(OMReactive*) 
            void setItsIDNSLookupResInit(OMReactive* p_iDNSLookupResInit);
        
        
        ////    Additional operations    ////
        public :
            
            //## auto_generated 
            InBound_C* getInBound() const;
            
            //## auto_generated 
            OutBound_C* getOutBound() const;
        
        
        ////    Framework operations    ////
        public :
            
            //## auto_generated 
            void destroy();
        
        protected :
            
            //## auto_generated 
            void initRelations();
        
        
        ////    Attributes    ////
        protected :
            
            int _p_;		//## attribute _p_ 
            
        
        ////    Relations and components    ////
        protected :
            
            InBound_C InBound;		//## classInstance InBound 
            
            
            OutBound_C OutBound;		//## classInstance OutBound 
            
        
        
        };
        
    
//## class Initiator_and_dns 


////    Friends    ////
public :
    
    
#ifdef _OMINSTRUMENT
    friend  class OMAnimatedInitiator_and_dns;
#endif // _OMINSTRUMENT


////    Constructors and destructors    ////
public :
    
    //## auto_generated 
    Initiator_and_dns(IOxfActive* theActiveContext = 0);
    
    //## auto_generated 
    ~Initiator_and_dns();


////    Operations    ////
public :
    
    //## operation add_dns_entry(char*,char*) 
    void add_dns_entry(char* address, char* portName);
    
    //## operation searchDNSEntry(OMString) 
    char* searchDNSEntry(const OMString& arg);


////    Additional operations    ////
public :
    
    //## auto_generated 
    pDNSServer_C* getPDNSServer() const;
    
    //## auto_generated 
    pDNSServer_C* get_pDNSServer() const;
    
    //## auto_generated 
    pDNSServer_C* newPDNSServer();
    
    //## auto_generated 
    void deletePDNSServer();
    
    //## auto_generated 
    pDNS_A_C* getPDNS_A() const;
    
    //## auto_generated 
    pDNS_A_C* get_pDNS_A() const;
    
    //## auto_generated 
    pDNS_A_C* newPDNS_A();
    
    //## auto_generated 
    void deletePDNS_A();
    
    //## auto_generated 
    pDNS_Bh_C* getPDNS_Bh() const;
    
    //## auto_generated 
    pDNS_Bh_C* get_pDNS_Bh() const;
    
    //## auto_generated 
    pDNS_Bh_C* newPDNS_Bh();
    
    //## auto_generated 
    void deletePDNS_Bh();
    
    //## auto_generated 
    pDNS_Bw_C* getPDNS_Bw() const;
    
    //## auto_generated 
    pDNS_Bw_C* get_pDNS_Bw() const;
    
    //## auto_generated 
    pDNS_Bw_C* newPDNS_Bw();
    
    //## auto_generated 
    void deletePDNS_Bw();
    
    //## auto_generated 
    pDNS_C_C* getPDNS_C() const;
    
    //## auto_generated 
    pDNS_C_C* get_pDNS_C() const;
    
    //## auto_generated 
    pDNS_C_C* newPDNS_C();
    
    //## auto_generated 
    void deletePDNS_C();
    
    //## auto_generated 
    OMString getAddress() const;
    
    //## auto_generated 
    void setAddress(OMString p_address);
    
    //## auto_generated 
    dns_table_type getDnsTable() const;
    
    //## auto_generated 
    void setDnsTable(dns_table_type p_dnsTable);
    
    //## auto_generated 
    int getI() const;
    
    //## auto_generated 
    void setI(int p_i);
    
    //## auto_generated 
    int getNbEntries() const;
    
    //## auto_generated 
    void setNbEntries(int p_nbEntries);
    
    //## auto_generated 
    char* getPortName() const;
    
    //## auto_generated 
    void setPortName(char* p_portName);


////    Framework operations    ////
public :
    
    //rootState:
    
    //## statechart_method 
    inline bool rootState_IN() const;
    
    //## statechart_method 
    virtual void rootState_entDef();
    
    //## statechart_method 
    virtual IOxfReactive::TakeEventStatus rootState_processEvent();
    
    //mainState:
    
    //## statechart_method 
    inline bool mainState_IN() const;
    
    //WaitForDNSQueries:
    
    //## statechart_method 
    inline bool WaitForDNSQueries_IN() const;
    
    //WaitForDNSQuery:
    
    //## statechart_method 
    inline bool WaitForDNSQuery_IN() const;
    
    //DNSQueryReceivedServer:
    
    //## statechart_method 
    inline bool DNSQueryReceivedServer_IN() const;
    
    //DNSQueryReceivedC:
    
    //## statechart_method 
    inline bool DNSQueryReceivedC_IN() const;
    
    //DNSQueryReceivedBw:
    
    //## statechart_method 
    inline bool DNSQueryReceivedBw_IN() const;
    
    //DNSQueryReceivedBh:
    
    //## statechart_method 
    inline bool DNSQueryReceivedBh_IN() const;
    
    //DNSQueryReceivedA:
    
    //## statechart_method 
    inline bool DNSQueryReceivedA_IN() const;
    
    //DNSEntrySentServer:
    
    //## statechart_method 
    inline bool DNSEntrySentServer_IN() const;
    
    //DNSEntrySentC:
    
    //## statechart_method 
    inline bool DNSEntrySentC_IN() const;
    
    //DNSEntrySentBw:
    
    //## statechart_method 
    inline bool DNSEntrySentBw_IN() const;
    
    //DNSEntrySentBh:
    
    //## statechart_method 
    inline bool DNSEntrySentBh_IN() const;
    
    //DNSEntrySentA:
    
    //## statechart_method 
    inline bool DNSEntrySentA_IN() const;
    
    //Initializing:
    
    //## statechart_method 
    inline bool Initializing_IN() const;
    
    //## statechart_method 
    IOxfReactive::TakeEventStatus Initializing_processEvent();
    
    //state_61:
    
    //## statechart_method 
    inline bool state_61_IN() const;
    
    //## statechart_method 
    IOxfReactive::TakeEventStatus state_61_processEvent();
    
    //SentToC:
    
    //## statechart_method 
    inline bool SentToC_IN() const;
    
    //SendingToC:
    
    //## statechart_method 
    inline bool SendingToC_IN() const;
    
    //Ack:
    
    //## statechart_method 
    inline bool Ack_IN() const;
    
    //state_21:
    
    //## statechart_method 
    inline bool state_21_IN() const;
    
    //## statechart_method 
    IOxfReactive::TakeEventStatus state_21_processEvent();
    
    //SentToBw:
    
    //## statechart_method 
    inline bool SentToBw_IN() const;
    
    //SendingToBw:
    
    //## statechart_method 
    inline bool SendingToBw_IN() const;
    
    //state_21_Ack:
    
    //## statechart_method 
    inline bool state_21_Ack_IN() const;
    
    //state_20:
    
    //## statechart_method 
    inline bool state_20_IN() const;
    
    //## statechart_method 
    IOxfReactive::TakeEventStatus state_20_processEvent();
    
    //SentToBh:
    
    //## statechart_method 
    inline bool SentToBh_IN() const;
    
    //SendingToBh:
    
    //## statechart_method 
    inline bool SendingToBh_IN() const;
    
    //state_20_Ack:
    
    //## statechart_method 
    inline bool state_20_Ack_IN() const;
    
    //state_16:
    
    //## statechart_method 
    inline bool state_16_IN() const;
    
    //## statechart_method 
    IOxfReactive::TakeEventStatus state_16_processEvent();
    
    //SentToA:
    
    //## statechart_method 
    inline bool SentToA_IN() const;
    
    //SendingToA:
    
    //## statechart_method 
    inline bool SendingToA_IN() const;
    
    //state_16_Ack:
    
    //## statechart_method 
    inline bool state_16_Ack_IN() const;
    
    //state_15:
    
    //## statechart_method 
    inline bool state_15_IN() const;
    
    //## statechart_method 
    IOxfReactive::TakeEventStatus state_15_processEvent();
    
    //SentToServer:
    
    //## statechart_method 
    inline bool SentToServer_IN() const;
    
    //SendingToSever:
    
    //## statechart_method 
    inline bool SendingToSever_IN() const;
    
    //state_15_Ack:
    
    //## statechart_method 
    inline bool state_15_Ack_IN() const;
    
    //AllAckReceived:
    
    //## statechart_method 
    inline bool AllAckReceived_IN() const;
    
    //## auto_generated 
    virtual bool startBehavior();
    
    //## statechart_method 
    IOxfReactive::TakeEventStatus state_16_AckTakeNull();
    
    //## statechart_method 
    IOxfReactive::TakeEventStatus state_20_AckTakeNull();
    
    //## statechart_method 
    IOxfReactive::TakeEventStatus Ack_handleEvent();
    
    //## statechart_method 
    void mainState_entDef();
    
    //## statechart_method 
    void state_16_entDef();
    
    //## statechart_method 
    void state_21_entDef();
    
    //## statechart_method 
    IOxfReactive::TakeEventStatus AckTakeNull();
    
    //## statechart_method 
    IOxfReactive::TakeEventStatus state_21_Ack_handleEvent();
    
    //## statechart_method 
    IOxfReactive::TakeEventStatus WaitForDNSQuery_handleEvent();
    
    //## statechart_method 
    IOxfReactive::TakeEventStatus WaitForDNSQueryTakeevDNSLookup();
    
    //## statechart_method 
    IOxfReactive::TakeEventStatus state_16_Ack_handleEvent();
    
    //## statechart_method 
    void state_61_entDef();
    
    //## statechart_method 
    void Initializing_exit();
    
    //## statechart_method 
    IOxfReactive::TakeEventStatus state_21_AckTakeNull();
    
    //## statechart_method 
    IOxfReactive::TakeEventStatus state_20_Ack_handleEvent();
    
    //## statechart_method 
    void Initializing_entDef();
    
    //## statechart_method 
    void rootStateEntDef();
    
    //## statechart_method 
    IOxfReactive::TakeEventStatus state_15_Ack_handleEvent();
    
    //## statechart_method 
    IOxfReactive::TakeEventStatus state_15_AckTakeNull();
    
    //## statechart_method 
    void WaitForDNSQueries_entDef();
    
    //## statechart_method 
    void state_15_entDef();
    
    //## statechart_method 
    void state_20_entDef();
    
    //## statechart_method 
    void mainStateEntDef();
    
    //## statechart_method 
    void WaitForDNSQueries_exit();

protected :
    
    //## auto_generated 
    void initRelations();
    
    //## auto_generated 
    void initStatechart();
    
    //## auto_generated 
    void cleanUpRelations();


////    Attributes    ////
protected :
    
    OMString address;		//## attribute address 
    
    dns_table_type dnsTable;		//## attribute dnsTable 
    
    int i;		//## attribute i 
    
    int nbEntries;		//## attribute nbEntries 
    
    char* portName;		//## attribute portName 
    

////    Relations and components    ////
protected :
    
    pDNSServer_C* pDNSServer;		//## classInstance pDNSServer 
    
    
    pDNS_A_C* pDNS_A;		//## classInstance pDNS_A 
    
    
    pDNS_Bh_C* pDNS_Bh;		//## classInstance pDNS_Bh 
    
    
    pDNS_Bw_C* pDNS_Bw;		//## classInstance pDNS_Bw 
    
    
    pDNS_C_C* pDNS_C;		//## classInstance pDNS_C 
    


////    Framework    ////
protected :
    
    //#[ ignore 
    //states enumeration: 
    enum Initiator_and_dns_Enum{ OMNonState=0, mainState=1, WaitForDNSQueries=2, WaitForDNSQuery=3, 
        DNSQueryReceivedServer=4, DNSQueryReceivedC=5, DNSQueryReceivedBw=6, DNSQueryReceivedBh=7, 
        DNSQueryReceivedA=8, DNSEntrySentServer=9, DNSEntrySentC=10, DNSEntrySentBw=11, 
        DNSEntrySentBh=12, DNSEntrySentA=13, Initializing=14, state_61=15, 
        SentToC=16, SendingToC=17, Ack=18, state_21=19, 
        SentToBw=20, SendingToBw=21, state_21_Ack=22, state_20=23, 
        SentToBh=24, SendingToBh=25, state_20_Ack=26, state_16=27, 
        SentToA=28, SendingToA=29, state_16_Ack=30, state_15=31, 
        SentToServer=32, SendingToSever=33, state_15_Ack=34, AllAckReceived=35 };
        //#]
    
    int rootState_subState;		//## ignore 
    
    
    int rootState_active;		//## ignore 
    
    
    int mainState_subState;		//## ignore 
    
    
    int WaitForDNSQueries_subState;		//## ignore 
    
    
    int state_61_subState;		//## ignore 
    
    
    int state_61_active;		//## ignore 
    
    
    int state_21_subState;		//## ignore 
    
    
    int state_21_active;		//## ignore 
    
    
    int state_20_subState;		//## ignore 
    
    
    int state_20_active;		//## ignore 
    
    
    int state_16_subState;		//## ignore 
    
    
    int state_16_active;		//## ignore 
    
    
    int state_15_subState;		//## ignore 
    
    
    int state_15_active;		//## ignore 
    

};
//---------------------------------------------------------------------------- 
// inline operations for Initiator_and_dns
//---------------------------------------------------------------------------- 

inline bool Initiator_and_dns::rootState_IN() const {
    return true;
}

inline bool Initiator_and_dns::mainState_IN() const {
    return rootState_subState == mainState;
}

inline bool Initiator_and_dns::WaitForDNSQueries_IN() const {
    return mainState_subState == WaitForDNSQueries;
}

inline bool Initiator_and_dns::WaitForDNSQuery_IN() const {
    return WaitForDNSQueries_subState == WaitForDNSQuery;
}

inline bool Initiator_and_dns::DNSQueryReceivedServer_IN() const {
    return WaitForDNSQueries_subState == DNSQueryReceivedServer;
}

inline bool Initiator_and_dns::DNSQueryReceivedC_IN() const {
    return WaitForDNSQueries_subState == DNSQueryReceivedC;
}

inline bool Initiator_and_dns::DNSQueryReceivedBw_IN() const {
    return WaitForDNSQueries_subState == DNSQueryReceivedBw;
}

inline bool Initiator_and_dns::DNSQueryReceivedBh_IN() const {
    return WaitForDNSQueries_subState == DNSQueryReceivedBh;
}

inline bool Initiator_and_dns::DNSQueryReceivedA_IN() const {
    return WaitForDNSQueries_subState == DNSQueryReceivedA;
}

inline bool Initiator_and_dns::DNSEntrySentServer_IN() const {
    return WaitForDNSQueries_subState == DNSEntrySentServer;
}

inline bool Initiator_and_dns::DNSEntrySentC_IN() const {
    return WaitForDNSQueries_subState == DNSEntrySentC;
}

inline bool Initiator_and_dns::DNSEntrySentBw_IN() const {
    return WaitForDNSQueries_subState == DNSEntrySentBw;
}

inline bool Initiator_and_dns::DNSEntrySentBh_IN() const {
    return WaitForDNSQueries_subState == DNSEntrySentBh;
}

inline bool Initiator_and_dns::DNSEntrySentA_IN() const {
    return WaitForDNSQueries_subState == DNSEntrySentA;
}

inline bool Initiator_and_dns::Initializing_IN() const {
    return mainState_subState == Initializing;
}

inline bool Initiator_and_dns::state_61_IN() const {
    return Initializing_IN();
}

inline bool Initiator_and_dns::SentToC_IN() const {
    return state_61_subState == SentToC;
}

inline bool Initiator_and_dns::SendingToC_IN() const {
    return state_61_subState == SendingToC;
}

inline bool Initiator_and_dns::Ack_IN() const {
    return state_61_subState == Ack;
}

inline bool Initiator_and_dns::state_21_IN() const {
    return Initializing_IN();
}

inline bool Initiator_and_dns::SentToBw_IN() const {
    return state_21_subState == SentToBw;
}

inline bool Initiator_and_dns::SendingToBw_IN() const {
    return state_21_subState == SendingToBw;
}

inline bool Initiator_and_dns::state_21_Ack_IN() const {
    return state_21_subState == state_21_Ack;
}

inline bool Initiator_and_dns::state_20_IN() const {
    return Initializing_IN();
}

inline bool Initiator_and_dns::SentToBh_IN() const {
    return state_20_subState == SentToBh;
}

inline bool Initiator_and_dns::SendingToBh_IN() const {
    return state_20_subState == SendingToBh;
}

inline bool Initiator_and_dns::state_20_Ack_IN() const {
    return state_20_subState == state_20_Ack;
}

inline bool Initiator_and_dns::state_16_IN() const {
    return Initializing_IN();
}

inline bool Initiator_and_dns::SentToA_IN() const {
    return state_16_subState == SentToA;
}

inline bool Initiator_and_dns::SendingToA_IN() const {
    return state_16_subState == SendingToA;
}

inline bool Initiator_and_dns::state_16_Ack_IN() const {
    return state_16_subState == state_16_Ack;
}

inline bool Initiator_and_dns::state_15_IN() const {
    return Initializing_IN();
}

inline bool Initiator_and_dns::SentToServer_IN() const {
    return state_15_subState == SentToServer;
}

inline bool Initiator_and_dns::SendingToSever_IN() const {
    return state_15_subState == SendingToSever;
}

inline bool Initiator_and_dns::state_15_Ack_IN() const {
    return state_15_subState == state_15_Ack;
}

inline bool Initiator_and_dns::AllAckReceived_IN() const {
    return mainState_subState == AllAckReceived;
}


















#ifdef _OMINSTRUMENT
//## ignore 
class OMAnimatedInitiator_and_dns : public OMAnimatediDNSLookupInitRes {

    
    DECLARE_REACTIVE_META(Initiator_and_dns, OMAnimatedInitiator_and_dns)


////    Framework operations    ////
public :
    
    virtual void serializeAttributes(AOMSAttributes* aomsAttributes) const;
    
    virtual void serializeRelations(AOMSRelations* aomsRelations) const;
    
    //## statechart_method 
    void rootState_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void mainState_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void WaitForDNSQueries_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void WaitForDNSQuery_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void DNSQueryReceivedServer_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void DNSQueryReceivedC_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void DNSQueryReceivedBw_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void DNSQueryReceivedBh_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void DNSQueryReceivedA_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void DNSEntrySentServer_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void DNSEntrySentC_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void DNSEntrySentBw_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void DNSEntrySentBh_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void DNSEntrySentA_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void Initializing_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void state_61_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void SentToC_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void SendingToC_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void Ack_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void state_21_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void SentToBw_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void SendingToBw_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void state_21_Ack_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void state_20_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void SentToBh_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void SendingToBh_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void state_20_Ack_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void state_16_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void SentToA_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void SendingToA_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void state_16_Ack_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void state_15_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void SentToServer_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void SendingToSever_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void state_15_Ack_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method 
    void AllAckReceived_serializeStates(AOMSState* aomsState) const;


};

#endif // _OMINSTRUMENT

#endif  
/*********************************************************************
	File Path	: DefaultComponent/DefaultConfig/Initiator_and_dns.h
*********************************************************************/

