/********************************************************************
	Rhapsody	: 6.1 
	Login		: Masood Khosroshahy
	Component	: DefaultComponent 
	Configuration 	: DefaultConfig
	Model Element	: SIP_Redirect
//!	Generated Date	: Thu, 20, Apr 2006  
	File Path	: DefaultComponent/DefaultConfig/SIP_Redirect.cpp
*********************************************************************/


//#[ ignore 
#define NAMESPACE_PREFIX 


#define _OMSTATECHART_ANIMATED 
//#]

#include "SIP_Redirect.h"

//## package sip 


//#[ ignore 
#define sip_SIP_Redirect_SIP_Redirect_SERIALIZE OM_NO_OP


#define sip_SIP_Redirect_addServerToViaField_SERIALIZE aomsmethod->addAttribute("viaHeader", x2String(viaHeader));


#define sip_SIP_Redirect_calculateStringLength_SERIALIZE aomsmethod->addAttribute("string", x2String(string));


#define sip_SIP_Redirect_dom_of_sip_addr_SERIALIZE aomsmethod->addAttribute("string", x2String(string));


#define sip_SIP_Redirect_get_user_idx_SERIALIZE aomsmethod->addAttribute("string", x2String(string));


#define sip_SIP_Redirect_removeServerFromViaField_SERIALIZE aomsmethod->addAttribute("viaHead", x2String(viaHead));


#define sip_SIP_Redirect_sendACK_SERIALIZE \
    aomsmethod->addAttribute("port", x2String(port)); \
    aomsmethod->addAttribute("c", x2String(c)); \
    aomsmethod->addAttribute("viaHeader", x2String(viaHeader)); \
    aomsmethod->addAttribute("h", UNKNOWN2STRING(h)); \
    aomsmethod->addAttribute("b", UNKNOWN2STRING(b));


#define sip_SIP_Redirect_sendBYE_SERIALIZE \
    aomsmethod->addAttribute("port", x2String(port)); \
    aomsmethod->addAttribute("c", x2String(c)); \
    aomsmethod->addAttribute("viaHeader", x2String(viaHeader)); \
    aomsmethod->addAttribute("h", UNKNOWN2STRING(h)); \
    aomsmethod->addAttribute("b", UNKNOWN2STRING(b));


#define sip_SIP_Redirect_sendINVITE_SERIALIZE \
    aomsmethod->addAttribute("port", x2String(port)); \
    aomsmethod->addAttribute("c", x2String(c)); \
    aomsmethod->addAttribute("viaHeader", x2String(viaHeader)); \
    aomsmethod->addAttribute("h", UNKNOWN2STRING(h)); \
    aomsmethod->addAttribute("b", UNKNOWN2STRING(b));


#define sip_SIP_Redirect_sendMovedPerm_SERIALIZE \
    aomsmethod->addAttribute("port", x2String(port)); \
    aomsmethod->addAttribute("viaHeader", x2String(viaHeader)); \
    aomsmethod->addAttribute("h", UNKNOWN2STRING(h)); \
    aomsmethod->addAttribute("b", UNKNOWN2STRING(b));


#define sip_SIP_Redirect_sendNotFound_SERIALIZE \
    aomsmethod->addAttribute("port", x2String(port)); \
    aomsmethod->addAttribute("viaHeader", x2String(viaHeader)); \
    aomsmethod->addAttribute("h", UNKNOWN2STRING(h)); \
    aomsmethod->addAttribute("b", UNKNOWN2STRING(b));


#define sip_SIP_Redirect_sendOK_SERIALIZE \
    aomsmethod->addAttribute("port", x2String(port)); \
    aomsmethod->addAttribute("viaHeader", x2String(viaHeader)); \
    aomsmethod->addAttribute("h", UNKNOWN2STRING(h)); \
    aomsmethod->addAttribute("b", UNKNOWN2STRING(b));


#define sip_SIP_Redirect_sendRINGING_SERIALIZE \
    aomsmethod->addAttribute("port", x2String(port)); \
    aomsmethod->addAttribute("viaHeader", x2String(viaHeader)); \
    aomsmethod->addAttribute("h", UNKNOWN2STRING(h)); \
    aomsmethod->addAttribute("b", UNKNOWN2STRING(b));


#define sip_SIP_Redirect_via_head_SERIALIZE aomsmethod->addAttribute("string", x2String(string));
//#]

//----------------------------------------------------------------------------
// SIP_Redirect.cpp                                                                  
//----------------------------------------------------------------------------
DECLARE_META_PACKAGE(sip)
//## class SIP_Redirect 



SIP_Redirect::SIP_Redirect(IOxfActive* theActiveContext) : IsBYEreceived(false) ,dom_name("") ,i(0) ,idx_called(0) ,j(0) ,nb_users(0) ,stringLength(0) ,stringLength2(0) {
    NOTIFY_REACTIVE_CONSTRUCTOR(SIP_Redirect, SIP_Redirect(), 0, sip_SIP_Redirect_SIP_Redirect_SERIALIZE);
    setActiveContext(theActiveContext, false);
    initRelations();
    initStatechart();
}

SIP_Redirect::~SIP_Redirect() {
    NOTIFY_DESTRUCTOR(~SIP_Redirect, false);
    cleanUpRelations();
}

SIP_Redirect::pA_C* SIP_Redirect::getPA() const {
    return pA;
}

SIP_Redirect::pA_C* SIP_Redirect::get_pA() const {
    return pA;
}

SIP_Redirect::pA_C* SIP_Redirect::newPA() {
    pA = new SIP_Redirect::pA_C;
    return pA;
}

void SIP_Redirect::deletePA() {
    delete pA;
    pA = NULL;
}

SIP_Redirect::pBh_C* SIP_Redirect::getPBh() const {
    return pBh;
}

SIP_Redirect::pBh_C* SIP_Redirect::get_pBh() const {
    return pBh;
}

SIP_Redirect::pBh_C* SIP_Redirect::newPBh() {
    pBh = new SIP_Redirect::pBh_C;
    return pBh;
}

void SIP_Redirect::deletePBh() {
    delete pBh;
    pBh = NULL;
}

SIP_Redirect::pBw_C* SIP_Redirect::getPBw() const {
    return pBw;
}

SIP_Redirect::pBw_C* SIP_Redirect::get_pBw() const {
    return pBw;
}

SIP_Redirect::pBw_C* SIP_Redirect::newPBw() {
    pBw = new SIP_Redirect::pBw_C;
    return pBw;
}

void SIP_Redirect::deletePBw() {
    delete pBw;
    pBw = NULL;
}

SIP_Redirect::pC_C* SIP_Redirect::getPC() const {
    return pC;
}

SIP_Redirect::pC_C* SIP_Redirect::get_pC() const {
    return pC;
}

SIP_Redirect::pC_C* SIP_Redirect::newPC() {
    pC = new SIP_Redirect::pC_C;
    return pC;
}

void SIP_Redirect::deletePC() {
    delete pC;
    pC = NULL;
}

SIP_Redirect::pDNS_C* SIP_Redirect::getPDNS() const {
    return pDNS;
}

SIP_Redirect::pDNS_C* SIP_Redirect::get_pDNS() const {
    return pDNS;
}

SIP_Redirect::pDNS_C* SIP_Redirect::newPDNS() {
    pDNS = new SIP_Redirect::pDNS_C;
    return pDNS;
}

void SIP_Redirect::deletePDNS() {
    delete pDNS;
    pDNS = NULL;
}

OMString SIP_Redirect::addServerToViaField(const OMString& viaHeader) {
    NOTIFY_OPERATION(addServerToViaField, addServerToViaField(OMString), 1, sip_SIP_Redirect_addServerToViaField_SERIALIZE);
    //#[ operation addServerToViaField(OMString) 
    stringLength = calculateStringLength(viaHeader);
    
    char tmpString[50];
    
    for (i = 0; i < stringLength ; i++)
    	tmpString[i]= viaHeader[i];
    		
    tmpString[stringLength]=' ';
    	
    stringLength2 = calculateStringLength(dom_name);
    
    for (i = 0; i < stringLength2 ; i++)
    	tmpString[stringLength + i + 1]= dom_name[i];
    	
    tmpString[stringLength + stringLength2 +1]='\0';
    
    tmp_string = tmpString;
    
    return(tmp_string);    
    //#]
}

int SIP_Redirect::calculateStringLength(const OMString& string) {
    NOTIFY_OPERATION(calculateStringLength, calculateStringLength(OMString), 1, sip_SIP_Redirect_calculateStringLength_SERIALIZE);
    //#[ operation calculateStringLength(OMString) 
    
    for (i = 0 ; ; i++)
    	if (string[i]== '\0')
    		return i;
    //#]
}

OMString SIP_Redirect::dom_of_sip_addr(const OMString& string) {
    NOTIFY_OPERATION(dom_of_sip_addr, dom_of_sip_addr(OMString), 1, sip_SIP_Redirect_dom_of_sip_addr_SERIALIZE);
    //#[ operation dom_of_sip_addr(OMString) 
    
    if(stringLength == 0)
    tmp_string="";
    
    char tmpString[30];
    
    for (i = 0; i < stringLength ; i++)
    	if(string[i]=='@')
    	{
    		for(j = i+1; j < stringLength; j++)
    		tmpString[j-i-1]= string[j];
    		
    		tmpString[stringLength-i-1]='\0';
    
    		tmp_string = tmpString;
    		return(tmp_string);    
      	} 
    
    return(tmp_string); 
    //#]
}

int SIP_Redirect::get_user_idx(const OMString& string) {
    NOTIFY_OPERATION(get_user_idx, get_user_idx(OMString), 1, sip_SIP_Redirect_get_user_idx_SERIALIZE);
    //#[ operation get_user_idx(OMString) 
    if (nb_users == 0)
    	return 0;
    
    for (int i =1 ; i < 11 ; i++)
    {
    	if (string == users.user_Array[i-1])
     	 return users.user_idxArray[i-1];
    }
    
    return 0;
    //#]
}

OMString SIP_Redirect::removeServerFromViaField(const OMString& viaHead) {
    NOTIFY_OPERATION(removeServerFromViaField, removeServerFromViaField(OMString), 1, sip_SIP_Redirect_removeServerFromViaField_SERIALIZE);
    //#[ operation removeServerFromViaField(OMString) 
    stringLength = calculateStringLength(viaHead);
    
    char tmpString[50];
    
    for (i = stringLength; i > 0 ; i--)
    	if(viaHead[i]==' ')
    	{
    		for(j = 0; j < i; j++)
    		tmpString[j]= viaHead[j];
    		
    		tmpString[i]='\0';
    
    		tmp_string = tmpString;
    		return(tmp_string);    
      	} 
    
    return(viaHead); 
    //#]
}

void SIP_Redirect::sendACK(const OMString& port, const OMString& c, const OMString& viaHeader, const SIP_headerset& h, const SIP_body& b) {
    NOTIFY_OPERATION(sendACK, sendACK(OMString,OMString,OMString,SIP_headerset,SIP_body), 5, sip_SIP_Redirect_sendACK_SERIALIZE);
    //#[ operation sendACK(OMString,OMString,OMString,SIP_headerset,SIP_body) 
    
    if (port == "pA")
    	OUT_PORT(pA)->GEN(evACK(c, h, b));
    if (port == "pBh")
    	OUT_PORT(pBh)->GEN(evACK(c, h, b));
    if (port == "pBw")
    	OUT_PORT(pBw)->GEN(evACK(c, h, b));
    if (port == "pC")
    	OUT_PORT(pC)->GEN(evACK(c, h, b));
    	
    return;
    
    
    
    //#]
}

void SIP_Redirect::sendBYE(const OMString& port, const OMString& c, const OMString& viaHeader, const SIP_headerset& h, const SIP_body& b) {
    NOTIFY_OPERATION(sendBYE, sendBYE(OMString,OMString,OMString,SIP_headerset,SIP_body), 5, sip_SIP_Redirect_sendBYE_SERIALIZE);
    //#[ operation sendBYE(OMString,OMString,OMString,SIP_headerset,SIP_body) 
    
    if (port == "pA")
    	OUT_PORT(pA)->GEN(evBYE(c, h, b));
    if (port == "pBh")
    	OUT_PORT(pBh)->GEN(evBYE(c, h, b));
    if (port == "pBw")
    	OUT_PORT(pBw)->GEN(evBYE(c, h, b));
    if (port == "pC")
    	OUT_PORT(pC)->GEN(evBYE(c, h, b));
    	
    return;
    
    
    
    //#]
}

void SIP_Redirect::sendINVITE(const OMString& port, const OMString& c, const OMString& viaHeader, const SIP_headerset& h, const SIP_body& b) {
    NOTIFY_OPERATION(sendINVITE, sendINVITE(OMString,OMString,OMString,SIP_headerset,SIP_body), 5, sip_SIP_Redirect_sendINVITE_SERIALIZE);
    //#[ operation sendINVITE(OMString,OMString,OMString,SIP_headerset,SIP_body) 
    
    if (port == "pA")
    	OUT_PORT(pA)->GEN(evINVITE(c, h, b));
    if (port == "pBh")
    	OUT_PORT(pBh)->GEN(evINVITE(c, h, b));
    if (port == "pBw")
    	OUT_PORT(pBw)->GEN(evINVITE(c, h, b));
    if (port == "pC")
    	OUT_PORT(pC)->GEN(evINVITE(c, h, b));	
    return;
    
    
    
    //#]
}

void SIP_Redirect::sendMovedPerm(const OMString& port, const OMString& viaHeader, const SIP_headerset& h, const SIP_body& b) {
    NOTIFY_OPERATION(sendMovedPerm, sendMovedPerm(OMString,OMString,SIP_headerset,SIP_body), 4, sip_SIP_Redirect_sendMovedPerm_SERIALIZE);
    //#[ operation sendMovedPerm(OMString,OMString,SIP_headerset,SIP_body) 
    
    if (port == "pA")
    	OUT_PORT(pA)->GEN(ev301_moved_perm(h.Array[3][1], h, b));
    if (port == "pBh")
    	OUT_PORT(pBh)->GEN(ev301_moved_perm(h.Array[3][1], h, b));
    if (port == "pBw")
    	OUT_PORT(pBw)->GEN(ev301_moved_perm(h.Array[3][1], h, b));
    if (port == "pC")
    	OUT_PORT(pC)->GEN(ev301_moved_perm(h.Array[3][1], h, b));
    	
    return;
    
    
    
    //#]
}

void SIP_Redirect::sendNotFound(const OMString& port, const OMString& viaHeader, const SIP_headerset& h, const SIP_body& b) {
    NOTIFY_OPERATION(sendNotFound, sendNotFound(OMString,OMString,SIP_headerset,SIP_body), 4, sip_SIP_Redirect_sendNotFound_SERIALIZE);
    //#[ operation sendNotFound(OMString,OMString,SIP_headerset,SIP_body) 
    
    if (port == "pA")
    	OUT_PORT(pA)->GEN(ev404_not_found(h, b));
    if (port == "pBh")
    	OUT_PORT(pBh)->GEN(ev404_not_found(h, b));
    if (port == "pBw")
    	OUT_PORT(pBw)->GEN(ev404_not_found(h, b));
    if (port == "pC")
    	OUT_PORT(pC)->GEN(ev404_not_found(h, b));
    return;
    
    
    
    //#]
}

void SIP_Redirect::sendOK(const OMString& port, const OMString& viaHeader, const SIP_headerset& h, const SIP_body& b) {
    NOTIFY_OPERATION(sendOK, sendOK(OMString,OMString,SIP_headerset,SIP_body), 4, sip_SIP_Redirect_sendOK_SERIALIZE);
    //#[ operation sendOK(OMString,OMString,SIP_headerset,SIP_body) 
    
    if (port == "pA")
    	OUT_PORT(pA)->GEN(ev200_OK(h, b));
    if (port == "pBh")
    	OUT_PORT(pBh)->GEN(ev200_OK(h, b));
    if (port == "pBw")
    	OUT_PORT(pBw)->GEN(ev200_OK(h, b));
    if (port == "pC")
    	OUT_PORT(pC)->GEN(ev200_OK(h, b));
    	
    return;
    
    
    
    //#]
}

void SIP_Redirect::sendRINGING(const OMString& port, const OMString& viaHeader, const SIP_headerset& h, const SIP_body& b) {
    NOTIFY_OPERATION(sendRINGING, sendRINGING(OMString,OMString,SIP_headerset,SIP_body), 4, sip_SIP_Redirect_sendRINGING_SERIALIZE);
    //#[ operation sendRINGING(OMString,OMString,SIP_headerset,SIP_body) 
    
    if (port == "pA")
    	OUT_PORT(pA)->GEN(ev180_ringing(h, b));
    if (port == "pBh")
    	OUT_PORT(pBh)->GEN(ev180_ringing(h, b));
    if (port == "pBw")
    	OUT_PORT(pBw)->GEN(ev180_ringing(h, b));
    if (port == "pC")
    	OUT_PORT(pC)->GEN(ev180_ringing(h, b));
    	
    return;
    
    
    
    //#]
}

OMString SIP_Redirect::via_head(const OMString& string) {
    NOTIFY_OPERATION(via_head, via_head(OMString), 1, sip_SIP_Redirect_via_head_SERIALIZE);
    //#[ operation via_head(OMString) 
    stringLength = calculateStringLength(string);
    
    if(stringLength == 0)
    	return(string); 
    
    char tmpString[30];
    
    for (i = stringLength; i > 0 ; i--)
    	if(string[i]==' ')
    	{
    		for(j = i+1; j < stringLength; j++)
    		tmpString[j-i-1]= string[j];
    		
    		tmpString[stringLength-i-1]='\0';
    
    		tmp_string = tmpString;
    		return(tmp_string);    
      	} 
    
    return(string); 
    //#]
}

bool SIP_Redirect::getIsBYEreceived() const {
    return IsBYEreceived;
}

void SIP_Redirect::setIsBYEreceived(bool p_IsBYEreceived) {
    IsBYEreceived = p_IsBYEreceived;
}

OMString SIP_Redirect::getAddressToRegister() const {
    return addressToRegister;
}

void SIP_Redirect::setAddressToRegister(OMString p_addressToRegister) {
    addressToRegister = p_addressToRegister;
}

SIP_body SIP_Redirect::getBody() const {
    return body;
}

void SIP_Redirect::setBody(SIP_body p_body) {
    body = p_body;
}

SIP_body SIP_Redirect::getBodyReceived() const {
    return bodyReceived;
}

void SIP_Redirect::setBodyReceived(SIP_body p_bodyReceived) {
    bodyReceived = p_bodyReceived;
}

OMString SIP_Redirect::getClient() const {
    return client;
}

void SIP_Redirect::setClient(OMString p_client) {
    client = p_client;
}

OMString SIP_Redirect::getDestination() const {
    return destination;
}

void SIP_Redirect::setDestination(OMString p_destination) {
    destination = p_destination;
}

OMString SIP_Redirect::getDom_destination() const {
    return dom_destination;
}

void SIP_Redirect::setDom_destination(OMString p_dom_destination) {
    dom_destination = p_dom_destination;
}

char* SIP_Redirect::getDom_name() const {
    return dom_name;
}

void SIP_Redirect::setDom_name(char* p_dom_name) {
    dom_name = p_dom_name;
}

OMString SIP_Redirect::getDuration() const {
    return duration;
}

void SIP_Redirect::setDuration(OMString p_duration) {
    duration = p_duration;
}

SIP_headerset SIP_Redirect::getHeaders() const {
    return headers;
}

void SIP_Redirect::setHeaders(SIP_headerset p_headers) {
    headers = p_headers;
}

SIP_headerset SIP_Redirect::getHeadersReceived() const {
    return headersReceived;
}

void SIP_Redirect::setHeadersReceived(SIP_headerset p_headersReceived) {
    headersReceived = p_headersReceived;
}

int SIP_Redirect::getI() const {
    return i;
}

void SIP_Redirect::setI(int p_i) {
    i = p_i;
}

int SIP_Redirect::getIdx_called() const {
    return idx_called;
}

void SIP_Redirect::setIdx_called(int p_idx_called) {
    idx_called = p_idx_called;
}

int SIP_Redirect::getJ() const {
    return j;
}

void SIP_Redirect::setJ(int p_j) {
    j = p_j;
}

int SIP_Redirect::getNb_users() const {
    return nb_users;
}

void SIP_Redirect::setNb_users(int p_nb_users) {
    nb_users = p_nb_users;
}

char* SIP_Redirect::getPort() const {
    return port;
}

void SIP_Redirect::setPort(char* p_port) {
    port = p_port;
}

char* SIP_Redirect::getPort_client() const {
    return port_client;
}

void SIP_Redirect::setPort_client(char* p_port_client) {
    port_client = p_port_client;
}

char* SIP_Redirect::getPort_correspondant() const {
    return port_correspondant;
}

void SIP_Redirect::setPort_correspondant(char* p_port_correspondant) {
    port_correspondant = p_port_correspondant;
}

OMString SIP_Redirect::getRedirection() const {
    return redirection;
}

void SIP_Redirect::setRedirection(OMString p_redirection) {
    redirection = p_redirection;
}

int SIP_Redirect::getStringLength() const {
    return stringLength;
}

void SIP_Redirect::setStringLength(int p_stringLength) {
    stringLength = p_stringLength;
}

int SIP_Redirect::getStringLength2() const {
    return stringLength2;
}

void SIP_Redirect::setStringLength2(int p_stringLength2) {
    stringLength2 = p_stringLength2;
}

OMString SIP_Redirect::getTmp_string() const {
    return tmp_string;
}

void SIP_Redirect::setTmp_string(OMString p_tmp_string) {
    tmp_string = p_tmp_string;
}

OMString SIP_Redirect::getTo_adr() const {
    return to_adr;
}

void SIP_Redirect::setTo_adr(OMString p_to_adr) {
    to_adr = p_to_adr;
}

int SIP_Redirect::getU() const {
    return u;
}

void SIP_Redirect::setU(int p_u) {
    u = p_u;
}

user_table_type SIP_Redirect::getUsers() const {
    return users;
}

void SIP_Redirect::setUsers(user_table_type p_users) {
    users = p_users;
}

OMString SIP_Redirect::getVia_adr() const {
    return via_adr;
}

void SIP_Redirect::setVia_adr(OMString p_via_adr) {
    via_adr = p_via_adr;
}

OMString SIP_Redirect::getVia_extract() const {
    return via_extract;
}

void SIP_Redirect::setVia_extract(OMString p_via_extract) {
    via_extract = p_via_extract;
}

void SIP_Redirect::rootState_entDef() {
    {
        NOTIFY_STATE_ENTERED("ROOT");
        mainState_entDef();
    }
}

IOxfReactive::TakeEventStatus SIP_Redirect::rootState_processEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    switch (rootState_active) {
        case Initial:
        {
            res = Initial_handleEvent();
            break;
        }
        case addressReceived:
        {
            res = addressReceived_handleEvent();
            break;
        }
        case AckSent:
        {
            res = AckSent_handleEvent();
            break;
        }
        case state_19:
        {
            res = state_19_handleEvent();
            break;
        }
        case WaitingForRequests:
        {
            res = WaitingForRequests_processEvent();
            break;
        }
        default:
            break;
    }
    return res;
}

IOxfReactive::TakeEventStatus SIP_Redirect::WaitingForRequests_processEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(proxy_server_processEvent() > 0)
        {
            res = eventConsumed;
            if(!IS_IN(WaitingForRequests))
                {
                    return res;
                }
        }
    if(registrar_redirect_processEvent() > 0)
        {
            res = eventConsumed;
            if(!IS_IN(WaitingForRequests))
                {
                    return res;
                }
        }
    
    return res;
}

IOxfReactive::TakeEventStatus SIP_Redirect::registrar_redirect_processEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    switch (registrar_redirect_active) {
        case WaitingForREGISTER:
        {
            if(IS_EVENT_TYPE_OF(evREGISTER_sip_id))
                {
                    OMSETPARAMS(evREGISTER);
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.registrar_redirect.1");
                    NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.registrar_redirect.ROOT.registrar_redirect.WaitingForREGISTER");
                    //#[ transition ROOT.mainState.WaitingForRequests.registrar_redirect.1 
                    
                    headersReceived = params->sip_headerset;
                    
                    headers = headersReceived;
                    
                    if (params->sip_headerset.Array[2][0] == "Via")
                      via_adr = params->sip_headerset.Array[2][1];
                    
                    if (params->sip_headerset.Array[1][0] == "To")
                      addressToRegister = params->sip_headerset.Array[1][1];
                    
                    if (params->sip_headerset.Array[3][0] == "Contact")
                      redirection = params->sip_headerset.Array[3][1];
                    
                    if (params->sip_headerset.Array[4][0] == "Expires")
                      duration = params->sip_headerset.Array[4][1];
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.WaitingForRequests.registrar_redirect.ROOT.registrar_redirect.evRegisterReceived");
                    pushNullTransition();
                    registrar_redirect_subState = evRegisterReceived;
                    registrar_redirect_active = evRegisterReceived;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.registrar_redirect.1");
                    res = eventConsumed;
                }
            
            
            break;
        }
        case evRegisterReceived:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.registrar_redirect.2");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.registrar_redirect.ROOT.registrar_redirect.evRegisterReceived");
                    //#[ transition ROOT.mainState.WaitingForRequests.registrar_redirect.2 
                    via_extract = via_head(via_adr);
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.WaitingForRequests.registrar_redirect.ROOT.registrar_redirect.Via_head_extracted");
                    pushNullTransition();
                    registrar_redirect_subState = registrar_redirect_Via_head_extracted;
                    registrar_redirect_active = registrar_redirect_Via_head_extracted;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.registrar_redirect.2");
                    res = eventConsumed;
                }
            
            
            break;
        }
        case registrar_redirect_Via_head_extracted:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.registrar_redirect.3");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.registrar_redirect.ROOT.registrar_redirect.Via_head_extracted");
                    //#[ transition ROOT.mainState.WaitingForRequests.registrar_redirect.3 
                    OUT_PORT(pDNS)->GEN(evDNSLookup(via_extract));
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.WaitingForRequests.registrar_redirect.ROOT.registrar_redirect.DNSLookupToSend");
                    registrar_redirect_subState = registrar_redirect_DNSLookupToSend;
                    registrar_redirect_active = registrar_redirect_DNSLookupToSend;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.registrar_redirect.3");
                    res = eventConsumed;
                }
            
            
            break;
        }
        case registrar_redirect_DNSLookupToSend:
        {
            if(IS_EVENT_TYPE_OF(evDNSLookupRes_sip_id))
                {
                    OMSETPARAMS(evDNSLookupRes);
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.registrar_redirect.4");
                    NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.registrar_redirect.ROOT.registrar_redirect.DNSLookupToSend");
                    //#[ transition ROOT.mainState.WaitingForRequests.registrar_redirect.4 
                    
                    port_client = params->portName;
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.WaitingForRequests.registrar_redirect.ROOT.registrar_redirect.DNSResponseReceived");
                    pushNullTransition();
                    registrar_redirect_subState = registrar_redirect_DNSResponseReceived;
                    registrar_redirect_active = registrar_redirect_DNSResponseReceived;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.registrar_redirect.4");
                    res = eventConsumed;
                }
            
            
            break;
        }
        case registrar_redirect_DNSResponseReceived:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.registrar_redirect.5");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.registrar_redirect.ROOT.registrar_redirect.DNSResponseReceived");
                    NOTIFY_STATE_ENTERED("ROOT.mainState.WaitingForRequests.registrar_redirect.ROOT.registrar_redirect.CheckingTheUserTable");
                    pushNullTransition();
                    registrar_redirect_subState = CheckingTheUserTable;
                    registrar_redirect_active = CheckingTheUserTable;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.registrar_redirect.5");
                    res = eventConsumed;
                }
            
            
            break;
        }
        case CheckingTheUserTable:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.registrar_redirect.7");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.registrar_redirect.ROOT.registrar_redirect.CheckingTheUserTable");
                    //#[ transition ROOT.mainState.WaitingForRequests.registrar_redirect.7 
                    u = get_user_idx(addressToRegister);
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.WaitingForRequests.registrar_redirect.ROOT.registrar_redirect.TableSearched");
                    pushNullTransition();
                    registrar_redirect_subState = TableSearched;
                    registrar_redirect_active = TableSearched;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.registrar_redirect.7");
                    res = eventConsumed;
                }
            
            
            break;
        }
        case TableSearched:
        {
            res = TableSearched_handleEvent();
            break;
        }
        case UserAdded:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.registrar_redirect.13");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.registrar_redirect.ROOT.registrar_redirect.UserAdded");
                    NOTIFY_STATE_ENTERED("ROOT.mainState.WaitingForRequests.registrar_redirect.ROOT.registrar_redirect.SendingOK");
                    pushNullTransition();
                    registrar_redirect_subState = SendingOK;
                    registrar_redirect_active = SendingOK;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.registrar_redirect.13");
                    res = eventConsumed;
                }
            
            
            break;
        }
        case Unregister:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.registrar_redirect.15");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.registrar_redirect.ROOT.registrar_redirect.Unregister");
                    NOTIFY_STATE_ENTERED("ROOT.mainState.WaitingForRequests.registrar_redirect.ROOT.registrar_redirect.SendingOK");
                    pushNullTransition();
                    registrar_redirect_subState = SendingOK;
                    registrar_redirect_active = SendingOK;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.registrar_redirect.15");
                    res = eventConsumed;
                }
            
            
            break;
        }
        case UpdatingRecord:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.registrar_redirect.14");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.registrar_redirect.ROOT.registrar_redirect.UpdatingRecord");
                    NOTIFY_STATE_ENTERED("ROOT.mainState.WaitingForRequests.registrar_redirect.ROOT.registrar_redirect.SendingOK");
                    pushNullTransition();
                    registrar_redirect_subState = SendingOK;
                    registrar_redirect_active = SendingOK;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.registrar_redirect.14");
                    res = eventConsumed;
                }
            
            
            break;
        }
        case SendingOK:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.registrar_redirect.16");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.registrar_redirect.ROOT.registrar_redirect.SendingOK");
                    //#[ transition ROOT.mainState.WaitingForRequests.registrar_redirect.16 
                    sendOK(port_client, headers.Array[2][1], headers, body);
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.WaitingForRequests.registrar_redirect.ROOT.registrar_redirect.OKsent");
                    pushNullTransition();
                    registrar_redirect_subState = OKsent;
                    registrar_redirect_active = OKsent;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.registrar_redirect.16");
                    res = eventConsumed;
                }
            
            
            break;
        }
        case OKsent:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.registrar_redirect.17");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.registrar_redirect.ROOT.registrar_redirect.OKsent");
                    NOTIFY_STATE_ENTERED("ROOT.mainState.WaitingForRequests.registrar_redirect.ROOT.registrar_redirect.WaitingForREGISTER");
                    registrar_redirect_subState = WaitingForREGISTER;
                    registrar_redirect_active = WaitingForREGISTER;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.registrar_redirect.17");
                    res = eventConsumed;
                }
            
            
            break;
        }
        default:
            break;
    }
    return res;
}

IOxfReactive::TakeEventStatus SIP_Redirect::proxy_server_processEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    switch (proxy_server_active) {
        case WaitingForRequestResponse:
        {
            res = WaitingForRequestResponse_handleEvent();
            break;
        }
        case OKreceived:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.proxy_server.4");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.OKreceived");
                    //#[ transition ROOT.mainState.WaitingForRequests.proxy_server.4 
                    headers.Array[2][1] = removeServerFromViaField(headers.Array[2][1]);
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.ViaHeadRestored");
                    pushNullTransition();
                    proxy_server_subState = ViaHeadRestored;
                    proxy_server_active = ViaHeadRestored;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.proxy_server.4");
                    res = eventConsumed;
                }
            
            
            break;
        }
        case ViaHeadRestored:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.proxy_server.5");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.ViaHeadRestored");
                    //#[ transition ROOT.mainState.WaitingForRequests.proxy_server.5 
                    if (IsBYEreceived == false)
                      port = port_client;
                    if (IsBYEreceived == true)
                      port = port_correspondant;
                    
                    sendOK(port, headers.Array[2][1], headers, body);
                    IsBYEreceived = false;
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.reSendingTheOK");
                    pushNullTransition();
                    proxy_server_subState = reSendingTheOK;
                    proxy_server_active = reSendingTheOK;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.proxy_server.5");
                    res = eventConsumed;
                }
            
            
            break;
        }
        case reSendingTheOK:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.proxy_server.6");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.reSendingTheOK");
                    NOTIFY_STATE_ENTERED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.WaitingForRequestResponse");
                    proxy_server_subState = WaitingForRequestResponse;
                    proxy_server_active = WaitingForRequestResponse;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.proxy_server.6");
                    res = eventConsumed;
                }
            
            
            break;
        }
        case RingingReceived:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.proxy_server.17");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.RingingReceived");
                    //#[ transition ROOT.mainState.WaitingForRequests.proxy_server.17 
                    headers.Array[2][1] = removeServerFromViaField(headers.Array[2][1]);
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.ViaHead_restored");
                    pushNullTransition();
                    proxy_server_subState = ViaHead_restored;
                    proxy_server_active = ViaHead_restored;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.proxy_server.17");
                    res = eventConsumed;
                }
            
            
            break;
        }
        case ViaHead_restored:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.proxy_server.8");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.ViaHead_restored");
                    //#[ transition ROOT.mainState.WaitingForRequests.proxy_server.8 
                    sendRINGING(port_client, headers.Array[2][1], headers, body);
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.reSendingTheRinging");
                    pushNullTransition();
                    proxy_server_subState = reSendingTheRinging;
                    proxy_server_active = reSendingTheRinging;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.proxy_server.8");
                    res = eventConsumed;
                }
            
            
            break;
        }
        case reSendingTheRinging:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.proxy_server.18");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.reSendingTheRinging");
                    NOTIFY_STATE_ENTERED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.WaitingForRequestResponse");
                    proxy_server_subState = WaitingForRequestResponse;
                    proxy_server_active = WaitingForRequestResponse;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.proxy_server.18");
                    res = eventConsumed;
                }
            
            
            break;
        }
        case ACKreceived:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.proxy_server.10");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.ACKreceived");
                    //#[ transition ROOT.mainState.WaitingForRequests.proxy_server.10 
                    headers.Array[2][1] = addServerToViaField(headers.Array[2][1]);
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.ServerAddedToViaField");
                    pushNullTransition();
                    proxy_server_subState = ServerAddedToViaField;
                    proxy_server_active = ServerAddedToViaField;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.proxy_server.10");
                    res = eventConsumed;
                }
            
            
            break;
        }
        case ServerAddedToViaField:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.proxy_server.11");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.ServerAddedToViaField");
                    //#[ transition ROOT.mainState.WaitingForRequests.proxy_server.11 
                    sendACK(port_correspondant, destination, headers.Array[2][1], headers, body);
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.reSendingTheACK");
                    pushNullTransition();
                    proxy_server_subState = reSendingTheACK;
                    proxy_server_active = reSendingTheACK;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.proxy_server.11");
                    res = eventConsumed;
                }
            
            
            break;
        }
        case reSendingTheACK:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.proxy_server.12");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.reSendingTheACK");
                    NOTIFY_STATE_ENTERED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.WaitingForRequestResponse");
                    proxy_server_subState = WaitingForRequestResponse;
                    proxy_server_active = WaitingForRequestResponse;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.proxy_server.12");
                    res = eventConsumed;
                }
            
            
            break;
        }
        case BYEreceived:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.proxy_server.14");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.BYEreceived");
                    //#[ transition ROOT.mainState.WaitingForRequests.proxy_server.14 
                    headers.Array[2][1] = addServerToViaField(headers.Array[2][1]);
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.ServerAddedTo_ViaField");
                    pushNullTransition();
                    proxy_server_subState = ServerAddedTo_ViaField;
                    proxy_server_active = ServerAddedTo_ViaField;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.proxy_server.14");
                    res = eventConsumed;
                }
            
            
            break;
        }
        case ServerAddedTo_ViaField:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.proxy_server.15");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.ServerAddedTo_ViaField");
                    //#[ transition ROOT.mainState.WaitingForRequests.proxy_server.15 
                    sendBYE(port_client, client, headers.Array[2][1], headers, body);
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.reSendingTheBYE");
                    pushNullTransition();
                    proxy_server_subState = reSendingTheBYE;
                    proxy_server_active = reSendingTheBYE;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.proxy_server.15");
                    res = eventConsumed;
                }
            
            
            break;
        }
        case reSendingTheBYE:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.proxy_server.16");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.reSendingTheBYE");
                    NOTIFY_STATE_ENTERED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.WaitingForRequestResponse");
                    proxy_server_subState = WaitingForRequestResponse;
                    proxy_server_active = WaitingForRequestResponse;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.proxy_server.16");
                    res = eventConsumed;
                }
            
            
            break;
        }
        case DNSResponseReceived:
        {
            res = DNSResponseReceived_handleEvent();
            break;
        }
        case INVITEReceived:
        {
            res = INVITEReceived_handleEvent();
            break;
        }
        case DNSLookupToSend:
        {
            res = DNSLookupToSend_handleEvent();
            break;
        }
        case Via_head_extracted:
        {
            res = Via_head_extracted_handleEvent();
            break;
        }
        case UserNotRegistered_SendingNotFound:
        {
            res = UserNotRegistered_SendingNotFound_handleEvent();
            break;
        }
        case UserRegistered_ContactingTheUser:
        {
            res = UserRegistered_ContactingTheUser_handleEvent();
            break;
        }
        case UserTableChecked:
        {
            res = UserTableChecked_handleEvent();
            break;
        }
        case CheckingTheTable:
        {
            res = CheckingTheTable_handleEvent();
            break;
        }
        case NotFoundSent:
        {
            res = NotFoundSent_handleEvent();
            break;
        }
        case DNSLookupTheContactFieldToResend:
        {
            res = DNSLookupTheContactFieldToResend_handleEvent();
            break;
        }
        case DNSResponse_Received:
        {
            res = DNSResponse_Received_handleEvent();
            break;
        }
        case reSendingTheINVITE:
        {
            res = reSendingTheINVITE_handleEvent();
            break;
        }
        case state_81:
        {
            res = INVITE_Received_handleEvent();
            break;
        }
        case state_82:
        {
            res = INVITE_Received_handleEvent();
            break;
        }
        default:
            break;
    }
    return res;
}

void SIP_Redirect::initRelations() {
    pA = newPA();
    pBh = newPBh();
    pBw = newPBw();
    pC = newPC();
    pDNS = newPDNS();
    if(getPA())
       getPA()->connectSIP_Redirect(this);
    if(getPBh())
       getPBh()->connectSIP_Redirect(this);
    if(getPBw())
       getPBw()->connectSIP_Redirect(this);
    if(getPC())
       getPC()->connectSIP_Redirect(this);
    if(getPDNS())
       getPDNS()->connectSIP_Redirect(this);
}

void SIP_Redirect::initStatechart() {
    rootState_subState = OMNonState;
    rootState_active = OMNonState;
    mainState_subState = OMNonState;
    registrar_redirect_subState = OMNonState;
    registrar_redirect_active = OMNonState;
    proxy_server_subState = OMNonState;
    proxy_server_active = OMNonState;
    INVITE_Received_subState = OMNonState;
    InitializingState_subState = OMNonState;
}

void SIP_Redirect::cleanUpRelations() {
    {
        deletePDNS();
    }
    {
        deletePC();
    }
    {
        deletePBw();
    }
    {
        deletePBh();
    }
    {
        deletePA();
    }
}

bool SIP_Redirect::startBehavior() {
    bool done = false;
    done = OMReactive::startBehavior();
    return done;
}

IOxfReactive::TakeEventStatus SIP_Redirect::DNSLookupTheContactFieldToResend_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(evDNSLookupRes_sip_id))
        {
            OMSETPARAMS(evDNSLookupRes);
            NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.16");
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.ROOT.INVITE_Received.DNSLookupTheContactFieldToResend");
            //#[ transition ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.16 
            
            port_correspondant = params->portName;
            //#]
            NOTIFY_STATE_ENTERED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.ROOT.INVITE_Received.DNSResponse_Received");
            pushNullTransition();
            INVITE_Received_subState = DNSResponse_Received;
            proxy_server_active = DNSResponse_Received;
            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.16");
            res = eventConsumed;
        }
    
    if(res == eventNotConsumed)
        {
            res = INVITE_Received_handleEvent();
        }
    return res;
}

IOxfReactive::TakeEventStatus SIP_Redirect::DNSResponseReceived_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(OMNullEventId))
        {
            NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.3");
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.ROOT.INVITE_Received.DNSResponseReceived");
            NOTIFY_STATE_ENTERED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.ROOT.INVITE_Received.CheckingTheTable");
            pushNullTransition();
            INVITE_Received_subState = CheckingTheTable;
            proxy_server_active = CheckingTheTable;
            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.3");
            res = eventConsumed;
        }
    
    if(res == eventNotConsumed)
        {
            res = INVITE_Received_handleEvent();
        }
    return res;
}

void SIP_Redirect::mainState_entDef() {
    NOTIFY_STATE_ENTERED("ROOT.mainState");
    rootState_subState = mainState;
    NOTIFY_TRANSITION_STARTED("5");
    InitializingState_entDef();
    NOTIFY_TRANSITION_TERMINATED("5");
}

IOxfReactive::TakeEventStatus SIP_Redirect::CheckingTheTable_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(OMNullEventId))
        {
            NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.10");
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.ROOT.INVITE_Received.CheckingTheTable");
            //#[ transition ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.10 
            idx_called = get_user_idx(to_adr);
            //#]
            NOTIFY_STATE_ENTERED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.ROOT.INVITE_Received.UserTableChecked");
            pushNullTransition();
            INVITE_Received_subState = UserTableChecked;
            proxy_server_active = UserTableChecked;
            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.10");
            res = eventConsumed;
        }
    
    if(res == eventNotConsumed)
        {
            res = INVITE_Received_handleEvent();
        }
    return res;
}

IOxfReactive::TakeEventStatus SIP_Redirect::TableSearched_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(OMNullEventId))
        {
            //## transition ROOT.mainState.WaitingForRequests.registrar_redirect.9 
            if(u == 0)
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.registrar_redirect.8");
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.registrar_redirect.9");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.registrar_redirect.ROOT.registrar_redirect.TableSearched");
                    //#[ transition ROOT.mainState.WaitingForRequests.registrar_redirect.9 
                    
                    nb_users++;
                    u = nb_users;
                    
                    users.user_idxArray[u-1]= u;
                    users.user_Array[u-1]= addressToRegister;
                    users.redirection_Array[u-1]= redirection;
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.WaitingForRequests.registrar_redirect.ROOT.registrar_redirect.UserAdded");
                    pushNullTransition();
                    registrar_redirect_subState = UserAdded;
                    registrar_redirect_active = UserAdded;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.registrar_redirect.9");
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.registrar_redirect.8");
                    res = eventConsumed;
                }
            else
                {
                    //## transition ROOT.mainState.WaitingForRequests.registrar_redirect.11 
                    if(duration == "0")
                        {
                            NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.registrar_redirect.8");
                            NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.registrar_redirect.10");
                            NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.registrar_redirect.11");
                            popNullTransition();
                            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.registrar_redirect.ROOT.registrar_redirect.TableSearched");
                            //#[ transition ROOT.mainState.WaitingForRequests.registrar_redirect.11 
                            
                            users.redirection_Array[u-1]= "";
                            //#]
                            NOTIFY_STATE_ENTERED("ROOT.mainState.WaitingForRequests.registrar_redirect.ROOT.registrar_redirect.Unregister");
                            pushNullTransition();
                            registrar_redirect_subState = Unregister;
                            registrar_redirect_active = Unregister;
                            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.registrar_redirect.11");
                            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.registrar_redirect.10");
                            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.registrar_redirect.8");
                            res = eventConsumed;
                        }
                    else
                        {
                            NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.registrar_redirect.8");
                            NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.registrar_redirect.10");
                            NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.registrar_redirect.12");
                            popNullTransition();
                            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.registrar_redirect.ROOT.registrar_redirect.TableSearched");
                            //#[ transition ROOT.mainState.WaitingForRequests.registrar_redirect.12 
                            
                            users.redirection_Array[u-1]= redirection;
                            //#]
                            NOTIFY_STATE_ENTERED("ROOT.mainState.WaitingForRequests.registrar_redirect.ROOT.registrar_redirect.UpdatingRecord");
                            pushNullTransition();
                            registrar_redirect_subState = UpdatingRecord;
                            registrar_redirect_active = UpdatingRecord;
                            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.registrar_redirect.12");
                            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.registrar_redirect.10");
                            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.registrar_redirect.8");
                            res = eventConsumed;
                        }
                }
        }
    
    
    return res;
}

IOxfReactive::TakeEventStatus SIP_Redirect::INVITE_Received_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(OMNullEventId))
        {
            //## transition ROOT.mainState.WaitingForRequests.proxy_server.19 
            if(IS_COMPLETED(INVITE_Received))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.proxy_server.19");
                    INVITE_Received_exit();
                    NOTIFY_STATE_ENTERED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.WaitingForRequestResponse");
                    proxy_server_subState = WaitingForRequestResponse;
                    proxy_server_active = WaitingForRequestResponse;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.proxy_server.19");
                    res = eventConsumed;
                }
        }
    
    
    return res;
}

void SIP_Redirect::registrar_redirect_exit() {
    switch (registrar_redirect_subState) {
        case WaitingForREGISTER:
        {
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.registrar_redirect.ROOT.registrar_redirect.WaitingForREGISTER");
            break;
        }
        case evRegisterReceived:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.registrar_redirect.ROOT.registrar_redirect.evRegisterReceived");
            break;
        }
        case registrar_redirect_Via_head_extracted:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.registrar_redirect.ROOT.registrar_redirect.Via_head_extracted");
            break;
        }
        case registrar_redirect_DNSLookupToSend:
        {
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.registrar_redirect.ROOT.registrar_redirect.DNSLookupToSend");
            break;
        }
        case registrar_redirect_DNSResponseReceived:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.registrar_redirect.ROOT.registrar_redirect.DNSResponseReceived");
            break;
        }
        case CheckingTheUserTable:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.registrar_redirect.ROOT.registrar_redirect.CheckingTheUserTable");
            break;
        }
        case TableSearched:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.registrar_redirect.ROOT.registrar_redirect.TableSearched");
            break;
        }
        case UserAdded:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.registrar_redirect.ROOT.registrar_redirect.UserAdded");
            break;
        }
        case Unregister:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.registrar_redirect.ROOT.registrar_redirect.Unregister");
            break;
        }
        case UpdatingRecord:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.registrar_redirect.ROOT.registrar_redirect.UpdatingRecord");
            break;
        }
        case SendingOK:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.registrar_redirect.ROOT.registrar_redirect.SendingOK");
            break;
        }
        case OKsent:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.registrar_redirect.ROOT.registrar_redirect.OKsent");
            break;
        }
        default:
            break;
    }
    registrar_redirect_subState = OMNonState;
    NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.registrar_redirect");
}

IOxfReactive::TakeEventStatus SIP_Redirect::DNSResponse_Received_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(OMNullEventId))
        {
            NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.15");
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.ROOT.INVITE_Received.DNSResponse_Received");
            //#[ transition ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.15 
            sendINVITE(port_correspondant, destination, headers.Array[2][1], headers, body);
            //#]
            NOTIFY_STATE_ENTERED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.ROOT.INVITE_Received.reSendingTheINVITE");
            pushNullTransition();
            INVITE_Received_subState = reSendingTheINVITE;
            proxy_server_active = reSendingTheINVITE;
            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.15");
            res = eventConsumed;
        }
    
    if(res == eventNotConsumed)
        {
            res = INVITE_Received_handleEvent();
        }
    return res;
}

IOxfReactive::TakeEventStatus SIP_Redirect::NotFoundSent_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(OMNullEventId))
        {
            NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.5");
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.ROOT.INVITE_Received.NotFoundSent");
            NOTIFY_STATE_ENTERED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.ROOT.INVITE_Received.state_81");
            INVITE_Received_subState = state_81;
            proxy_server_active = state_81;
            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.5");
            res = eventConsumed;
        }
    
    if(res == eventNotConsumed)
        {
            res = INVITE_Received_handleEvent();
        }
    return res;
}

IOxfReactive::TakeEventStatus SIP_Redirect::reSendingTheINVITE_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(OMNullEventId))
        {
            NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.14");
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.ROOT.INVITE_Received.reSendingTheINVITE");
            NOTIFY_STATE_ENTERED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.ROOT.INVITE_Received.state_82");
            INVITE_Received_subState = state_82;
            proxy_server_active = state_82;
            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.14");
            res = eventConsumed;
        }
    
    if(res == eventNotConsumed)
        {
            res = INVITE_Received_handleEvent();
        }
    return res;
}

void SIP_Redirect::INVITE_Received_exit() {
    popNullTransition();
    switch (INVITE_Received_subState) {
        case DNSResponseReceived:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.ROOT.INVITE_Received.DNSResponseReceived");
            break;
        }
        case INVITEReceived:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.ROOT.INVITE_Received.INVITEReceived");
            break;
        }
        case DNSLookupToSend:
        {
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.ROOT.INVITE_Received.DNSLookupToSend");
            break;
        }
        case Via_head_extracted:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.ROOT.INVITE_Received.Via_head_extracted");
            break;
        }
        case UserNotRegistered_SendingNotFound:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.ROOT.INVITE_Received.UserNotRegistered_SendingNotFound");
            break;
        }
        case UserRegistered_ContactingTheUser:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.ROOT.INVITE_Received.UserRegistered_ContactingTheUser");
            break;
        }
        case UserTableChecked:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.ROOT.INVITE_Received.UserTableChecked");
            break;
        }
        case CheckingTheTable:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.ROOT.INVITE_Received.CheckingTheTable");
            break;
        }
        case NotFoundSent:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.ROOT.INVITE_Received.NotFoundSent");
            break;
        }
        case DNSLookupTheContactFieldToResend:
        {
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.ROOT.INVITE_Received.DNSLookupTheContactFieldToResend");
            break;
        }
        case DNSResponse_Received:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.ROOT.INVITE_Received.DNSResponse_Received");
            break;
        }
        case reSendingTheINVITE:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.ROOT.INVITE_Received.reSendingTheINVITE");
            break;
        }
        case state_81:
        {
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.ROOT.INVITE_Received.state_81");
            break;
        }
        case state_82:
        {
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.ROOT.INVITE_Received.state_82");
            break;
        }
        default:
            break;
    }
    INVITE_Received_subState = OMNonState;
    NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received");
}

void SIP_Redirect::proxy_server_exit() {
    switch (proxy_server_subState) {
        case WaitingForRequestResponse:
        {
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.WaitingForRequestResponse");
            break;
        }
        case OKreceived:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.OKreceived");
            break;
        }
        case ViaHeadRestored:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.ViaHeadRestored");
            break;
        }
        case reSendingTheOK:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.reSendingTheOK");
            break;
        }
        case RingingReceived:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.RingingReceived");
            break;
        }
        case ViaHead_restored:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.ViaHead_restored");
            break;
        }
        case reSendingTheRinging:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.reSendingTheRinging");
            break;
        }
        case ACKreceived:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.ACKreceived");
            break;
        }
        case ServerAddedToViaField:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.ServerAddedToViaField");
            break;
        }
        case reSendingTheACK:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.reSendingTheACK");
            break;
        }
        case BYEreceived:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.BYEreceived");
            break;
        }
        case ServerAddedTo_ViaField:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.ServerAddedTo_ViaField");
            break;
        }
        case reSendingTheBYE:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.reSendingTheBYE");
            break;
        }
        case INVITE_Received:
        {
            INVITE_Received_exit();
            break;
        }
        default:
            break;
    }
    proxy_server_subState = OMNonState;
    NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server");
}

IOxfReactive::TakeEventStatus SIP_Redirect::DNSLookupToSend_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(evDNSLookupRes_sip_id))
        {
            OMSETPARAMS(evDNSLookupRes);
            NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.2");
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.ROOT.INVITE_Received.DNSLookupToSend");
            //#[ transition ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.2 
            
            port_client = params->portName;
            //#]
            NOTIFY_STATE_ENTERED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.ROOT.INVITE_Received.DNSResponseReceived");
            pushNullTransition();
            INVITE_Received_subState = DNSResponseReceived;
            proxy_server_active = DNSResponseReceived;
            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.2");
            res = eventConsumed;
        }
    
    if(res == eventNotConsumed)
        {
            res = INVITE_Received_handleEvent();
        }
    return res;
}

IOxfReactive::TakeEventStatus SIP_Redirect::InitializingState_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(OMNullEventId))
        {
            //## transition 4 
            if(IS_COMPLETED(InitializingState))
                {
                    NOTIFY_TRANSITION_STARTED("4");
                    InitializingState_exit();
                    WaitingForRequests_entDef();
                    NOTIFY_TRANSITION_TERMINATED("4");
                    res = eventConsumed;
                }
        }
    
    
    return res;
}

IOxfReactive::TakeEventStatus SIP_Redirect::Initial_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(evInitialization_sip_id))
        {
            OMSETPARAMS(evInitialization);
            //## transition 1 
            if(IS_PORT(pDNS))
                {
                    NOTIFY_TRANSITION_STARTED("1");
                    NOTIFY_STATE_EXITED("ROOT.mainState.InitializingState.Initial");
                    //#[ transition 1 
                    
                    dom_name = params->dom_name;
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.InitializingState.addressReceived");
                    pushNullTransition();
                    InitializingState_subState = addressReceived;
                    rootState_active = addressReceived;
                    NOTIFY_TRANSITION_TERMINATED("1");
                    res = eventConsumed;
                }
        }
    
    if(res == eventNotConsumed)
        {
            res = InitializingState_handleEvent();
        }
    return res;
}

IOxfReactive::TakeEventStatus SIP_Redirect::UserTableChecked_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(OMNullEventId))
        {
            //## transition ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.13 
            if(idx_called == 0)
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.11");
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.13");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.ROOT.INVITE_Received.UserTableChecked");
                    NOTIFY_STATE_ENTERED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.ROOT.INVITE_Received.UserNotRegistered_SendingNotFound");
                    pushNullTransition();
                    INVITE_Received_subState = UserNotRegistered_SendingNotFound;
                    proxy_server_active = UserNotRegistered_SendingNotFound;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.13");
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.11");
                    res = eventConsumed;
                }
            else
                {
                    //## transition ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.6 
                    if(users.redirection_Array[idx_called - 1] == "")
                        {
                            NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.11");
                            NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.12");
                            NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.6");
                            popNullTransition();
                            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.ROOT.INVITE_Received.UserTableChecked");
                            NOTIFY_STATE_ENTERED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.ROOT.INVITE_Received.UserNotRegistered_SendingNotFound");
                            pushNullTransition();
                            INVITE_Received_subState = UserNotRegistered_SendingNotFound;
                            proxy_server_active = UserNotRegistered_SendingNotFound;
                            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.6");
                            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.12");
                            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.11");
                            res = eventConsumed;
                        }
                    else
                        {
                            NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.11");
                            NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.12");
                            NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.8");
                            popNullTransition();
                            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.ROOT.INVITE_Received.UserTableChecked");
                            //#[ transition ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.8 
                            
                            /* Setting the "destination" with the value of "Contact" field */
                            destination = users.redirection_Array[idx_called - 1];
                            headers.Array[2][1] = addServerToViaField(headers.Array[2][1]);
                            
                            stringLength = calculateStringLength(destination);
                            dom_destination = dom_of_sip_addr(destination);
                            //#]
                            NOTIFY_STATE_ENTERED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.ROOT.INVITE_Received.UserRegistered_ContactingTheUser");
                            pushNullTransition();
                            INVITE_Received_subState = UserRegistered_ContactingTheUser;
                            proxy_server_active = UserRegistered_ContactingTheUser;
                            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.8");
                            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.12");
                            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.11");
                            res = eventConsumed;
                        }
                }
        }
    
    if(res == eventNotConsumed)
        {
            res = INVITE_Received_handleEvent();
        }
    return res;
}

void SIP_Redirect::WaitingForRequests_exit() {
    proxy_server_exit();
    registrar_redirect_exit();
    NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests");
}

void SIP_Redirect::registrar_redirect_entDef() {
    NOTIFY_STATE_ENTERED("ROOT.mainState.WaitingForRequests.registrar_redirect");
    NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.registrar_redirect.0");
    NOTIFY_STATE_ENTERED("ROOT.mainState.WaitingForRequests.registrar_redirect.ROOT.registrar_redirect.WaitingForREGISTER");
    registrar_redirect_subState = WaitingForREGISTER;
    registrar_redirect_active = WaitingForREGISTER;
    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.registrar_redirect.0");
}

IOxfReactive::TakeEventStatus SIP_Redirect::addressReceived_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(OMNullEventId))
        {
            NOTIFY_TRANSITION_STARTED("2");
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.InitializingState.addressReceived");
            //#[ transition 2 
            OUT_PORT(pDNS)->GEN(evRes_init(dom_name));
            //#]
            NOTIFY_STATE_ENTERED("ROOT.mainState.InitializingState.AckSent");
            pushNullTransition();
            InitializingState_subState = AckSent;
            rootState_active = AckSent;
            NOTIFY_TRANSITION_TERMINATED("2");
            res = eventConsumed;
        }
    
    if(res == eventNotConsumed)
        {
            res = InitializingState_handleEvent();
        }
    return res;
}

void SIP_Redirect::InitializingState_entDef() {
    NOTIFY_STATE_ENTERED("ROOT.mainState.InitializingState");
    pushNullTransition();
    mainState_subState = InitializingState;
    NOTIFY_TRANSITION_STARTED("0");
    NOTIFY_STATE_ENTERED("ROOT.mainState.InitializingState.Initial");
    InitializingState_subState = Initial;
    rootState_active = Initial;
    NOTIFY_TRANSITION_TERMINATED("0");
}

void SIP_Redirect::InitializingState_exit() {
    popNullTransition();
    switch (InitializingState_subState) {
        case Initial:
        {
            NOTIFY_STATE_EXITED("ROOT.mainState.InitializingState.Initial");
            break;
        }
        case addressReceived:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.InitializingState.addressReceived");
            break;
        }
        case AckSent:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.InitializingState.AckSent");
            break;
        }
        case state_19:
        {
            NOTIFY_STATE_EXITED("ROOT.mainState.InitializingState.state_19");
            break;
        }
        default:
            break;
    }
    InitializingState_subState = OMNonState;
    NOTIFY_STATE_EXITED("ROOT.mainState.InitializingState");
}

IOxfReactive::TakeEventStatus SIP_Redirect::WaitingForRequestResponse_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(evACK_sip_id))
        {
            OMSETPARAMS(evACK);
            NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.proxy_server.9");
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.WaitingForRequestResponse");
            //#[ transition ROOT.mainState.WaitingForRequests.proxy_server.9 
            
            headersReceived = params->sip_headerset;
            bodyReceived = params->sip_body;
            
            headers = headersReceived;
            body = bodyReceived;
            
            if (params->sip_headerset.Array[2][0] == "Via")
              via_adr = params->sip_headerset.Array[2][1];
            //#]
            NOTIFY_STATE_ENTERED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.ACKreceived");
            pushNullTransition();
            proxy_server_subState = ACKreceived;
            proxy_server_active = ACKreceived;
            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.proxy_server.9");
            res = eventConsumed;
        }
    else if(IS_EVENT_TYPE_OF(ev200_OK_sip_id))
        {
            OMSETPARAMS(ev200_OK);
            NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.proxy_server.3");
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.WaitingForRequestResponse");
            //#[ transition ROOT.mainState.WaitingForRequests.proxy_server.3 
            
            headersReceived = params->sip_headerset;
            bodyReceived = params->sip_body;
            
            headers = headersReceived;
            body = bodyReceived;
            
            if (params->sip_headerset.Array[2][0] == "Via")
              via_adr = params->sip_headerset.Array[2][1];
            //#]
            NOTIFY_STATE_ENTERED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.OKreceived");
            pushNullTransition();
            proxy_server_subState = OKreceived;
            proxy_server_active = OKreceived;
            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.proxy_server.3");
            res = eventConsumed;
        }
    else if(IS_EVENT_TYPE_OF(ev180_ringing_sip_id))
        {
            OMSETPARAMS(ev180_ringing);
            NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.proxy_server.7");
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.WaitingForRequestResponse");
            //#[ transition ROOT.mainState.WaitingForRequests.proxy_server.7 
            
            headersReceived = params->sip_headerset;
            bodyReceived = params->sip_body;
            
            headers = headersReceived;
            body = bodyReceived;
            
            if (params->sip_headerset.Array[2][0] == "Via")
              via_adr = params->sip_headerset.Array[2][1];
            //#]
            NOTIFY_STATE_ENTERED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.RingingReceived");
            pushNullTransition();
            proxy_server_subState = RingingReceived;
            proxy_server_active = RingingReceived;
            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.proxy_server.7");
            res = eventConsumed;
        }
    else if(IS_EVENT_TYPE_OF(evINVITE_sip_id))
        {
            OMSETPARAMS(evINVITE);
            NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.proxy_server.1");
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.WaitingForRequestResponse");
            //#[ transition ROOT.mainState.WaitingForRequests.proxy_server.1 
            
            headersReceived = params->sip_headerset;
            bodyReceived = params->sip_body;
            
            headers = headersReceived;
            body = bodyReceived;
            
            if (params->sip_headerset.Array[1][0] == "To")
              to_adr = params->sip_headerset.Array[1][1];
            
            if (params->sip_headerset.Array[2][0] == "Via")
              via_adr = params->sip_headerset.Array[2][1];
            
            if (params->sip_headerset.Array[0][0] == "From")
              client = params->sip_headerset.Array[0][1];
            //#]
            INVITE_Received_entDef();
            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.proxy_server.1");
            res = eventConsumed;
        }
    else if(IS_EVENT_TYPE_OF(evBYE_sip_id))
        {
            OMSETPARAMS(evBYE);
            NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.proxy_server.13");
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.WaitingForRequestResponse");
            //#[ transition ROOT.mainState.WaitingForRequests.proxy_server.13 
            
            headersReceived = params->sip_headerset;
            bodyReceived = params->sip_body;
            
            headers = headersReceived;
            body = bodyReceived;
            
            if (params->sip_headerset.Array[2][0] == "Via")
              via_adr = params->sip_headerset.Array[2][1];
            IsBYEreceived = true;
            //#]
            NOTIFY_STATE_ENTERED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.BYEreceived");
            pushNullTransition();
            proxy_server_subState = BYEreceived;
            proxy_server_active = BYEreceived;
            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.proxy_server.13");
            res = eventConsumed;
        }
    
    
    return res;
}

IOxfReactive::TakeEventStatus SIP_Redirect::AckSent_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(OMNullEventId))
        {
            NOTIFY_TRANSITION_STARTED("3");
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.InitializingState.AckSent");
            NOTIFY_STATE_ENTERED("ROOT.mainState.InitializingState.state_19");
            InitializingState_subState = state_19;
            rootState_active = state_19;
            NOTIFY_TRANSITION_TERMINATED("3");
            res = eventConsumed;
        }
    
    if(res == eventNotConsumed)
        {
            res = InitializingState_handleEvent();
        }
    return res;
}

IOxfReactive::TakeEventStatus SIP_Redirect::INVITEReceived_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(OMNullEventId))
        {
            NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.0");
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.ROOT.INVITE_Received.INVITEReceived");
            //#[ transition ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.0 
            via_extract = via_head(via_adr);
            //#]
            NOTIFY_STATE_ENTERED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.ROOT.INVITE_Received.Via_head_extracted");
            pushNullTransition();
            INVITE_Received_subState = Via_head_extracted;
            proxy_server_active = Via_head_extracted;
            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.0");
            res = eventConsumed;
        }
    
    if(res == eventNotConsumed)
        {
            res = INVITE_Received_handleEvent();
        }
    return res;
}

IOxfReactive::TakeEventStatus SIP_Redirect::Via_head_extracted_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(OMNullEventId))
        {
            NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.1");
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.ROOT.INVITE_Received.Via_head_extracted");
            //#[ transition ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.1 
            OUT_PORT(pDNS)->GEN(evDNSLookup(via_extract));
            //#]
            NOTIFY_STATE_ENTERED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.ROOT.INVITE_Received.DNSLookupToSend");
            INVITE_Received_subState = DNSLookupToSend;
            proxy_server_active = DNSLookupToSend;
            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.1");
            res = eventConsumed;
        }
    
    if(res == eventNotConsumed)
        {
            res = INVITE_Received_handleEvent();
        }
    return res;
}

void SIP_Redirect::INVITE_Received_entDef() {
    NOTIFY_STATE_ENTERED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received");
    pushNullTransition();
    proxy_server_subState = INVITE_Received;
    NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.4");
    NOTIFY_STATE_ENTERED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.ROOT.INVITE_Received.INVITEReceived");
    pushNullTransition();
    INVITE_Received_subState = INVITEReceived;
    proxy_server_active = INVITEReceived;
    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.4");
}

IOxfReactive::TakeEventStatus SIP_Redirect::state_19_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    res = InitializingState_handleEvent();
    return res;
}

IOxfReactive::TakeEventStatus SIP_Redirect::UserNotRegistered_SendingNotFound_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(OMNullEventId))
        {
            NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.7");
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.ROOT.INVITE_Received.UserNotRegistered_SendingNotFound");
            //#[ transition ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.7 
            sendNotFound(port_client, headers.Array[2][1], headers, body);
            //#]
            NOTIFY_STATE_ENTERED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.ROOT.INVITE_Received.NotFoundSent");
            pushNullTransition();
            INVITE_Received_subState = NotFoundSent;
            proxy_server_active = NotFoundSent;
            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.7");
            res = eventConsumed;
        }
    
    if(res == eventNotConsumed)
        {
            res = INVITE_Received_handleEvent();
        }
    return res;
}

void SIP_Redirect::proxy_server_entDef() {
    NOTIFY_STATE_ENTERED("ROOT.mainState.WaitingForRequests.proxy_server");
    NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.proxy_server.0");
    NOTIFY_STATE_ENTERED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.WaitingForRequestResponse");
    proxy_server_subState = WaitingForRequestResponse;
    proxy_server_active = WaitingForRequestResponse;
    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.proxy_server.0");
}

IOxfReactive::TakeEventStatus SIP_Redirect::UserRegistered_ContactingTheUser_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(OMNullEventId))
        {
            NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.17");
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.ROOT.INVITE_Received.UserRegistered_ContactingTheUser");
            //#[ transition ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.17 
            OUT_PORT(pDNS)->GEN(evDNSLookup(dom_destination));
            //#]
            NOTIFY_STATE_ENTERED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.ROOT.INVITE_Received.DNSLookupTheContactFieldToResend");
            INVITE_Received_subState = DNSLookupTheContactFieldToResend;
            proxy_server_active = DNSLookupTheContactFieldToResend;
            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.17");
            res = eventConsumed;
        }
    
    if(res == eventNotConsumed)
        {
            res = INVITE_Received_handleEvent();
        }
    return res;
}

void SIP_Redirect::WaitingForRequests_entDef() {
    NOTIFY_STATE_ENTERED("ROOT.mainState.WaitingForRequests");
    mainState_subState = WaitingForRequests;
    rootState_active = WaitingForRequests;
    proxy_server_entDef();
    registrar_redirect_entDef();
}





SIP_Redirect::pA_C::pA_C() {
}

SIP_Redirect::pA_C::~pA_C() {
}

void SIP_Redirect::pA_C::connectSIP_Redirect(SIP_Redirect* part) {
    //#[ operation connectSIP_Redirect(SIP_Redirect*) 
    InBound.setItsDefaultProvidedInterface(part);
    InBound.setPort(this); // for IS_PORT macro support
    
    //#]
}






SIP_Redirect::pBh_C::pBh_C() {
}

SIP_Redirect::pBh_C::~pBh_C() {
}

void SIP_Redirect::pBh_C::connectSIP_Redirect(SIP_Redirect* part) {
    //#[ operation connectSIP_Redirect(SIP_Redirect*) 
    InBound.setItsDefaultProvidedInterface(part);
    InBound.setPort(this); // for IS_PORT macro support
    
    //#]
}






SIP_Redirect::pBw_C::pBw_C() {
}

SIP_Redirect::pBw_C::~pBw_C() {
}

void SIP_Redirect::pBw_C::connectSIP_Redirect(SIP_Redirect* part) {
    //#[ operation connectSIP_Redirect(SIP_Redirect*) 
    InBound.setItsDefaultProvidedInterface(part);
    InBound.setPort(this); // for IS_PORT macro support
    
    //#]
}






SIP_Redirect::pC_C::pC_C() {
}

SIP_Redirect::pC_C::~pC_C() {
}

void SIP_Redirect::pC_C::connectSIP_Redirect(SIP_Redirect* part) {
    //#[ operation connectSIP_Redirect(SIP_Redirect*) 
    InBound.setItsDefaultProvidedInterface(part);
    InBound.setPort(this); // for IS_PORT macro support
    
    //#]
}






SIP_Redirect::pDNS_C::pDNS_C() {
    initRelations();
}

SIP_Redirect::pDNS_C::~pDNS_C() {
}

void SIP_Redirect::pDNS_C::connectSIP_Redirect(SIP_Redirect* part) {
    //#[ operation connectSIP_Redirect(SIP_Redirect*) 
    InBound.setItsIDNSLookupResInit(part);
    InBound.setPort(this); // for IS_PORT macro support
    
    //#]
}

iDNSLookupInitRes* SIP_Redirect::pDNS_C::getItsIDNSLookupInitRes() {
    //#[ operation getItsIDNSLookupInitRes() 
    return &OutBound;
    //#]
}

iDNSLookupResInit* SIP_Redirect::pDNS_C::getItsIDNSLookupResInit() {
    //#[ operation getItsIDNSLookupResInit() 
    return &InBound;
    //#]
}

void SIP_Redirect::pDNS_C::setItsIDNSLookupInitRes(OMReactive* p_iDNSLookupInitRes) {
    //#[ operation setItsIDNSLookupInitRes(OMReactive*) 
    OutBound.setItsIDNSLookupInitRes(p_iDNSLookupInitRes);
    //#]
}

void SIP_Redirect::pDNS_C::setItsIDNSLookupResInit(iDNSLookupResInit* p_iDNSLookupResInit) {
    //#[ operation setItsIDNSLookupResInit(iDNSLookupResInit*) 
    InBound.setItsIDNSLookupResInit(p_iDNSLookupResInit);
    //#]
}

SIP_Redirect::pDNS_C::InBound_C* SIP_Redirect::pDNS_C::getInBound() const {
    return (SIP_Redirect::pDNS_C::InBound_C*) &InBound;
}

SIP_Redirect::pDNS_C::OutBound_C* SIP_Redirect::pDNS_C::getOutBound() const {
    return (SIP_Redirect::pDNS_C::OutBound_C*) &OutBound;
}

void SIP_Redirect::pDNS_C::destroy() {
}

void SIP_Redirect::pDNS_C::initRelations() {
    InBound._setPort(this);
}





SIP_Redirect::pDNS_C::InBound_C::InBound_C() {
    itsIDNSLookupResInit = NULL;
    port = NULL;
}

SIP_Redirect::pDNS_C::InBound_C::~InBound_C() {
    cleanUpRelations();
}

bool SIP_Redirect::pDNS_C::InBound_C::send(IOxfEvent* event, const IOxfEventGenerationParams& params) {
    //#[ operation send(IOxfEvent*,const IOxfEventGenerationParams&) 
    bool res = false;
    if (event != NULL) {
      event->setPort(getPort());
      	if (itsIDNSLookupResInit != NULL){
    	     if (event->isTypeOf(evDNSLookupRes_sip_id)){
         		res = itsIDNSLookupResInit->send(event, params);
         	    return res;
         	}
         	
         	if (event->isTypeOf(evInitialization_sip_id)){
         		res = itsIDNSLookupResInit->send(event, params);
         	    return res;
         	}
         	}
    	  }
    return res;
    
    //#]
}

bool SIP_Redirect::pDNS_C::InBound_C::send(IOxfEvent* event) {
    //#[ operation send(IOxfEvent*) 
    bool res = false;
    if (event != NULL) {
      event->setPort(getPort());
      	if (itsIDNSLookupResInit != NULL){
    	     if (event->isTypeOf(evDNSLookupRes_sip_id)){
         		res = itsIDNSLookupResInit->send(event);
         	    return res;
         	}
         	
         	if (event->isTypeOf(evInitialization_sip_id)){
         		res = itsIDNSLookupResInit->send(event);
         	    return res;
         	}
         	}
    	  }
    return res;
    
    //#]
}

iDNSLookupResInit* SIP_Redirect::pDNS_C::InBound_C::getItsIDNSLookupResInit() const {
    return itsIDNSLookupResInit;
}

void SIP_Redirect::pDNS_C::InBound_C::setItsIDNSLookupResInit(iDNSLookupResInit* p_iDNSLookupResInit) {
    itsIDNSLookupResInit = p_iDNSLookupResInit;
}

SIP_Redirect::pDNS_C* SIP_Redirect::pDNS_C::InBound_C::getPort() const {
    return port;
}

void SIP_Redirect::pDNS_C::InBound_C::__setPort(SIP_Redirect::pDNS_C* p_pDNS_C) {
    port = p_pDNS_C;
}

void SIP_Redirect::pDNS_C::InBound_C::_setPort(SIP_Redirect::pDNS_C* p_pDNS_C) {
    __setPort(p_pDNS_C);
}

void SIP_Redirect::pDNS_C::InBound_C::setPort(SIP_Redirect::pDNS_C* p_pDNS_C) {
    _setPort(p_pDNS_C);
}

void SIP_Redirect::pDNS_C::InBound_C::_clearPort() {
    port = NULL;
}

void SIP_Redirect::pDNS_C::InBound_C::cleanUpRelations() {
    if(itsIDNSLookupResInit != NULL)
        {
            itsIDNSLookupResInit = NULL;
        }
    if(port != NULL)
        {
            SIP_Redirect::pDNS_C::InBound_C* p_InBound = port->getInBound();
            port = NULL;
        }
}






SIP_Redirect::pDNS_C::OutBound_C::OutBound_C() {
    itsIDNSLookupInitRes = NULL;
}

SIP_Redirect::pDNS_C::OutBound_C::~OutBound_C() {
    cleanUpRelations();
}

bool SIP_Redirect::pDNS_C::OutBound_C::send(IOxfEvent* event, const IOxfEventGenerationParams& params) {
    //#[ operation send(IOxfEvent*,const IOxfEventGenerationParams&) 
    bool res = false;
    if (event != NULL) {
      	if (itsIDNSLookupInitRes != NULL){
    	     if (event->isTypeOf(evDNSLookup_sip_id)){
         		res = itsIDNSLookupInitRes->send(event, params);
         	    return res;
         	}
         	
         	if (event->isTypeOf(evRes_init_sip_id)){
         		res = itsIDNSLookupInitRes->send(event, params);
         	    return res;
         	}
         	}
    	  }
    return res;
    
    //#]
}

bool SIP_Redirect::pDNS_C::OutBound_C::send(IOxfEvent* event) {
    //#[ operation send(IOxfEvent*) 
    bool res = false;
    if (event != NULL) {
      	if (itsIDNSLookupInitRes != NULL){
    	     if (event->isTypeOf(evDNSLookup_sip_id)){
         		res = itsIDNSLookupInitRes->send(event);
         	    return res;
         	}
         	
         	if (event->isTypeOf(evRes_init_sip_id)){
         		res = itsIDNSLookupInitRes->send(event);
         	    return res;
         	}
         	}
    	  }
    return res;
    
    //#]
}

OMReactive* SIP_Redirect::pDNS_C::OutBound_C::getItsIDNSLookupInitRes() const {
    return itsIDNSLookupInitRes;
}

void SIP_Redirect::pDNS_C::OutBound_C::setItsIDNSLookupInitRes(OMReactive* p_OMReactive) {
    itsIDNSLookupInitRes = p_OMReactive;
}

void SIP_Redirect::pDNS_C::OutBound_C::cleanUpRelations() {
    if(itsIDNSLookupInitRes != NULL)
        {
            itsIDNSLookupInitRes = NULL;
        }
}





#ifdef _OMINSTRUMENT


void OMAnimatedSIP_Redirect::serializeAttributes(AOMSAttributes* aomsAttributes) const {
    aomsAttributes->addAttribute("dom_name", x2String(myReal->dom_name));
    aomsAttributes->addAttribute("body", UNKNOWN2STRING(myReal->body));
    aomsAttributes->addAttribute("bodyReceived", UNKNOWN2STRING(myReal->bodyReceived));
    aomsAttributes->addAttribute("headers", UNKNOWN2STRING(myReal->headers));
    aomsAttributes->addAttribute("headersReceived", UNKNOWN2STRING(myReal->headersReceived));
    aomsAttributes->addAttribute("to_adr", x2String(myReal->to_adr));
    aomsAttributes->addAttribute("via_adr", x2String(myReal->via_adr));
    aomsAttributes->addAttribute("via_extract", x2String(myReal->via_extract));
    aomsAttributes->addAttribute("port_client", x2String(myReal->port_client));
    aomsAttributes->addAttribute("idx_called", x2String(myReal->idx_called));
    aomsAttributes->addAttribute("users", UNKNOWN2STRING(myReal->users));
    aomsAttributes->addAttribute("nb_users", x2String(myReal->nb_users));
    aomsAttributes->addAttribute("stringLength", x2String(myReal->stringLength));
    aomsAttributes->addAttribute("i", x2String(myReal->i));
    aomsAttributes->addAttribute("j", x2String(myReal->j));
    aomsAttributes->addAttribute("tmp_string", x2String(myReal->tmp_string));
    aomsAttributes->addAttribute("redirection", x2String(myReal->redirection));
    aomsAttributes->addAttribute("duration", x2String(myReal->duration));
    aomsAttributes->addAttribute("addressToRegister", x2String(myReal->addressToRegister));
    aomsAttributes->addAttribute("u", x2String(myReal->u));
    aomsAttributes->addAttribute("stringLength2", x2String(myReal->stringLength2));
    aomsAttributes->addAttribute("destination", x2String(myReal->destination));
    aomsAttributes->addAttribute("port_correspondant", x2String(myReal->port_correspondant));
    aomsAttributes->addAttribute("client", x2String(myReal->client));
    aomsAttributes->addAttribute("dom_destination", x2String(myReal->dom_destination));
    aomsAttributes->addAttribute("IsBYEreceived", x2String(myReal->IsBYEreceived));
    aomsAttributes->addAttribute("port", x2String(myReal->port));
    OMAnimatediDNSLookupResInit::serializeAttributes(aomsAttributes);
}

void OMAnimatedSIP_Redirect::serializeRelations(AOMSRelations* aomsRelations) const {
    OMAnimatediDNSLookupResInit::serializeRelations(aomsRelations);
}

void OMAnimatedSIP_Redirect::rootState_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT");
    switch (myReal->rootState_subState) {
        case SIP_Redirect::mainState:
        {
            mainState_serializeStates(aomsState);
            break;
        }
        default:
            break;
    }
}

void OMAnimatedSIP_Redirect::mainState_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState");
    switch (myReal->mainState_subState) {
        case SIP_Redirect::InitializingState:
        {
            InitializingState_serializeStates(aomsState);
            break;
        }
        case SIP_Redirect::WaitingForRequests:
        {
            WaitingForRequests_serializeStates(aomsState);
            break;
        }
        default:
            break;
    }
}

void OMAnimatedSIP_Redirect::WaitingForRequests_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.WaitingForRequests");
    proxy_server_serializeStates(aomsState);
    registrar_redirect_serializeStates(aomsState);
}

void OMAnimatedSIP_Redirect::registrar_redirect_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.WaitingForRequests.registrar_redirect");
    switch (myReal->registrar_redirect_subState) {
        case SIP_Redirect::WaitingForREGISTER:
        {
            WaitingForREGISTER_serializeStates(aomsState);
            break;
        }
        case SIP_Redirect::evRegisterReceived:
        {
            evRegisterReceived_serializeStates(aomsState);
            break;
        }
        case SIP_Redirect::registrar_redirect_Via_head_extracted:
        {
            registrar_redirect_Via_head_extracted_serializeStates(aomsState);
            break;
        }
        case SIP_Redirect::registrar_redirect_DNSLookupToSend:
        {
            registrar_redirect_DNSLookupToSend_serializeStates(aomsState);
            break;
        }
        case SIP_Redirect::registrar_redirect_DNSResponseReceived:
        {
            registrar_redirect_DNSResponseReceived_serializeStates(aomsState);
            break;
        }
        case SIP_Redirect::CheckingTheUserTable:
        {
            CheckingTheUserTable_serializeStates(aomsState);
            break;
        }
        case SIP_Redirect::TableSearched:
        {
            TableSearched_serializeStates(aomsState);
            break;
        }
        case SIP_Redirect::UserAdded:
        {
            UserAdded_serializeStates(aomsState);
            break;
        }
        case SIP_Redirect::Unregister:
        {
            Unregister_serializeStates(aomsState);
            break;
        }
        case SIP_Redirect::UpdatingRecord:
        {
            UpdatingRecord_serializeStates(aomsState);
            break;
        }
        case SIP_Redirect::SendingOK:
        {
            SendingOK_serializeStates(aomsState);
            break;
        }
        case SIP_Redirect::OKsent:
        {
            OKsent_serializeStates(aomsState);
            break;
        }
        default:
            break;
    }
}

void OMAnimatedSIP_Redirect::WaitingForREGISTER_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.WaitingForRequests.registrar_redirect.ROOT.registrar_redirect.WaitingForREGISTER");
}

void OMAnimatedSIP_Redirect::registrar_redirect_Via_head_extracted_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.WaitingForRequests.registrar_redirect.ROOT.registrar_redirect.Via_head_extracted");
}

void OMAnimatedSIP_Redirect::UserAdded_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.WaitingForRequests.registrar_redirect.ROOT.registrar_redirect.UserAdded");
}

void OMAnimatedSIP_Redirect::UpdatingRecord_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.WaitingForRequests.registrar_redirect.ROOT.registrar_redirect.UpdatingRecord");
}

void OMAnimatedSIP_Redirect::Unregister_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.WaitingForRequests.registrar_redirect.ROOT.registrar_redirect.Unregister");
}

void OMAnimatedSIP_Redirect::TableSearched_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.WaitingForRequests.registrar_redirect.ROOT.registrar_redirect.TableSearched");
}

void OMAnimatedSIP_Redirect::SendingOK_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.WaitingForRequests.registrar_redirect.ROOT.registrar_redirect.SendingOK");
}

void OMAnimatedSIP_Redirect::OKsent_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.WaitingForRequests.registrar_redirect.ROOT.registrar_redirect.OKsent");
}

void OMAnimatedSIP_Redirect::evRegisterReceived_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.WaitingForRequests.registrar_redirect.ROOT.registrar_redirect.evRegisterReceived");
}

void OMAnimatedSIP_Redirect::registrar_redirect_DNSResponseReceived_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.WaitingForRequests.registrar_redirect.ROOT.registrar_redirect.DNSResponseReceived");
}

void OMAnimatedSIP_Redirect::registrar_redirect_DNSLookupToSend_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.WaitingForRequests.registrar_redirect.ROOT.registrar_redirect.DNSLookupToSend");
}

void OMAnimatedSIP_Redirect::CheckingTheUserTable_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.WaitingForRequests.registrar_redirect.ROOT.registrar_redirect.CheckingTheUserTable");
}

void OMAnimatedSIP_Redirect::proxy_server_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.WaitingForRequests.proxy_server");
    switch (myReal->proxy_server_subState) {
        case SIP_Redirect::WaitingForRequestResponse:
        {
            WaitingForRequestResponse_serializeStates(aomsState);
            break;
        }
        case SIP_Redirect::OKreceived:
        {
            OKreceived_serializeStates(aomsState);
            break;
        }
        case SIP_Redirect::ViaHeadRestored:
        {
            ViaHeadRestored_serializeStates(aomsState);
            break;
        }
        case SIP_Redirect::reSendingTheOK:
        {
            reSendingTheOK_serializeStates(aomsState);
            break;
        }
        case SIP_Redirect::RingingReceived:
        {
            RingingReceived_serializeStates(aomsState);
            break;
        }
        case SIP_Redirect::ViaHead_restored:
        {
            ViaHead_restored_serializeStates(aomsState);
            break;
        }
        case SIP_Redirect::reSendingTheRinging:
        {
            reSendingTheRinging_serializeStates(aomsState);
            break;
        }
        case SIP_Redirect::ACKreceived:
        {
            ACKreceived_serializeStates(aomsState);
            break;
        }
        case SIP_Redirect::ServerAddedToViaField:
        {
            ServerAddedToViaField_serializeStates(aomsState);
            break;
        }
        case SIP_Redirect::reSendingTheACK:
        {
            reSendingTheACK_serializeStates(aomsState);
            break;
        }
        case SIP_Redirect::BYEreceived:
        {
            BYEreceived_serializeStates(aomsState);
            break;
        }
        case SIP_Redirect::ServerAddedTo_ViaField:
        {
            ServerAddedTo_ViaField_serializeStates(aomsState);
            break;
        }
        case SIP_Redirect::reSendingTheBYE:
        {
            reSendingTheBYE_serializeStates(aomsState);
            break;
        }
        case SIP_Redirect::INVITE_Received:
        {
            INVITE_Received_serializeStates(aomsState);
            break;
        }
        default:
            break;
    }
}

void OMAnimatedSIP_Redirect::WaitingForRequestResponse_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.WaitingForRequestResponse");
}

void OMAnimatedSIP_Redirect::ViaHeadRestored_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.ViaHeadRestored");
}

void OMAnimatedSIP_Redirect::ViaHead_restored_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.ViaHead_restored");
}

void OMAnimatedSIP_Redirect::ServerAddedToViaField_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.ServerAddedToViaField");
}

void OMAnimatedSIP_Redirect::ServerAddedTo_ViaField_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.ServerAddedTo_ViaField");
}

void OMAnimatedSIP_Redirect::RingingReceived_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.RingingReceived");
}

void OMAnimatedSIP_Redirect::reSendingTheRinging_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.reSendingTheRinging");
}

void OMAnimatedSIP_Redirect::reSendingTheOK_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.reSendingTheOK");
}

void OMAnimatedSIP_Redirect::reSendingTheBYE_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.reSendingTheBYE");
}

void OMAnimatedSIP_Redirect::reSendingTheACK_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.reSendingTheACK");
}

void OMAnimatedSIP_Redirect::OKreceived_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.OKreceived");
}

void OMAnimatedSIP_Redirect::INVITE_Received_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received");
    switch (myReal->INVITE_Received_subState) {
        case SIP_Redirect::DNSResponseReceived:
        {
            DNSResponseReceived_serializeStates(aomsState);
            break;
        }
        case SIP_Redirect::INVITEReceived:
        {
            INVITEReceived_serializeStates(aomsState);
            break;
        }
        case SIP_Redirect::DNSLookupToSend:
        {
            DNSLookupToSend_serializeStates(aomsState);
            break;
        }
        case SIP_Redirect::Via_head_extracted:
        {
            Via_head_extracted_serializeStates(aomsState);
            break;
        }
        case SIP_Redirect::UserNotRegistered_SendingNotFound:
        {
            UserNotRegistered_SendingNotFound_serializeStates(aomsState);
            break;
        }
        case SIP_Redirect::UserRegistered_ContactingTheUser:
        {
            UserRegistered_ContactingTheUser_serializeStates(aomsState);
            break;
        }
        case SIP_Redirect::UserTableChecked:
        {
            UserTableChecked_serializeStates(aomsState);
            break;
        }
        case SIP_Redirect::CheckingTheTable:
        {
            CheckingTheTable_serializeStates(aomsState);
            break;
        }
        case SIP_Redirect::NotFoundSent:
        {
            NotFoundSent_serializeStates(aomsState);
            break;
        }
        case SIP_Redirect::DNSLookupTheContactFieldToResend:
        {
            DNSLookupTheContactFieldToResend_serializeStates(aomsState);
            break;
        }
        case SIP_Redirect::DNSResponse_Received:
        {
            DNSResponse_Received_serializeStates(aomsState);
            break;
        }
        case SIP_Redirect::reSendingTheINVITE:
        {
            reSendingTheINVITE_serializeStates(aomsState);
            break;
        }
        case SIP_Redirect::state_81:
        {
            state_81_serializeStates(aomsState);
            break;
        }
        case SIP_Redirect::state_82:
        {
            state_82_serializeStates(aomsState);
            break;
        }
        default:
            break;
    }
}

void OMAnimatedSIP_Redirect::Via_head_extracted_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.ROOT.INVITE_Received.Via_head_extracted");
}

void OMAnimatedSIP_Redirect::UserTableChecked_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.ROOT.INVITE_Received.UserTableChecked");
}

void OMAnimatedSIP_Redirect::UserRegistered_ContactingTheUser_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.ROOT.INVITE_Received.UserRegistered_ContactingTheUser");
}

void OMAnimatedSIP_Redirect::UserNotRegistered_SendingNotFound_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.ROOT.INVITE_Received.UserNotRegistered_SendingNotFound");
}

void OMAnimatedSIP_Redirect::state_82_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.ROOT.INVITE_Received.state_82");
}

void OMAnimatedSIP_Redirect::state_81_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.ROOT.INVITE_Received.state_81");
}

void OMAnimatedSIP_Redirect::reSendingTheINVITE_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.ROOT.INVITE_Received.reSendingTheINVITE");
}

void OMAnimatedSIP_Redirect::NotFoundSent_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.ROOT.INVITE_Received.NotFoundSent");
}

void OMAnimatedSIP_Redirect::INVITEReceived_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.ROOT.INVITE_Received.INVITEReceived");
}

void OMAnimatedSIP_Redirect::DNSResponseReceived_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.ROOT.INVITE_Received.DNSResponseReceived");
}

void OMAnimatedSIP_Redirect::DNSResponse_Received_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.ROOT.INVITE_Received.DNSResponse_Received");
}

void OMAnimatedSIP_Redirect::DNSLookupToSend_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.ROOT.INVITE_Received.DNSLookupToSend");
}

void OMAnimatedSIP_Redirect::DNSLookupTheContactFieldToResend_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.ROOT.INVITE_Received.DNSLookupTheContactFieldToResend");
}

void OMAnimatedSIP_Redirect::CheckingTheTable_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.INVITE_Received.ROOT.INVITE_Received.CheckingTheTable");
}

void OMAnimatedSIP_Redirect::BYEreceived_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.BYEreceived");
}

void OMAnimatedSIP_Redirect::ACKreceived_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.WaitingForRequests.proxy_server.ROOT.proxy_server.ACKreceived");
}

void OMAnimatedSIP_Redirect::InitializingState_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.InitializingState");
    switch (myReal->InitializingState_subState) {
        case SIP_Redirect::Initial:
        {
            Initial_serializeStates(aomsState);
            break;
        }
        case SIP_Redirect::addressReceived:
        {
            addressReceived_serializeStates(aomsState);
            break;
        }
        case SIP_Redirect::AckSent:
        {
            AckSent_serializeStates(aomsState);
            break;
        }
        case SIP_Redirect::state_19:
        {
            state_19_serializeStates(aomsState);
            break;
        }
        default:
            break;
    }
}

void OMAnimatedSIP_Redirect::state_19_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.InitializingState.state_19");
}

void OMAnimatedSIP_Redirect::Initial_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.InitializingState.Initial");
}

void OMAnimatedSIP_Redirect::addressReceived_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.InitializingState.addressReceived");
}

void OMAnimatedSIP_Redirect::AckSent_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.InitializingState.AckSent");
}

IMPLEMENT_REACTIVE_META_S(SIP_Redirect, false, iDNSLookupResInit, OMAnimatediDNSLookupResInit, OMAnimatedSIP_Redirect)
OMINIT_SUPERCLASS(iDNSLookupResInit, OMAnimatediDNSLookupResInit)
OMREGISTER_REACTIVE_CLASS
#endif // _OMINSTRUMENT


/*********************************************************************
	File Path	: DefaultComponent/DefaultConfig/SIP_Redirect.cpp
*********************************************************************/

