/********************************************************************
	Rhapsody	: 6.1 
	Login		: Masood Khosroshahy
	Component	: DefaultComponent 
	Configuration 	: DefaultConfig
	Model Element	: Initiator_and_dns
//!	Generated Date	: Wed, 19, Apr 2006  
	File Path	: DefaultComponent/DefaultConfig/Initiator_and_dns.cpp
*********************************************************************/


//#[ ignore 
#define NAMESPACE_PREFIX 


#define _OMSTATECHART_ANIMATED 
//#]

#include "Initiator_and_dns.h"

//## package sip 


//#[ ignore 
#define sip_Initiator_and_dns_Initiator_and_dns_SERIALIZE OM_NO_OP


#define sip_Initiator_and_dns_add_dns_entry_SERIALIZE \
    aomsmethod->addAttribute("address", x2String(address)); \
    aomsmethod->addAttribute("portName", x2String(portName));


#define sip_Initiator_and_dns_searchDNSEntry_SERIALIZE aomsmethod->addAttribute("arg", x2String(arg));
//#]

//----------------------------------------------------------------------------
// Initiator_and_dns.cpp                                                                  
//----------------------------------------------------------------------------
DECLARE_META_PACKAGE(sip)
//## class Initiator_and_dns 



Initiator_and_dns::Initiator_and_dns(IOxfActive* theActiveContext) : i(0) ,nbEntries(0) {
    NOTIFY_REACTIVE_CONSTRUCTOR(Initiator_and_dns, Initiator_and_dns(), 0, sip_Initiator_and_dns_Initiator_and_dns_SERIALIZE);
    setActiveContext(theActiveContext, false);
    initRelations();
    initStatechart();
}

Initiator_and_dns::~Initiator_and_dns() {
    NOTIFY_DESTRUCTOR(~Initiator_and_dns, false);
    cleanUpRelations();
}

Initiator_and_dns::pDNSServer_C* Initiator_and_dns::getPDNSServer() const {
    return pDNSServer;
}

Initiator_and_dns::pDNSServer_C* Initiator_and_dns::get_pDNSServer() const {
    return pDNSServer;
}

Initiator_and_dns::pDNSServer_C* Initiator_and_dns::newPDNSServer() {
    pDNSServer = new Initiator_and_dns::pDNSServer_C;
    return pDNSServer;
}

void Initiator_and_dns::deletePDNSServer() {
    delete pDNSServer;
    pDNSServer = NULL;
}

Initiator_and_dns::pDNS_A_C* Initiator_and_dns::getPDNS_A() const {
    return pDNS_A;
}

Initiator_and_dns::pDNS_A_C* Initiator_and_dns::get_pDNS_A() const {
    return pDNS_A;
}

Initiator_and_dns::pDNS_A_C* Initiator_and_dns::newPDNS_A() {
    pDNS_A = new Initiator_and_dns::pDNS_A_C;
    return pDNS_A;
}

void Initiator_and_dns::deletePDNS_A() {
    delete pDNS_A;
    pDNS_A = NULL;
}

Initiator_and_dns::pDNS_Bh_C* Initiator_and_dns::getPDNS_Bh() const {
    return pDNS_Bh;
}

Initiator_and_dns::pDNS_Bh_C* Initiator_and_dns::get_pDNS_Bh() const {
    return pDNS_Bh;
}

Initiator_and_dns::pDNS_Bh_C* Initiator_and_dns::newPDNS_Bh() {
    pDNS_Bh = new Initiator_and_dns::pDNS_Bh_C;
    return pDNS_Bh;
}

void Initiator_and_dns::deletePDNS_Bh() {
    delete pDNS_Bh;
    pDNS_Bh = NULL;
}

Initiator_and_dns::pDNS_Bw_C* Initiator_and_dns::getPDNS_Bw() const {
    return pDNS_Bw;
}

Initiator_and_dns::pDNS_Bw_C* Initiator_and_dns::get_pDNS_Bw() const {
    return pDNS_Bw;
}

Initiator_and_dns::pDNS_Bw_C* Initiator_and_dns::newPDNS_Bw() {
    pDNS_Bw = new Initiator_and_dns::pDNS_Bw_C;
    return pDNS_Bw;
}

void Initiator_and_dns::deletePDNS_Bw() {
    delete pDNS_Bw;
    pDNS_Bw = NULL;
}

Initiator_and_dns::pDNS_C_C* Initiator_and_dns::getPDNS_C() const {
    return pDNS_C;
}

Initiator_and_dns::pDNS_C_C* Initiator_and_dns::get_pDNS_C() const {
    return pDNS_C;
}

Initiator_and_dns::pDNS_C_C* Initiator_and_dns::newPDNS_C() {
    pDNS_C = new Initiator_and_dns::pDNS_C_C;
    return pDNS_C;
}

void Initiator_and_dns::deletePDNS_C() {
    delete pDNS_C;
    pDNS_C = NULL;
}

void Initiator_and_dns::add_dns_entry(char* address, char* portName) {
    NOTIFY_OPERATION(add_dns_entry, add_dns_entry(char*,char*), 2, sip_Initiator_and_dns_add_dns_entry_SERIALIZE);
    //#[ operation add_dns_entry(char*,char*) 
    for (i = 0; i < nbEntries ; i++)
    {
    	if (dnsTable.Array[i][0] == address)
    		{
    		dnsTable.Array[i][1] = portName;
    		return;
    		}
    }
    
    nbEntries++;
    dnsTable.Array[nbEntries - 1][0] = address;
    dnsTable.Array[nbEntries - 1][1] = portName;
    return;
    
    //#]
}

char* Initiator_and_dns::searchDNSEntry(const OMString& arg) {
    NOTIFY_OPERATION(searchDNSEntry, searchDNSEntry(OMString), 1, sip_Initiator_and_dns_searchDNSEntry_SERIALIZE);
    //#[ operation searchDNSEntry(OMString) 
    for (i = 0; i < nbEntries ; i++)
    {
    	if (dnsTable.Array[i][0] == arg)
    		return(dnsTable.Array[i][1]);
    }
    
    
    //#]
}

OMString Initiator_and_dns::getAddress() const {
    return address;
}

void Initiator_and_dns::setAddress(OMString p_address) {
    address = p_address;
}

dns_table_type Initiator_and_dns::getDnsTable() const {
    return dnsTable;
}

void Initiator_and_dns::setDnsTable(dns_table_type p_dnsTable) {
    dnsTable = p_dnsTable;
}

int Initiator_and_dns::getI() const {
    return i;
}

void Initiator_and_dns::setI(int p_i) {
    i = p_i;
}

int Initiator_and_dns::getNbEntries() const {
    return nbEntries;
}

void Initiator_and_dns::setNbEntries(int p_nbEntries) {
    nbEntries = p_nbEntries;
}

char* Initiator_and_dns::getPortName() const {
    return portName;
}

void Initiator_and_dns::setPortName(char* p_portName) {
    portName = p_portName;
}

void Initiator_and_dns::rootState_entDef() {
    {
        NOTIFY_STATE_ENTERED("ROOT");
        rootStateEntDef();
    }
}

IOxfReactive::TakeEventStatus Initiator_and_dns::rootState_processEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    switch (rootState_active) {
        case AllAckReceived:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("22");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.AllAckReceived");
                    WaitForDNSQueries_entDef();
                    NOTIFY_TRANSITION_TERMINATED("22");
                    res = eventConsumed;
                }
            
            
            break;
        }
        case Initializing:
        {
            res = Initializing_processEvent();
            break;
        }
        case WaitForDNSQuery:
        {
            res = WaitForDNSQuery_handleEvent();
            break;
        }
        case DNSQueryReceivedA:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitForDNSQueries.2");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.WaitForDNSQueries.ROOT.WaitForDNSQueries.DNSQueryReceivedA");
                    //#[ transition ROOT.mainState.WaitForDNSQueries.2 
                    portName = searchDNSEntry(address);
                    OUT_PORT(pDNS_A)->GEN(evDNSLookupRes(portName));
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.WaitForDNSQueries.ROOT.WaitForDNSQueries.DNSEntrySentA");
                    pushNullTransition();
                    WaitForDNSQueries_subState = DNSEntrySentA;
                    rootState_active = DNSEntrySentA;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitForDNSQueries.2");
                    res = eventConsumed;
                }
            
            
            break;
        }
        case DNSEntrySentA:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitForDNSQueries.11");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.WaitForDNSQueries.ROOT.WaitForDNSQueries.DNSEntrySentA");
                    NOTIFY_STATE_ENTERED("ROOT.mainState.WaitForDNSQueries.ROOT.WaitForDNSQueries.WaitForDNSQuery");
                    WaitForDNSQueries_subState = WaitForDNSQuery;
                    rootState_active = WaitForDNSQuery;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitForDNSQueries.11");
                    res = eventConsumed;
                }
            
            
            break;
        }
        case DNSQueryReceivedBh:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitForDNSQueries.4");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.WaitForDNSQueries.ROOT.WaitForDNSQueries.DNSQueryReceivedBh");
                    //#[ transition ROOT.mainState.WaitForDNSQueries.4 
                    portName = searchDNSEntry(address);
                    OUT_PORT(pDNS_Bh)->GEN(evDNSLookupRes(portName));
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.WaitForDNSQueries.ROOT.WaitForDNSQueries.DNSEntrySentBh");
                    pushNullTransition();
                    WaitForDNSQueries_subState = DNSEntrySentBh;
                    rootState_active = DNSEntrySentBh;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitForDNSQueries.4");
                    res = eventConsumed;
                }
            
            
            break;
        }
        case DNSQueryReceivedBw:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitForDNSQueries.8");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.WaitForDNSQueries.ROOT.WaitForDNSQueries.DNSQueryReceivedBw");
                    //#[ transition ROOT.mainState.WaitForDNSQueries.8 
                    portName = searchDNSEntry(address);
                    OUT_PORT(pDNS_Bw)->GEN(evDNSLookupRes(portName));
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.WaitForDNSQueries.ROOT.WaitForDNSQueries.DNSEntrySentBw");
                    pushNullTransition();
                    WaitForDNSQueries_subState = DNSEntrySentBw;
                    rootState_active = DNSEntrySentBw;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitForDNSQueries.8");
                    res = eventConsumed;
                }
            
            
            break;
        }
        case DNSEntrySentBh:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitForDNSQueries.12");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.WaitForDNSQueries.ROOT.WaitForDNSQueries.DNSEntrySentBh");
                    NOTIFY_STATE_ENTERED("ROOT.mainState.WaitForDNSQueries.ROOT.WaitForDNSQueries.WaitForDNSQuery");
                    WaitForDNSQueries_subState = WaitForDNSQuery;
                    rootState_active = WaitForDNSQuery;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitForDNSQueries.12");
                    res = eventConsumed;
                }
            
            
            break;
        }
        case DNSEntrySentC:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitForDNSQueries.14");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.WaitForDNSQueries.ROOT.WaitForDNSQueries.DNSEntrySentC");
                    NOTIFY_STATE_ENTERED("ROOT.mainState.WaitForDNSQueries.ROOT.WaitForDNSQueries.WaitForDNSQuery");
                    WaitForDNSQueries_subState = WaitForDNSQuery;
                    rootState_active = WaitForDNSQuery;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitForDNSQueries.14");
                    res = eventConsumed;
                }
            
            
            break;
        }
        case DNSQueryReceivedC:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitForDNSQueries.9");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.WaitForDNSQueries.ROOT.WaitForDNSQueries.DNSQueryReceivedC");
                    //#[ transition ROOT.mainState.WaitForDNSQueries.9 
                    portName = searchDNSEntry(address);
                    OUT_PORT(pDNS_C)->GEN(evDNSLookupRes(portName));
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.WaitForDNSQueries.ROOT.WaitForDNSQueries.DNSEntrySentC");
                    pushNullTransition();
                    WaitForDNSQueries_subState = DNSEntrySentC;
                    rootState_active = DNSEntrySentC;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitForDNSQueries.9");
                    res = eventConsumed;
                }
            
            
            break;
        }
        case DNSEntrySentBw:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitForDNSQueries.13");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.WaitForDNSQueries.ROOT.WaitForDNSQueries.DNSEntrySentBw");
                    NOTIFY_STATE_ENTERED("ROOT.mainState.WaitForDNSQueries.ROOT.WaitForDNSQueries.WaitForDNSQuery");
                    WaitForDNSQueries_subState = WaitForDNSQuery;
                    rootState_active = WaitForDNSQuery;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitForDNSQueries.13");
                    res = eventConsumed;
                }
            
            
            break;
        }
        case DNSEntrySentServer:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitForDNSQueries.15");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.WaitForDNSQueries.ROOT.WaitForDNSQueries.DNSEntrySentServer");
                    NOTIFY_STATE_ENTERED("ROOT.mainState.WaitForDNSQueries.ROOT.WaitForDNSQueries.WaitForDNSQuery");
                    WaitForDNSQueries_subState = WaitForDNSQuery;
                    rootState_active = WaitForDNSQuery;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitForDNSQueries.15");
                    res = eventConsumed;
                }
            
            
            break;
        }
        case DNSQueryReceivedServer:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitForDNSQueries.10");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.WaitForDNSQueries.ROOT.WaitForDNSQueries.DNSQueryReceivedServer");
                    //#[ transition ROOT.mainState.WaitForDNSQueries.10 
                    portName = searchDNSEntry(address);
                    OUT_PORT(pDNSServer)->GEN(evDNSLookupRes(portName));
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.WaitForDNSQueries.ROOT.WaitForDNSQueries.DNSEntrySentServer");
                    pushNullTransition();
                    WaitForDNSQueries_subState = DNSEntrySentServer;
                    rootState_active = DNSEntrySentServer;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitForDNSQueries.10");
                    res = eventConsumed;
                }
            
            
            break;
        }
        default:
            break;
    }
    return res;
}

IOxfReactive::TakeEventStatus Initiator_and_dns::Initializing_processEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(state_61_processEvent() > 0)
        {
            res = eventConsumed;
            if(!IS_IN(Initializing))
                {
                    return res;
                }
        }
    if(state_15_processEvent() > 0)
        {
            res = eventConsumed;
            if(!IS_IN(Initializing))
                {
                    return res;
                }
        }
    if(state_16_processEvent() > 0)
        {
            res = eventConsumed;
            if(!IS_IN(Initializing))
                {
                    return res;
                }
        }
    if(state_20_processEvent() > 0)
        {
            res = eventConsumed;
            if(!IS_IN(Initializing))
                {
                    return res;
                }
        }
    if(state_21_processEvent() > 0)
        {
            res = eventConsumed;
            if(!IS_IN(Initializing))
                {
                    return res;
                }
        }
    
    return res;
}

IOxfReactive::TakeEventStatus Initiator_and_dns::state_61_processEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    switch (state_61_active) {
        case Ack:
        {
            res = Ack_handleEvent();
            break;
        }
        case SentToC:
        {
            if(IS_EVENT_TYPE_OF(evRes_init_sip_id))
                {
                    OMSETPARAMS(evRes_init);
                    //## transition 21 
                    if(IS_PORT(pDNS_C))
                        {
                            NOTIFY_TRANSITION_STARTED("21");
                            NOTIFY_STATE_EXITED("ROOT.mainState.Initializing.state_61.SentToC");
                            NOTIFY_STATE_ENTERED("ROOT.mainState.Initializing.state_61.Ack");
                            pushNullTransition();
                            state_61_subState = Ack;
                            state_61_active = Ack;
                            NOTIFY_TRANSITION_TERMINATED("21");
                            res = eventConsumed;
                        }
                }
            
            
            break;
        }
        case SendingToC:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("17");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.Initializing.state_61.SendingToC");
                    //#[ transition 17 
                    OUT_PORT(pDNS_C)->GEN(evInitialization("c.enst.fr", ""));
                    add_dns_entry("c.enst.fr", "pC");
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.Initializing.state_61.SentToC");
                    state_61_subState = SentToC;
                    state_61_active = SentToC;
                    NOTIFY_TRANSITION_TERMINATED("17");
                    res = eventConsumed;
                }
            
            
            break;
        }
        default:
            break;
    }
    return res;
}

IOxfReactive::TakeEventStatus Initiator_and_dns::state_21_processEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    switch (state_21_active) {
        case state_21_Ack:
        {
            res = state_21_Ack_handleEvent();
            break;
        }
        case SentToBw:
        {
            if(IS_EVENT_TYPE_OF(evRes_init_sip_id))
                {
                    OMSETPARAMS(evRes_init);
                    //## transition 20 
                    if(IS_PORT(pDNS_Bw))
                        {
                            NOTIFY_TRANSITION_STARTED("20");
                            NOTIFY_STATE_EXITED("ROOT.mainState.Initializing.state_21.SentToBw");
                            NOTIFY_STATE_ENTERED("ROOT.mainState.Initializing.state_21.Ack");
                            pushNullTransition();
                            state_21_subState = state_21_Ack;
                            state_21_active = state_21_Ack;
                            NOTIFY_TRANSITION_TERMINATED("20");
                            res = eventConsumed;
                        }
                }
            
            
            break;
        }
        case SendingToBw:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("16");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.Initializing.state_21.SendingToBw");
                    //#[ transition 16 
                    OUT_PORT(pDNS_Bw)->GEN(evInitialization("work.enst.fr", ""));
                    add_dns_entry("work.enst.fr", "pBw");
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.Initializing.state_21.SentToBw");
                    state_21_subState = SentToBw;
                    state_21_active = SentToBw;
                    NOTIFY_TRANSITION_TERMINATED("16");
                    res = eventConsumed;
                }
            
            
            break;
        }
        default:
            break;
    }
    return res;
}

IOxfReactive::TakeEventStatus Initiator_and_dns::state_20_processEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    switch (state_20_active) {
        case state_20_Ack:
        {
            res = state_20_Ack_handleEvent();
            break;
        }
        case SentToBh:
        {
            if(IS_EVENT_TYPE_OF(evRes_init_sip_id))
                {
                    OMSETPARAMS(evRes_init);
                    //## transition 19 
                    if(IS_PORT(pDNS_Bh))
                        {
                            NOTIFY_TRANSITION_STARTED("19");
                            NOTIFY_STATE_EXITED("ROOT.mainState.Initializing.state_20.SentToBh");
                            NOTIFY_STATE_ENTERED("ROOT.mainState.Initializing.state_20.Ack");
                            pushNullTransition();
                            state_20_subState = state_20_Ack;
                            state_20_active = state_20_Ack;
                            NOTIFY_TRANSITION_TERMINATED("19");
                            res = eventConsumed;
                        }
                }
            
            
            break;
        }
        case SendingToBh:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("15");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.Initializing.state_20.SendingToBh");
                    //#[ transition 15 
                    OUT_PORT(pDNS_Bh)->GEN(evInitialization("home.isp.fr", ""));
                    add_dns_entry("home.isp.fr", "pBh");
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.Initializing.state_20.SentToBh");
                    state_20_subState = SentToBh;
                    state_20_active = SentToBh;
                    NOTIFY_TRANSITION_TERMINATED("15");
                    res = eventConsumed;
                }
            
            
            break;
        }
        default:
            break;
    }
    return res;
}

IOxfReactive::TakeEventStatus Initiator_and_dns::state_16_processEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    switch (state_16_active) {
        case state_16_Ack:
        {
            res = state_16_Ack_handleEvent();
            break;
        }
        case SentToA:
        {
            if(IS_EVENT_TYPE_OF(evRes_init_sip_id))
                {
                    OMSETPARAMS(evRes_init);
                    //## transition 18 
                    if(IS_PORT(pDNS_A))
                        {
                            NOTIFY_TRANSITION_STARTED("18");
                            NOTIFY_STATE_EXITED("ROOT.mainState.Initializing.state_16.SentToA");
                            NOTIFY_STATE_ENTERED("ROOT.mainState.Initializing.state_16.Ack");
                            pushNullTransition();
                            state_16_subState = state_16_Ack;
                            state_16_active = state_16_Ack;
                            NOTIFY_TRANSITION_TERMINATED("18");
                            res = eventConsumed;
                        }
                }
            
            
            break;
        }
        case SendingToA:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("5");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.Initializing.state_16.SendingToA");
                    //#[ transition 5 
                    OUT_PORT(pDNS_A)->GEN(evInitialization("a.enst.fr", ""));
                    add_dns_entry("a.enst.fr", "pA");
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.Initializing.state_16.SentToA");
                    state_16_subState = SentToA;
                    state_16_active = SentToA;
                    NOTIFY_TRANSITION_TERMINATED("5");
                    res = eventConsumed;
                }
            
            
            break;
        }
        default:
            break;
    }
    return res;
}

IOxfReactive::TakeEventStatus Initiator_and_dns::state_15_processEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    switch (state_15_active) {
        case state_15_Ack:
        {
            res = state_15_Ack_handleEvent();
            break;
        }
        case SentToServer:
        {
            if(IS_EVENT_TYPE_OF(evRes_init_sip_id))
                {
                    OMSETPARAMS(evRes_init);
                    //## transition 8 
                    if(IS_PORT(pDNSServer))
                        {
                            NOTIFY_TRANSITION_STARTED("8");
                            NOTIFY_STATE_EXITED("ROOT.mainState.Initializing.state_15.SentToServer");
                            NOTIFY_STATE_ENTERED("ROOT.mainState.Initializing.state_15.Ack");
                            pushNullTransition();
                            state_15_subState = state_15_Ack;
                            state_15_active = state_15_Ack;
                            NOTIFY_TRANSITION_TERMINATED("8");
                            res = eventConsumed;
                        }
                }
            
            
            break;
        }
        case SendingToSever:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("1");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.mainState.Initializing.state_15.SendingToSever");
                    //#[ transition 1 
                    OUT_PORT(pDNSServer)->GEN(evInitialization("sip.enst.fr", ""));
                    add_dns_entry("sip.enst.fr", "pServer");
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.Initializing.state_15.SentToServer");
                    state_15_subState = SentToServer;
                    state_15_active = SentToServer;
                    NOTIFY_TRANSITION_TERMINATED("1");
                    res = eventConsumed;
                }
            
            
            break;
        }
        default:
            break;
    }
    return res;
}

void Initiator_and_dns::initRelations() {
    pDNSServer = newPDNSServer();
    pDNS_A = newPDNS_A();
    pDNS_Bh = newPDNS_Bh();
    pDNS_Bw = newPDNS_Bw();
    pDNS_C = newPDNS_C();
    if(getPDNSServer())
       getPDNSServer()->connectInitiator_and_dns(this);
    if(getPDNS_A())
       getPDNS_A()->connectInitiator_and_dns(this);
    if(getPDNS_Bh())
       getPDNS_Bh()->connectInitiator_and_dns(this);
    if(getPDNS_Bw())
       getPDNS_Bw()->connectInitiator_and_dns(this);
    if(getPDNS_C())
       getPDNS_C()->connectInitiator_and_dns(this);
}

void Initiator_and_dns::initStatechart() {
    rootState_subState = OMNonState;
    rootState_active = OMNonState;
    mainState_subState = OMNonState;
    WaitForDNSQueries_subState = OMNonState;
    state_61_subState = OMNonState;
    state_61_active = OMNonState;
    state_21_subState = OMNonState;
    state_21_active = OMNonState;
    state_20_subState = OMNonState;
    state_20_active = OMNonState;
    state_16_subState = OMNonState;
    state_16_active = OMNonState;
    state_15_subState = OMNonState;
    state_15_active = OMNonState;
}

void Initiator_and_dns::cleanUpRelations() {
    {
        deletePDNS_C();
    }
    {
        deletePDNS_Bw();
    }
    {
        deletePDNS_Bh();
    }
    {
        deletePDNS_A();
    }
    {
        deletePDNSServer();
    }
}

bool Initiator_and_dns::startBehavior() {
    bool done = false;
    done = OMReactive::startBehavior();
    return done;
}

IOxfReactive::TakeEventStatus Initiator_and_dns::state_16_AckTakeNull() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    //## transition 14 
    if(IS_IN(state_15_Ack) && IS_IN(state_20_Ack) && IS_IN(state_21_Ack) && IS_IN(Ack))
        {
            NOTIFY_TRANSITION_STARTED("14");
            NOTIFY_TRANSITION_STARTED("9");
            NOTIFY_TRANSITION_STARTED("10");
            NOTIFY_TRANSITION_STARTED("11");
            NOTIFY_TRANSITION_STARTED("12");
            NOTIFY_TRANSITION_STARTED("13");
            Initializing_exit();
            NOTIFY_STATE_ENTERED("ROOT.mainState.AllAckReceived");
            pushNullTransition();
            mainState_subState = AllAckReceived;
            rootState_active = AllAckReceived;
            NOTIFY_TRANSITION_TERMINATED("13");
            NOTIFY_TRANSITION_TERMINATED("12");
            NOTIFY_TRANSITION_TERMINATED("11");
            NOTIFY_TRANSITION_TERMINATED("10");
            NOTIFY_TRANSITION_TERMINATED("9");
            NOTIFY_TRANSITION_TERMINATED("14");
            res = eventConsumed;
        }
    return res;
}

IOxfReactive::TakeEventStatus Initiator_and_dns::state_20_AckTakeNull() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    //## transition 14 
    if(IS_IN(state_15_Ack) && IS_IN(state_16_Ack) && IS_IN(state_21_Ack) && IS_IN(Ack))
        {
            NOTIFY_TRANSITION_STARTED("14");
            NOTIFY_TRANSITION_STARTED("9");
            NOTIFY_TRANSITION_STARTED("10");
            NOTIFY_TRANSITION_STARTED("11");
            NOTIFY_TRANSITION_STARTED("12");
            NOTIFY_TRANSITION_STARTED("13");
            Initializing_exit();
            NOTIFY_STATE_ENTERED("ROOT.mainState.AllAckReceived");
            pushNullTransition();
            mainState_subState = AllAckReceived;
            rootState_active = AllAckReceived;
            NOTIFY_TRANSITION_TERMINATED("13");
            NOTIFY_TRANSITION_TERMINATED("12");
            NOTIFY_TRANSITION_TERMINATED("11");
            NOTIFY_TRANSITION_TERMINATED("10");
            NOTIFY_TRANSITION_TERMINATED("9");
            NOTIFY_TRANSITION_TERMINATED("14");
            res = eventConsumed;
        }
    return res;
}

IOxfReactive::TakeEventStatus Initiator_and_dns::Ack_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(OMNullEventId))
        {
            res = AckTakeNull();
        }
    
    
    return res;
}

void Initiator_and_dns::mainState_entDef() {
    NOTIFY_STATE_ENTERED("ROOT.mainState");
    rootState_subState = mainState;
    mainStateEntDef();
}

void Initiator_and_dns::state_16_entDef() {
    NOTIFY_STATE_ENTERED("ROOT.mainState.Initializing.state_16");
    NOTIFY_TRANSITION_STARTED("6");
    NOTIFY_STATE_ENTERED("ROOT.mainState.Initializing.state_16.SendingToA");
    pushNullTransition();
    state_16_subState = SendingToA;
    state_16_active = SendingToA;
    NOTIFY_TRANSITION_TERMINATED("6");
}

void Initiator_and_dns::state_21_entDef() {
    NOTIFY_STATE_ENTERED("ROOT.mainState.Initializing.state_21");
    NOTIFY_TRANSITION_STARTED("3");
    NOTIFY_STATE_ENTERED("ROOT.mainState.Initializing.state_21.SendingToBw");
    pushNullTransition();
    state_21_subState = SendingToBw;
    state_21_active = SendingToBw;
    NOTIFY_TRANSITION_TERMINATED("3");
}

IOxfReactive::TakeEventStatus Initiator_and_dns::AckTakeNull() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    //## transition 14 
    if(IS_IN(state_15_Ack) && IS_IN(state_16_Ack) && IS_IN(state_20_Ack) && IS_IN(state_21_Ack))
        {
            NOTIFY_TRANSITION_STARTED("14");
            NOTIFY_TRANSITION_STARTED("9");
            NOTIFY_TRANSITION_STARTED("10");
            NOTIFY_TRANSITION_STARTED("11");
            NOTIFY_TRANSITION_STARTED("12");
            NOTIFY_TRANSITION_STARTED("13");
            Initializing_exit();
            NOTIFY_STATE_ENTERED("ROOT.mainState.AllAckReceived");
            pushNullTransition();
            mainState_subState = AllAckReceived;
            rootState_active = AllAckReceived;
            NOTIFY_TRANSITION_TERMINATED("13");
            NOTIFY_TRANSITION_TERMINATED("12");
            NOTIFY_TRANSITION_TERMINATED("11");
            NOTIFY_TRANSITION_TERMINATED("10");
            NOTIFY_TRANSITION_TERMINATED("9");
            NOTIFY_TRANSITION_TERMINATED("14");
            res = eventConsumed;
        }
    return res;
}

IOxfReactive::TakeEventStatus Initiator_and_dns::state_21_Ack_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(OMNullEventId))
        {
            res = state_21_AckTakeNull();
        }
    
    
    return res;
}

IOxfReactive::TakeEventStatus Initiator_and_dns::WaitForDNSQuery_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(evDNSLookup_sip_id))
        {
            res = WaitForDNSQueryTakeevDNSLookup();
        }
    
    
    return res;
}

IOxfReactive::TakeEventStatus Initiator_and_dns::WaitForDNSQueryTakeevDNSLookup() {
    OMSETPARAMS(evDNSLookup);
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    //## transition ROOT.mainState.WaitForDNSQueries.1 
    if(IS_PORT(pDNS_A))
        {
            NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitForDNSQueries.1");
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitForDNSQueries.ROOT.WaitForDNSQueries.WaitForDNSQuery");
            //#[ transition ROOT.mainState.WaitForDNSQueries.1 
            
            address = params->domain;
            //#]
            NOTIFY_STATE_ENTERED("ROOT.mainState.WaitForDNSQueries.ROOT.WaitForDNSQueries.DNSQueryReceivedA");
            pushNullTransition();
            WaitForDNSQueries_subState = DNSQueryReceivedA;
            rootState_active = DNSQueryReceivedA;
            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitForDNSQueries.1");
            res = eventConsumed;
        }
    else
        {
            //## transition ROOT.mainState.WaitForDNSQueries.3 
            if(IS_PORT(pDNS_Bh))
                {
                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitForDNSQueries.3");
                    NOTIFY_STATE_EXITED("ROOT.mainState.WaitForDNSQueries.ROOT.WaitForDNSQueries.WaitForDNSQuery");
                    //#[ transition ROOT.mainState.WaitForDNSQueries.3 
                    
                    address = params->domain;
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.mainState.WaitForDNSQueries.ROOT.WaitForDNSQueries.DNSQueryReceivedBh");
                    pushNullTransition();
                    WaitForDNSQueries_subState = DNSQueryReceivedBh;
                    rootState_active = DNSQueryReceivedBh;
                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitForDNSQueries.3");
                    res = eventConsumed;
                }
            else
                {
                    //## transition ROOT.mainState.WaitForDNSQueries.5 
                    if(IS_PORT(pDNS_Bw))
                        {
                            NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitForDNSQueries.5");
                            NOTIFY_STATE_EXITED("ROOT.mainState.WaitForDNSQueries.ROOT.WaitForDNSQueries.WaitForDNSQuery");
                            //#[ transition ROOT.mainState.WaitForDNSQueries.5 
                            
                            address = params->domain;
                            //#]
                            NOTIFY_STATE_ENTERED("ROOT.mainState.WaitForDNSQueries.ROOT.WaitForDNSQueries.DNSQueryReceivedBw");
                            pushNullTransition();
                            WaitForDNSQueries_subState = DNSQueryReceivedBw;
                            rootState_active = DNSQueryReceivedBw;
                            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitForDNSQueries.5");
                            res = eventConsumed;
                        }
                    else
                        {
                            //## transition ROOT.mainState.WaitForDNSQueries.6 
                            if(IS_PORT(pDNS_C))
                                {
                                    NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitForDNSQueries.6");
                                    NOTIFY_STATE_EXITED("ROOT.mainState.WaitForDNSQueries.ROOT.WaitForDNSQueries.WaitForDNSQuery");
                                    //#[ transition ROOT.mainState.WaitForDNSQueries.6 
                                    
                                    address = params->domain;
                                    //#]
                                    NOTIFY_STATE_ENTERED("ROOT.mainState.WaitForDNSQueries.ROOT.WaitForDNSQueries.DNSQueryReceivedC");
                                    pushNullTransition();
                                    WaitForDNSQueries_subState = DNSQueryReceivedC;
                                    rootState_active = DNSQueryReceivedC;
                                    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitForDNSQueries.6");
                                    res = eventConsumed;
                                }
                            else
                                {
                                    //## transition ROOT.mainState.WaitForDNSQueries.7 
                                    if(IS_PORT(pDNSServer))
                                        {
                                            NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitForDNSQueries.7");
                                            NOTIFY_STATE_EXITED("ROOT.mainState.WaitForDNSQueries.ROOT.WaitForDNSQueries.WaitForDNSQuery");
                                            //#[ transition ROOT.mainState.WaitForDNSQueries.7 
                                            
                                            address = params->domain;
                                            //#]
                                            NOTIFY_STATE_ENTERED("ROOT.mainState.WaitForDNSQueries.ROOT.WaitForDNSQueries.DNSQueryReceivedServer");
                                            pushNullTransition();
                                            WaitForDNSQueries_subState = DNSQueryReceivedServer;
                                            rootState_active = DNSQueryReceivedServer;
                                            NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitForDNSQueries.7");
                                            res = eventConsumed;
                                        }
                                }
                        }
                }
        }
    return res;
}

IOxfReactive::TakeEventStatus Initiator_and_dns::state_16_Ack_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(OMNullEventId))
        {
            res = state_16_AckTakeNull();
        }
    
    
    return res;
}

void Initiator_and_dns::state_61_entDef() {
    NOTIFY_STATE_ENTERED("ROOT.mainState.Initializing.state_61");
    NOTIFY_TRANSITION_STARTED("7");
    NOTIFY_STATE_ENTERED("ROOT.mainState.Initializing.state_61.SendingToC");
    pushNullTransition();
    state_61_subState = SendingToC;
    state_61_active = SendingToC;
    NOTIFY_TRANSITION_TERMINATED("7");
}

void Initiator_and_dns::Initializing_exit() {
    switch (state_61_subState) {
        case Ack:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.Initializing.state_61.Ack");
            break;
        }
        case SentToC:
        {
            NOTIFY_STATE_EXITED("ROOT.mainState.Initializing.state_61.SentToC");
            break;
        }
        case SendingToC:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.Initializing.state_61.SendingToC");
            break;
        }
        default:
            break;
    }
    state_61_subState = OMNonState;
    NOTIFY_STATE_EXITED("ROOT.mainState.Initializing.state_61");
    switch (state_15_subState) {
        case state_15_Ack:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.Initializing.state_15.Ack");
            break;
        }
        case SentToServer:
        {
            NOTIFY_STATE_EXITED("ROOT.mainState.Initializing.state_15.SentToServer");
            break;
        }
        case SendingToSever:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.Initializing.state_15.SendingToSever");
            break;
        }
        default:
            break;
    }
    state_15_subState = OMNonState;
    NOTIFY_STATE_EXITED("ROOT.mainState.Initializing.state_15");
    switch (state_16_subState) {
        case state_16_Ack:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.Initializing.state_16.Ack");
            break;
        }
        case SentToA:
        {
            NOTIFY_STATE_EXITED("ROOT.mainState.Initializing.state_16.SentToA");
            break;
        }
        case SendingToA:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.Initializing.state_16.SendingToA");
            break;
        }
        default:
            break;
    }
    state_16_subState = OMNonState;
    NOTIFY_STATE_EXITED("ROOT.mainState.Initializing.state_16");
    switch (state_20_subState) {
        case state_20_Ack:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.Initializing.state_20.Ack");
            break;
        }
        case SentToBh:
        {
            NOTIFY_STATE_EXITED("ROOT.mainState.Initializing.state_20.SentToBh");
            break;
        }
        case SendingToBh:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.Initializing.state_20.SendingToBh");
            break;
        }
        default:
            break;
    }
    state_20_subState = OMNonState;
    NOTIFY_STATE_EXITED("ROOT.mainState.Initializing.state_20");
    switch (state_21_subState) {
        case state_21_Ack:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.Initializing.state_21.Ack");
            break;
        }
        case SentToBw:
        {
            NOTIFY_STATE_EXITED("ROOT.mainState.Initializing.state_21.SentToBw");
            break;
        }
        case SendingToBw:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.Initializing.state_21.SendingToBw");
            break;
        }
        default:
            break;
    }
    state_21_subState = OMNonState;
    NOTIFY_STATE_EXITED("ROOT.mainState.Initializing.state_21");
    NOTIFY_STATE_EXITED("ROOT.mainState.Initializing");
}

IOxfReactive::TakeEventStatus Initiator_and_dns::state_21_AckTakeNull() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    //## transition 14 
    if(IS_IN(state_15_Ack) && IS_IN(state_16_Ack) && IS_IN(state_20_Ack) && IS_IN(Ack))
        {
            NOTIFY_TRANSITION_STARTED("14");
            NOTIFY_TRANSITION_STARTED("9");
            NOTIFY_TRANSITION_STARTED("10");
            NOTIFY_TRANSITION_STARTED("11");
            NOTIFY_TRANSITION_STARTED("12");
            NOTIFY_TRANSITION_STARTED("13");
            Initializing_exit();
            NOTIFY_STATE_ENTERED("ROOT.mainState.AllAckReceived");
            pushNullTransition();
            mainState_subState = AllAckReceived;
            rootState_active = AllAckReceived;
            NOTIFY_TRANSITION_TERMINATED("13");
            NOTIFY_TRANSITION_TERMINATED("12");
            NOTIFY_TRANSITION_TERMINATED("11");
            NOTIFY_TRANSITION_TERMINATED("10");
            NOTIFY_TRANSITION_TERMINATED("9");
            NOTIFY_TRANSITION_TERMINATED("14");
            res = eventConsumed;
        }
    return res;
}

IOxfReactive::TakeEventStatus Initiator_and_dns::state_20_Ack_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(OMNullEventId))
        {
            res = state_20_AckTakeNull();
        }
    
    
    return res;
}

void Initiator_and_dns::Initializing_entDef() {
    NOTIFY_STATE_ENTERED("ROOT.mainState.Initializing");
    mainState_subState = Initializing;
    rootState_active = Initializing;
    state_61_entDef();
    state_15_entDef();
    state_16_entDef();
    state_20_entDef();
    state_21_entDef();
}

void Initiator_and_dns::rootStateEntDef() {
    mainState_entDef();
}

IOxfReactive::TakeEventStatus Initiator_and_dns::state_15_Ack_handleEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    if(IS_EVENT_TYPE_OF(OMNullEventId))
        {
            res = state_15_AckTakeNull();
        }
    
    
    return res;
}

IOxfReactive::TakeEventStatus Initiator_and_dns::state_15_AckTakeNull() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    //## transition 14 
    if(IS_IN(state_16_Ack) && IS_IN(state_20_Ack) && IS_IN(state_21_Ack) && IS_IN(Ack))
        {
            NOTIFY_TRANSITION_STARTED("14");
            NOTIFY_TRANSITION_STARTED("9");
            NOTIFY_TRANSITION_STARTED("10");
            NOTIFY_TRANSITION_STARTED("11");
            NOTIFY_TRANSITION_STARTED("12");
            NOTIFY_TRANSITION_STARTED("13");
            Initializing_exit();
            NOTIFY_STATE_ENTERED("ROOT.mainState.AllAckReceived");
            pushNullTransition();
            mainState_subState = AllAckReceived;
            rootState_active = AllAckReceived;
            NOTIFY_TRANSITION_TERMINATED("13");
            NOTIFY_TRANSITION_TERMINATED("12");
            NOTIFY_TRANSITION_TERMINATED("11");
            NOTIFY_TRANSITION_TERMINATED("10");
            NOTIFY_TRANSITION_TERMINATED("9");
            NOTIFY_TRANSITION_TERMINATED("14");
            res = eventConsumed;
        }
    return res;
}

void Initiator_and_dns::WaitForDNSQueries_entDef() {
    NOTIFY_STATE_ENTERED("ROOT.mainState.WaitForDNSQueries");
    mainState_subState = WaitForDNSQueries;
    NOTIFY_TRANSITION_STARTED("ROOT.mainState.WaitForDNSQueries.0");
    NOTIFY_STATE_ENTERED("ROOT.mainState.WaitForDNSQueries.ROOT.WaitForDNSQueries.WaitForDNSQuery");
    WaitForDNSQueries_subState = WaitForDNSQuery;
    rootState_active = WaitForDNSQuery;
    NOTIFY_TRANSITION_TERMINATED("ROOT.mainState.WaitForDNSQueries.0");
}

void Initiator_and_dns::state_15_entDef() {
    NOTIFY_STATE_ENTERED("ROOT.mainState.Initializing.state_15");
    NOTIFY_TRANSITION_STARTED("4");
    NOTIFY_STATE_ENTERED("ROOT.mainState.Initializing.state_15.SendingToSever");
    pushNullTransition();
    state_15_subState = SendingToSever;
    state_15_active = SendingToSever;
    NOTIFY_TRANSITION_TERMINATED("4");
}

void Initiator_and_dns::state_20_entDef() {
    NOTIFY_STATE_ENTERED("ROOT.mainState.Initializing.state_20");
    NOTIFY_TRANSITION_STARTED("2");
    NOTIFY_STATE_ENTERED("ROOT.mainState.Initializing.state_20.SendingToBh");
    pushNullTransition();
    state_20_subState = SendingToBh;
    state_20_active = SendingToBh;
    NOTIFY_TRANSITION_TERMINATED("2");
}

void Initiator_and_dns::mainStateEntDef() {
    NOTIFY_TRANSITION_STARTED("0");
    NOTIFY_STATE_ENTERED("ROOT.mainState.Initializing");
    mainState_subState = Initializing;
    rootState_active = Initializing;
    state_61_entDef();
    state_16_entDef();
    state_20_entDef();
    state_21_entDef();
    state_15_entDef();
    NOTIFY_TRANSITION_TERMINATED("0");
}

void Initiator_and_dns::WaitForDNSQueries_exit() {
    switch (WaitForDNSQueries_subState) {
        case WaitForDNSQuery:
        {
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitForDNSQueries.ROOT.WaitForDNSQueries.WaitForDNSQuery");
            break;
        }
        case DNSQueryReceivedA:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitForDNSQueries.ROOT.WaitForDNSQueries.DNSQueryReceivedA");
            break;
        }
        case DNSEntrySentA:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitForDNSQueries.ROOT.WaitForDNSQueries.DNSEntrySentA");
            break;
        }
        case DNSQueryReceivedBh:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitForDNSQueries.ROOT.WaitForDNSQueries.DNSQueryReceivedBh");
            break;
        }
        case DNSQueryReceivedBw:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitForDNSQueries.ROOT.WaitForDNSQueries.DNSQueryReceivedBw");
            break;
        }
        case DNSEntrySentBh:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitForDNSQueries.ROOT.WaitForDNSQueries.DNSEntrySentBh");
            break;
        }
        case DNSEntrySentC:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitForDNSQueries.ROOT.WaitForDNSQueries.DNSEntrySentC");
            break;
        }
        case DNSQueryReceivedC:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitForDNSQueries.ROOT.WaitForDNSQueries.DNSQueryReceivedC");
            break;
        }
        case DNSEntrySentBw:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitForDNSQueries.ROOT.WaitForDNSQueries.DNSEntrySentBw");
            break;
        }
        case DNSEntrySentServer:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitForDNSQueries.ROOT.WaitForDNSQueries.DNSEntrySentServer");
            break;
        }
        case DNSQueryReceivedServer:
        {
            popNullTransition();
            NOTIFY_STATE_EXITED("ROOT.mainState.WaitForDNSQueries.ROOT.WaitForDNSQueries.DNSQueryReceivedServer");
            break;
        }
        default:
            break;
    }
    WaitForDNSQueries_subState = OMNonState;
    NOTIFY_STATE_EXITED("ROOT.mainState.WaitForDNSQueries");
}





Initiator_and_dns::pDNSServer_C::pDNSServer_C() {
    initRelations();
}

Initiator_and_dns::pDNSServer_C::~pDNSServer_C() {
}

void Initiator_and_dns::pDNSServer_C::connectInitiator_and_dns(Initiator_and_dns* part) {
    //#[ operation connectInitiator_and_dns(Initiator_and_dns*) 
    InBound.setItsIDNSLookupInitRes(part);
    InBound.setPort(this); // for IS_PORT macro support
    
    //#]
}

iDNSLookupInitRes* Initiator_and_dns::pDNSServer_C::getItsIDNSLookupInitRes() {
    //#[ operation getItsIDNSLookupInitRes() 
    return &InBound;
    //#]
}

iDNSLookupResInit* Initiator_and_dns::pDNSServer_C::getItsIDNSLookupResInit() {
    //#[ operation getItsIDNSLookupResInit() 
    return &OutBound;
    //#]
}

void Initiator_and_dns::pDNSServer_C::setItsIDNSLookupInitRes(iDNSLookupInitRes* p_iDNSLookupInitRes) {
    //#[ operation setItsIDNSLookupInitRes(iDNSLookupInitRes*) 
    InBound.setItsIDNSLookupInitRes(p_iDNSLookupInitRes);
    //#]
}

void Initiator_and_dns::pDNSServer_C::setItsIDNSLookupResInit(OMReactive* p_iDNSLookupResInit) {
    //#[ operation setItsIDNSLookupResInit(OMReactive*) 
    OutBound.setItsIDNSLookupResInit(p_iDNSLookupResInit);
    //#]
}

Initiator_and_dns::pDNSServer_C::InBound_C* Initiator_and_dns::pDNSServer_C::getInBound() const {
    return (Initiator_and_dns::pDNSServer_C::InBound_C*) &InBound;
}

Initiator_and_dns::pDNSServer_C::OutBound_C* Initiator_and_dns::pDNSServer_C::getOutBound() const {
    return (Initiator_and_dns::pDNSServer_C::OutBound_C*) &OutBound;
}

void Initiator_and_dns::pDNSServer_C::destroy() {
}

void Initiator_and_dns::pDNSServer_C::initRelations() {
    InBound._setPort(this);
}





Initiator_and_dns::pDNSServer_C::InBound_C::InBound_C() {
    itsIDNSLookupInitRes = NULL;
    port = NULL;
}

Initiator_and_dns::pDNSServer_C::InBound_C::~InBound_C() {
    cleanUpRelations();
}

bool Initiator_and_dns::pDNSServer_C::InBound_C::send(IOxfEvent* event, const IOxfEventGenerationParams& params) {
    //#[ operation send(IOxfEvent*,const IOxfEventGenerationParams&) 
    bool res = false;
    if (event != NULL) {
      event->setPort(getPort());
      	if (itsIDNSLookupInitRes != NULL){
    	     if (event->isTypeOf(evDNSLookup_sip_id)){
         		res = itsIDNSLookupInitRes->send(event, params);
         	    return res;
         	}
         	
         	if (event->isTypeOf(evRes_init_sip_id)){
         		res = itsIDNSLookupInitRes->send(event, params);
         	    return res;
         	}
         	}
    	  }
    return res;
    
    //#]
}

bool Initiator_and_dns::pDNSServer_C::InBound_C::send(IOxfEvent* event) {
    //#[ operation send(IOxfEvent*) 
    bool res = false;
    if (event != NULL) {
      event->setPort(getPort());
      	if (itsIDNSLookupInitRes != NULL){
    	     if (event->isTypeOf(evDNSLookup_sip_id)){
         		res = itsIDNSLookupInitRes->send(event);
         	    return res;
         	}
         	
         	if (event->isTypeOf(evRes_init_sip_id)){
         		res = itsIDNSLookupInitRes->send(event);
         	    return res;
         	}
         	}
    	  }
    return res;
    
    //#]
}

iDNSLookupInitRes* Initiator_and_dns::pDNSServer_C::InBound_C::getItsIDNSLookupInitRes() const {
    return itsIDNSLookupInitRes;
}

void Initiator_and_dns::pDNSServer_C::InBound_C::setItsIDNSLookupInitRes(iDNSLookupInitRes* p_iDNSLookupInitRes) {
    itsIDNSLookupInitRes = p_iDNSLookupInitRes;
}

Initiator_and_dns::pDNSServer_C* Initiator_and_dns::pDNSServer_C::InBound_C::getPort() const {
    return port;
}

void Initiator_and_dns::pDNSServer_C::InBound_C::__setPort(Initiator_and_dns::pDNSServer_C* p_pDNSServer_C) {
    port = p_pDNSServer_C;
}

void Initiator_and_dns::pDNSServer_C::InBound_C::_setPort(Initiator_and_dns::pDNSServer_C* p_pDNSServer_C) {
    __setPort(p_pDNSServer_C);
}

void Initiator_and_dns::pDNSServer_C::InBound_C::setPort(Initiator_and_dns::pDNSServer_C* p_pDNSServer_C) {
    _setPort(p_pDNSServer_C);
}

void Initiator_and_dns::pDNSServer_C::InBound_C::_clearPort() {
    port = NULL;
}

void Initiator_and_dns::pDNSServer_C::InBound_C::cleanUpRelations() {
    if(itsIDNSLookupInitRes != NULL)
        {
            itsIDNSLookupInitRes = NULL;
        }
    if(port != NULL)
        {
            Initiator_and_dns::pDNSServer_C::InBound_C* p_InBound = port->getInBound();
            port = NULL;
        }
}






Initiator_and_dns::pDNSServer_C::OutBound_C::OutBound_C() {
    itsIDNSLookupResInit = NULL;
}

Initiator_and_dns::pDNSServer_C::OutBound_C::~OutBound_C() {
    cleanUpRelations();
}

bool Initiator_and_dns::pDNSServer_C::OutBound_C::send(IOxfEvent* event, const IOxfEventGenerationParams& params) {
    //#[ operation send(IOxfEvent*,const IOxfEventGenerationParams&) 
    bool res = false;
    if (event != NULL) {
      	if (itsIDNSLookupResInit != NULL){
    	     if (event->isTypeOf(evDNSLookupRes_sip_id)){
         		res = itsIDNSLookupResInit->send(event, params);
         	    return res;
         	}
         	
         	if (event->isTypeOf(evInitialization_sip_id)){
         		res = itsIDNSLookupResInit->send(event, params);
         	    return res;
         	}
         	}
    	  }
    return res;
    
    //#]
}

bool Initiator_and_dns::pDNSServer_C::OutBound_C::send(IOxfEvent* event) {
    //#[ operation send(IOxfEvent*) 
    bool res = false;
    if (event != NULL) {
      	if (itsIDNSLookupResInit != NULL){
    	     if (event->isTypeOf(evDNSLookupRes_sip_id)){
         		res = itsIDNSLookupResInit->send(event);
         	    return res;
         	}
         	
         	if (event->isTypeOf(evInitialization_sip_id)){
         		res = itsIDNSLookupResInit->send(event);
         	    return res;
         	}
         	}
    	  }
    return res;
    
    //#]
}

OMReactive* Initiator_and_dns::pDNSServer_C::OutBound_C::getItsIDNSLookupResInit() const {
    return itsIDNSLookupResInit;
}

void Initiator_and_dns::pDNSServer_C::OutBound_C::setItsIDNSLookupResInit(OMReactive* p_OMReactive) {
    itsIDNSLookupResInit = p_OMReactive;
}

void Initiator_and_dns::pDNSServer_C::OutBound_C::cleanUpRelations() {
    if(itsIDNSLookupResInit != NULL)
        {
            itsIDNSLookupResInit = NULL;
        }
}







Initiator_and_dns::pDNS_A_C::pDNS_A_C() {
    initRelations();
}

Initiator_and_dns::pDNS_A_C::~pDNS_A_C() {
}

void Initiator_and_dns::pDNS_A_C::connectInitiator_and_dns(Initiator_and_dns* part) {
    //#[ operation connectInitiator_and_dns(Initiator_and_dns*) 
    InBound.setItsIDNSLookupInitRes(part);
    InBound.setPort(this); // for IS_PORT macro support
    
    //#]
}

iDNSLookupInitRes* Initiator_and_dns::pDNS_A_C::getItsIDNSLookupInitRes() {
    //#[ operation getItsIDNSLookupInitRes() 
    return &InBound;
    //#]
}

iDNSLookupResInit* Initiator_and_dns::pDNS_A_C::getItsIDNSLookupResInit() {
    //#[ operation getItsIDNSLookupResInit() 
    return &OutBound;
    //#]
}

void Initiator_and_dns::pDNS_A_C::setItsIDNSLookupInitRes(iDNSLookupInitRes* p_iDNSLookupInitRes) {
    //#[ operation setItsIDNSLookupInitRes(iDNSLookupInitRes*) 
    InBound.setItsIDNSLookupInitRes(p_iDNSLookupInitRes);
    //#]
}

void Initiator_and_dns::pDNS_A_C::setItsIDNSLookupResInit(OMReactive* p_iDNSLookupResInit) {
    //#[ operation setItsIDNSLookupResInit(OMReactive*) 
    OutBound.setItsIDNSLookupResInit(p_iDNSLookupResInit);
    //#]
}

Initiator_and_dns::pDNS_A_C::InBound_C* Initiator_and_dns::pDNS_A_C::getInBound() const {
    return (Initiator_and_dns::pDNS_A_C::InBound_C*) &InBound;
}

Initiator_and_dns::pDNS_A_C::OutBound_C* Initiator_and_dns::pDNS_A_C::getOutBound() const {
    return (Initiator_and_dns::pDNS_A_C::OutBound_C*) &OutBound;
}

void Initiator_and_dns::pDNS_A_C::destroy() {
}

void Initiator_and_dns::pDNS_A_C::initRelations() {
    InBound._setPort(this);
}





Initiator_and_dns::pDNS_A_C::InBound_C::InBound_C() {
    itsIDNSLookupInitRes = NULL;
    port = NULL;
}

Initiator_and_dns::pDNS_A_C::InBound_C::~InBound_C() {
    cleanUpRelations();
}

bool Initiator_and_dns::pDNS_A_C::InBound_C::send(IOxfEvent* event, const IOxfEventGenerationParams& params) {
    //#[ operation send(IOxfEvent*,const IOxfEventGenerationParams&) 
    bool res = false;
    if (event != NULL) {
      event->setPort(getPort());
      	if (itsIDNSLookupInitRes != NULL){
    	     if (event->isTypeOf(evDNSLookup_sip_id)){
         		res = itsIDNSLookupInitRes->send(event, params);
         	    return res;
         	}
         	
         	if (event->isTypeOf(evRes_init_sip_id)){
         		res = itsIDNSLookupInitRes->send(event, params);
         	    return res;
         	}
         	}
    	  }
    return res;
    
    //#]
}

bool Initiator_and_dns::pDNS_A_C::InBound_C::send(IOxfEvent* event) {
    //#[ operation send(IOxfEvent*) 
    bool res = false;
    if (event != NULL) {
      event->setPort(getPort());
      	if (itsIDNSLookupInitRes != NULL){
    	     if (event->isTypeOf(evDNSLookup_sip_id)){
         		res = itsIDNSLookupInitRes->send(event);
         	    return res;
         	}
         	
         	if (event->isTypeOf(evRes_init_sip_id)){
         		res = itsIDNSLookupInitRes->send(event);
         	    return res;
         	}
         	}
    	  }
    return res;
    
    //#]
}

iDNSLookupInitRes* Initiator_and_dns::pDNS_A_C::InBound_C::getItsIDNSLookupInitRes() const {
    return itsIDNSLookupInitRes;
}

void Initiator_and_dns::pDNS_A_C::InBound_C::setItsIDNSLookupInitRes(iDNSLookupInitRes* p_iDNSLookupInitRes) {
    itsIDNSLookupInitRes = p_iDNSLookupInitRes;
}

Initiator_and_dns::pDNS_A_C* Initiator_and_dns::pDNS_A_C::InBound_C::getPort() const {
    return port;
}

void Initiator_and_dns::pDNS_A_C::InBound_C::__setPort(Initiator_and_dns::pDNS_A_C* p_pDNS_A_C) {
    port = p_pDNS_A_C;
}

void Initiator_and_dns::pDNS_A_C::InBound_C::_setPort(Initiator_and_dns::pDNS_A_C* p_pDNS_A_C) {
    __setPort(p_pDNS_A_C);
}

void Initiator_and_dns::pDNS_A_C::InBound_C::setPort(Initiator_and_dns::pDNS_A_C* p_pDNS_A_C) {
    _setPort(p_pDNS_A_C);
}

void Initiator_and_dns::pDNS_A_C::InBound_C::_clearPort() {
    port = NULL;
}

void Initiator_and_dns::pDNS_A_C::InBound_C::cleanUpRelations() {
    if(itsIDNSLookupInitRes != NULL)
        {
            itsIDNSLookupInitRes = NULL;
        }
    if(port != NULL)
        {
            Initiator_and_dns::pDNS_A_C::InBound_C* p_InBound = port->getInBound();
            port = NULL;
        }
}






Initiator_and_dns::pDNS_A_C::OutBound_C::OutBound_C() {
    itsIDNSLookupResInit = NULL;
}

Initiator_and_dns::pDNS_A_C::OutBound_C::~OutBound_C() {
    cleanUpRelations();
}

bool Initiator_and_dns::pDNS_A_C::OutBound_C::send(IOxfEvent* event, const IOxfEventGenerationParams& params) {
    //#[ operation send(IOxfEvent*,const IOxfEventGenerationParams&) 
    bool res = false;
    if (event != NULL) {
      	if (itsIDNSLookupResInit != NULL){
    	     if (event->isTypeOf(evDNSLookupRes_sip_id)){
         		res = itsIDNSLookupResInit->send(event, params);
         	    return res;
         	}
         	
         	if (event->isTypeOf(evInitialization_sip_id)){
         		res = itsIDNSLookupResInit->send(event, params);
         	    return res;
         	}
         	}
    	  }
    return res;
    
    //#]
}

bool Initiator_and_dns::pDNS_A_C::OutBound_C::send(IOxfEvent* event) {
    //#[ operation send(IOxfEvent*) 
    bool res = false;
    if (event != NULL) {
      	if (itsIDNSLookupResInit != NULL){
    	     if (event->isTypeOf(evDNSLookupRes_sip_id)){
         		res = itsIDNSLookupResInit->send(event);
         	    return res;
         	}
         	
         	if (event->isTypeOf(evInitialization_sip_id)){
         		res = itsIDNSLookupResInit->send(event);
         	    return res;
         	}
         	}
    	  }
    return res;
    
    //#]
}

OMReactive* Initiator_and_dns::pDNS_A_C::OutBound_C::getItsIDNSLookupResInit() const {
    return itsIDNSLookupResInit;
}

void Initiator_and_dns::pDNS_A_C::OutBound_C::setItsIDNSLookupResInit(OMReactive* p_OMReactive) {
    itsIDNSLookupResInit = p_OMReactive;
}

void Initiator_and_dns::pDNS_A_C::OutBound_C::cleanUpRelations() {
    if(itsIDNSLookupResInit != NULL)
        {
            itsIDNSLookupResInit = NULL;
        }
}







Initiator_and_dns::pDNS_Bh_C::pDNS_Bh_C() {
    initRelations();
}

Initiator_and_dns::pDNS_Bh_C::~pDNS_Bh_C() {
}

void Initiator_and_dns::pDNS_Bh_C::connectInitiator_and_dns(Initiator_and_dns* part) {
    //#[ operation connectInitiator_and_dns(Initiator_and_dns*) 
    InBound.setItsIDNSLookupInitRes(part);
    InBound.setPort(this); // for IS_PORT macro support
    
    //#]
}

iDNSLookupInitRes* Initiator_and_dns::pDNS_Bh_C::getItsIDNSLookupInitRes() {
    //#[ operation getItsIDNSLookupInitRes() 
    return &InBound;
    //#]
}

iDNSLookupResInit* Initiator_and_dns::pDNS_Bh_C::getItsIDNSLookupResInit() {
    //#[ operation getItsIDNSLookupResInit() 
    return &OutBound;
    //#]
}

void Initiator_and_dns::pDNS_Bh_C::setItsIDNSLookupInitRes(iDNSLookupInitRes* p_iDNSLookupInitRes) {
    //#[ operation setItsIDNSLookupInitRes(iDNSLookupInitRes*) 
    InBound.setItsIDNSLookupInitRes(p_iDNSLookupInitRes);
    //#]
}

void Initiator_and_dns::pDNS_Bh_C::setItsIDNSLookupResInit(OMReactive* p_iDNSLookupResInit) {
    //#[ operation setItsIDNSLookupResInit(OMReactive*) 
    OutBound.setItsIDNSLookupResInit(p_iDNSLookupResInit);
    //#]
}

Initiator_and_dns::pDNS_Bh_C::InBound_C* Initiator_and_dns::pDNS_Bh_C::getInBound() const {
    return (Initiator_and_dns::pDNS_Bh_C::InBound_C*) &InBound;
}

Initiator_and_dns::pDNS_Bh_C::OutBound_C* Initiator_and_dns::pDNS_Bh_C::getOutBound() const {
    return (Initiator_and_dns::pDNS_Bh_C::OutBound_C*) &OutBound;
}

void Initiator_and_dns::pDNS_Bh_C::destroy() {
}

void Initiator_and_dns::pDNS_Bh_C::initRelations() {
    InBound._setPort(this);
}





Initiator_and_dns::pDNS_Bh_C::InBound_C::InBound_C() {
    itsIDNSLookupInitRes = NULL;
    port = NULL;
}

Initiator_and_dns::pDNS_Bh_C::InBound_C::~InBound_C() {
    cleanUpRelations();
}

bool Initiator_and_dns::pDNS_Bh_C::InBound_C::send(IOxfEvent* event, const IOxfEventGenerationParams& params) {
    //#[ operation send(IOxfEvent*,const IOxfEventGenerationParams&) 
    bool res = false;
    if (event != NULL) {
      event->setPort(getPort());
      	if (itsIDNSLookupInitRes != NULL){
    	     if (event->isTypeOf(evDNSLookup_sip_id)){
         		res = itsIDNSLookupInitRes->send(event, params);
         	    return res;
         	}
         	
         	if (event->isTypeOf(evRes_init_sip_id)){
         		res = itsIDNSLookupInitRes->send(event, params);
         	    return res;
         	}
         	}
    	  }
    return res;
    
    //#]
}

bool Initiator_and_dns::pDNS_Bh_C::InBound_C::send(IOxfEvent* event) {
    //#[ operation send(IOxfEvent*) 
    bool res = false;
    if (event != NULL) {
      event->setPort(getPort());
      	if (itsIDNSLookupInitRes != NULL){
    	     if (event->isTypeOf(evDNSLookup_sip_id)){
         		res = itsIDNSLookupInitRes->send(event);
         	    return res;
         	}
         	
         	if (event->isTypeOf(evRes_init_sip_id)){
         		res = itsIDNSLookupInitRes->send(event);
         	    return res;
         	}
         	}
    	  }
    return res;
    
    //#]
}

iDNSLookupInitRes* Initiator_and_dns::pDNS_Bh_C::InBound_C::getItsIDNSLookupInitRes() const {
    return itsIDNSLookupInitRes;
}

void Initiator_and_dns::pDNS_Bh_C::InBound_C::setItsIDNSLookupInitRes(iDNSLookupInitRes* p_iDNSLookupInitRes) {
    itsIDNSLookupInitRes = p_iDNSLookupInitRes;
}

Initiator_and_dns::pDNS_Bh_C* Initiator_and_dns::pDNS_Bh_C::InBound_C::getPort() const {
    return port;
}

void Initiator_and_dns::pDNS_Bh_C::InBound_C::__setPort(Initiator_and_dns::pDNS_Bh_C* p_pDNS_Bh_C) {
    port = p_pDNS_Bh_C;
}

void Initiator_and_dns::pDNS_Bh_C::InBound_C::_setPort(Initiator_and_dns::pDNS_Bh_C* p_pDNS_Bh_C) {
    __setPort(p_pDNS_Bh_C);
}

void Initiator_and_dns::pDNS_Bh_C::InBound_C::setPort(Initiator_and_dns::pDNS_Bh_C* p_pDNS_Bh_C) {
    _setPort(p_pDNS_Bh_C);
}

void Initiator_and_dns::pDNS_Bh_C::InBound_C::_clearPort() {
    port = NULL;
}

void Initiator_and_dns::pDNS_Bh_C::InBound_C::cleanUpRelations() {
    if(itsIDNSLookupInitRes != NULL)
        {
            itsIDNSLookupInitRes = NULL;
        }
    if(port != NULL)
        {
            Initiator_and_dns::pDNS_Bh_C::InBound_C* p_InBound = port->getInBound();
            port = NULL;
        }
}






Initiator_and_dns::pDNS_Bh_C::OutBound_C::OutBound_C() {
    itsIDNSLookupResInit = NULL;
}

Initiator_and_dns::pDNS_Bh_C::OutBound_C::~OutBound_C() {
    cleanUpRelations();
}

bool Initiator_and_dns::pDNS_Bh_C::OutBound_C::send(IOxfEvent* event, const IOxfEventGenerationParams& params) {
    //#[ operation send(IOxfEvent*,const IOxfEventGenerationParams&) 
    bool res = false;
    if (event != NULL) {
      	if (itsIDNSLookupResInit != NULL){
    	     if (event->isTypeOf(evDNSLookupRes_sip_id)){
         		res = itsIDNSLookupResInit->send(event, params);
         	    return res;
         	}
         	
         	if (event->isTypeOf(evInitialization_sip_id)){
         		res = itsIDNSLookupResInit->send(event, params);
         	    return res;
         	}
         	}
    	  }
    return res;
    
    //#]
}

bool Initiator_and_dns::pDNS_Bh_C::OutBound_C::send(IOxfEvent* event) {
    //#[ operation send(IOxfEvent*) 
    bool res = false;
    if (event != NULL) {
      	if (itsIDNSLookupResInit != NULL){
    	     if (event->isTypeOf(evDNSLookupRes_sip_id)){
         		res = itsIDNSLookupResInit->send(event);
         	    return res;
         	}
         	
         	if (event->isTypeOf(evInitialization_sip_id)){
         		res = itsIDNSLookupResInit->send(event);
         	    return res;
         	}
         	}
    	  }
    return res;
    
    //#]
}

OMReactive* Initiator_and_dns::pDNS_Bh_C::OutBound_C::getItsIDNSLookupResInit() const {
    return itsIDNSLookupResInit;
}

void Initiator_and_dns::pDNS_Bh_C::OutBound_C::setItsIDNSLookupResInit(OMReactive* p_OMReactive) {
    itsIDNSLookupResInit = p_OMReactive;
}

void Initiator_and_dns::pDNS_Bh_C::OutBound_C::cleanUpRelations() {
    if(itsIDNSLookupResInit != NULL)
        {
            itsIDNSLookupResInit = NULL;
        }
}







Initiator_and_dns::pDNS_Bw_C::pDNS_Bw_C() {
    initRelations();
}

Initiator_and_dns::pDNS_Bw_C::~pDNS_Bw_C() {
}

void Initiator_and_dns::pDNS_Bw_C::connectInitiator_and_dns(Initiator_and_dns* part) {
    //#[ operation connectInitiator_and_dns(Initiator_and_dns*) 
    InBound.setItsIDNSLookupInitRes(part);
    InBound.setPort(this); // for IS_PORT macro support
    
    //#]
}

iDNSLookupInitRes* Initiator_and_dns::pDNS_Bw_C::getItsIDNSLookupInitRes() {
    //#[ operation getItsIDNSLookupInitRes() 
    return &InBound;
    //#]
}

iDNSLookupResInit* Initiator_and_dns::pDNS_Bw_C::getItsIDNSLookupResInit() {
    //#[ operation getItsIDNSLookupResInit() 
    return &OutBound;
    //#]
}

void Initiator_and_dns::pDNS_Bw_C::setItsIDNSLookupInitRes(iDNSLookupInitRes* p_iDNSLookupInitRes) {
    //#[ operation setItsIDNSLookupInitRes(iDNSLookupInitRes*) 
    InBound.setItsIDNSLookupInitRes(p_iDNSLookupInitRes);
    //#]
}

void Initiator_and_dns::pDNS_Bw_C::setItsIDNSLookupResInit(OMReactive* p_iDNSLookupResInit) {
    //#[ operation setItsIDNSLookupResInit(OMReactive*) 
    OutBound.setItsIDNSLookupResInit(p_iDNSLookupResInit);
    //#]
}

Initiator_and_dns::pDNS_Bw_C::InBound_C* Initiator_and_dns::pDNS_Bw_C::getInBound() const {
    return (Initiator_and_dns::pDNS_Bw_C::InBound_C*) &InBound;
}

Initiator_and_dns::pDNS_Bw_C::OutBound_C* Initiator_and_dns::pDNS_Bw_C::getOutBound() const {
    return (Initiator_and_dns::pDNS_Bw_C::OutBound_C*) &OutBound;
}

void Initiator_and_dns::pDNS_Bw_C::destroy() {
}

void Initiator_and_dns::pDNS_Bw_C::initRelations() {
    InBound._setPort(this);
}





Initiator_and_dns::pDNS_Bw_C::InBound_C::InBound_C() {
    itsIDNSLookupInitRes = NULL;
    port = NULL;
}

Initiator_and_dns::pDNS_Bw_C::InBound_C::~InBound_C() {
    cleanUpRelations();
}

bool Initiator_and_dns::pDNS_Bw_C::InBound_C::send(IOxfEvent* event, const IOxfEventGenerationParams& params) {
    //#[ operation send(IOxfEvent*,const IOxfEventGenerationParams&) 
    bool res = false;
    if (event != NULL) {
      event->setPort(getPort());
      	if (itsIDNSLookupInitRes != NULL){
    	     if (event->isTypeOf(evDNSLookup_sip_id)){
         		res = itsIDNSLookupInitRes->send(event, params);
         	    return res;
         	}
         	
         	if (event->isTypeOf(evRes_init_sip_id)){
         		res = itsIDNSLookupInitRes->send(event, params);
         	    return res;
         	}
         	}
    	  }
    return res;
    
    //#]
}

bool Initiator_and_dns::pDNS_Bw_C::InBound_C::send(IOxfEvent* event) {
    //#[ operation send(IOxfEvent*) 
    bool res = false;
    if (event != NULL) {
      event->setPort(getPort());
      	if (itsIDNSLookupInitRes != NULL){
    	     if (event->isTypeOf(evDNSLookup_sip_id)){
         		res = itsIDNSLookupInitRes->send(event);
         	    return res;
         	}
         	
         	if (event->isTypeOf(evRes_init_sip_id)){
         		res = itsIDNSLookupInitRes->send(event);
         	    return res;
         	}
         	}
    	  }
    return res;
    
    //#]
}

iDNSLookupInitRes* Initiator_and_dns::pDNS_Bw_C::InBound_C::getItsIDNSLookupInitRes() const {
    return itsIDNSLookupInitRes;
}

void Initiator_and_dns::pDNS_Bw_C::InBound_C::setItsIDNSLookupInitRes(iDNSLookupInitRes* p_iDNSLookupInitRes) {
    itsIDNSLookupInitRes = p_iDNSLookupInitRes;
}

Initiator_and_dns::pDNS_Bw_C* Initiator_and_dns::pDNS_Bw_C::InBound_C::getPort() const {
    return port;
}

void Initiator_and_dns::pDNS_Bw_C::InBound_C::__setPort(Initiator_and_dns::pDNS_Bw_C* p_pDNS_Bw_C) {
    port = p_pDNS_Bw_C;
}

void Initiator_and_dns::pDNS_Bw_C::InBound_C::_setPort(Initiator_and_dns::pDNS_Bw_C* p_pDNS_Bw_C) {
    __setPort(p_pDNS_Bw_C);
}

void Initiator_and_dns::pDNS_Bw_C::InBound_C::setPort(Initiator_and_dns::pDNS_Bw_C* p_pDNS_Bw_C) {
    _setPort(p_pDNS_Bw_C);
}

void Initiator_and_dns::pDNS_Bw_C::InBound_C::_clearPort() {
    port = NULL;
}

void Initiator_and_dns::pDNS_Bw_C::InBound_C::cleanUpRelations() {
    if(itsIDNSLookupInitRes != NULL)
        {
            itsIDNSLookupInitRes = NULL;
        }
    if(port != NULL)
        {
            Initiator_and_dns::pDNS_Bw_C::InBound_C* p_InBound = port->getInBound();
            port = NULL;
        }
}






Initiator_and_dns::pDNS_Bw_C::OutBound_C::OutBound_C() {
    itsIDNSLookupResInit = NULL;
}

Initiator_and_dns::pDNS_Bw_C::OutBound_C::~OutBound_C() {
    cleanUpRelations();
}

bool Initiator_and_dns::pDNS_Bw_C::OutBound_C::send(IOxfEvent* event, const IOxfEventGenerationParams& params) {
    //#[ operation send(IOxfEvent*,const IOxfEventGenerationParams&) 
    bool res = false;
    if (event != NULL) {
      	if (itsIDNSLookupResInit != NULL){
    	     if (event->isTypeOf(evDNSLookupRes_sip_id)){
         		res = itsIDNSLookupResInit->send(event, params);
         	    return res;
         	}
         	
         	if (event->isTypeOf(evInitialization_sip_id)){
         		res = itsIDNSLookupResInit->send(event, params);
         	    return res;
         	}
         	}
    	  }
    return res;
    
    //#]
}

bool Initiator_and_dns::pDNS_Bw_C::OutBound_C::send(IOxfEvent* event) {
    //#[ operation send(IOxfEvent*) 
    bool res = false;
    if (event != NULL) {
      	if (itsIDNSLookupResInit != NULL){
    	     if (event->isTypeOf(evDNSLookupRes_sip_id)){
         		res = itsIDNSLookupResInit->send(event);
         	    return res;
         	}
         	
         	if (event->isTypeOf(evInitialization_sip_id)){
         		res = itsIDNSLookupResInit->send(event);
         	    return res;
         	}
         	}
    	  }
    return res;
    
    //#]
}

OMReactive* Initiator_and_dns::pDNS_Bw_C::OutBound_C::getItsIDNSLookupResInit() const {
    return itsIDNSLookupResInit;
}

void Initiator_and_dns::pDNS_Bw_C::OutBound_C::setItsIDNSLookupResInit(OMReactive* p_OMReactive) {
    itsIDNSLookupResInit = p_OMReactive;
}

void Initiator_and_dns::pDNS_Bw_C::OutBound_C::cleanUpRelations() {
    if(itsIDNSLookupResInit != NULL)
        {
            itsIDNSLookupResInit = NULL;
        }
}







Initiator_and_dns::pDNS_C_C::pDNS_C_C() {
    initRelations();
}

Initiator_and_dns::pDNS_C_C::~pDNS_C_C() {
}

void Initiator_and_dns::pDNS_C_C::connectInitiator_and_dns(Initiator_and_dns* part) {
    //#[ operation connectInitiator_and_dns(Initiator_and_dns*) 
    InBound.setItsIDNSLookupInitRes(part);
    InBound.setPort(this); // for IS_PORT macro support
    
    //#]
}

iDNSLookupInitRes* Initiator_and_dns::pDNS_C_C::getItsIDNSLookupInitRes() {
    //#[ operation getItsIDNSLookupInitRes() 
    return &InBound;
    //#]
}

iDNSLookupResInit* Initiator_and_dns::pDNS_C_C::getItsIDNSLookupResInit() {
    //#[ operation getItsIDNSLookupResInit() 
    return &OutBound;
    //#]
}

void Initiator_and_dns::pDNS_C_C::setItsIDNSLookupInitRes(iDNSLookupInitRes* p_iDNSLookupInitRes) {
    //#[ operation setItsIDNSLookupInitRes(iDNSLookupInitRes*) 
    InBound.setItsIDNSLookupInitRes(p_iDNSLookupInitRes);
    //#]
}

void Initiator_and_dns::pDNS_C_C::setItsIDNSLookupResInit(OMReactive* p_iDNSLookupResInit) {
    //#[ operation setItsIDNSLookupResInit(OMReactive*) 
    OutBound.setItsIDNSLookupResInit(p_iDNSLookupResInit);
    //#]
}

Initiator_and_dns::pDNS_C_C::InBound_C* Initiator_and_dns::pDNS_C_C::getInBound() const {
    return (Initiator_and_dns::pDNS_C_C::InBound_C*) &InBound;
}

Initiator_and_dns::pDNS_C_C::OutBound_C* Initiator_and_dns::pDNS_C_C::getOutBound() const {
    return (Initiator_and_dns::pDNS_C_C::OutBound_C*) &OutBound;
}

void Initiator_and_dns::pDNS_C_C::destroy() {
}

void Initiator_and_dns::pDNS_C_C::initRelations() {
    InBound._setPort(this);
}





Initiator_and_dns::pDNS_C_C::InBound_C::InBound_C() {
    itsIDNSLookupInitRes = NULL;
    port = NULL;
}

Initiator_and_dns::pDNS_C_C::InBound_C::~InBound_C() {
    cleanUpRelations();
}

bool Initiator_and_dns::pDNS_C_C::InBound_C::send(IOxfEvent* event, const IOxfEventGenerationParams& params) {
    //#[ operation send(IOxfEvent*,const IOxfEventGenerationParams&) 
    bool res = false;
    if (event != NULL) {
      event->setPort(getPort());
      	if (itsIDNSLookupInitRes != NULL){
    	     if (event->isTypeOf(evDNSLookup_sip_id)){
         		res = itsIDNSLookupInitRes->send(event, params);
         	    return res;
         	}
         	
         	if (event->isTypeOf(evRes_init_sip_id)){
         		res = itsIDNSLookupInitRes->send(event, params);
         	    return res;
         	}
         	}
    	  }
    return res;
    
    //#]
}

bool Initiator_and_dns::pDNS_C_C::InBound_C::send(IOxfEvent* event) {
    //#[ operation send(IOxfEvent*) 
    bool res = false;
    if (event != NULL) {
      event->setPort(getPort());
      	if (itsIDNSLookupInitRes != NULL){
    	     if (event->isTypeOf(evDNSLookup_sip_id)){
         		res = itsIDNSLookupInitRes->send(event);
         	    return res;
         	}
         	
         	if (event->isTypeOf(evRes_init_sip_id)){
         		res = itsIDNSLookupInitRes->send(event);
         	    return res;
         	}
         	}
    	  }
    return res;
    
    //#]
}

iDNSLookupInitRes* Initiator_and_dns::pDNS_C_C::InBound_C::getItsIDNSLookupInitRes() const {
    return itsIDNSLookupInitRes;
}

void Initiator_and_dns::pDNS_C_C::InBound_C::setItsIDNSLookupInitRes(iDNSLookupInitRes* p_iDNSLookupInitRes) {
    itsIDNSLookupInitRes = p_iDNSLookupInitRes;
}

Initiator_and_dns::pDNS_C_C* Initiator_and_dns::pDNS_C_C::InBound_C::getPort() const {
    return port;
}

void Initiator_and_dns::pDNS_C_C::InBound_C::__setPort(Initiator_and_dns::pDNS_C_C* p_pDNS_C_C) {
    port = p_pDNS_C_C;
}

void Initiator_and_dns::pDNS_C_C::InBound_C::_setPort(Initiator_and_dns::pDNS_C_C* p_pDNS_C_C) {
    __setPort(p_pDNS_C_C);
}

void Initiator_and_dns::pDNS_C_C::InBound_C::setPort(Initiator_and_dns::pDNS_C_C* p_pDNS_C_C) {
    _setPort(p_pDNS_C_C);
}

void Initiator_and_dns::pDNS_C_C::InBound_C::_clearPort() {
    port = NULL;
}

void Initiator_and_dns::pDNS_C_C::InBound_C::cleanUpRelations() {
    if(itsIDNSLookupInitRes != NULL)
        {
            itsIDNSLookupInitRes = NULL;
        }
    if(port != NULL)
        {
            Initiator_and_dns::pDNS_C_C::InBound_C* p_InBound = port->getInBound();
            port = NULL;
        }
}






Initiator_and_dns::pDNS_C_C::OutBound_C::OutBound_C() {
    itsIDNSLookupResInit = NULL;
}

Initiator_and_dns::pDNS_C_C::OutBound_C::~OutBound_C() {
    cleanUpRelations();
}

bool Initiator_and_dns::pDNS_C_C::OutBound_C::send(IOxfEvent* event, const IOxfEventGenerationParams& params) {
    //#[ operation send(IOxfEvent*,const IOxfEventGenerationParams&) 
    bool res = false;
    if (event != NULL) {
      	if (itsIDNSLookupResInit != NULL){
    	     if (event->isTypeOf(evDNSLookupRes_sip_id)){
         		res = itsIDNSLookupResInit->send(event, params);
         	    return res;
         	}
         	
         	if (event->isTypeOf(evInitialization_sip_id)){
         		res = itsIDNSLookupResInit->send(event, params);
         	    return res;
         	}
         	}
    	  }
    return res;
    
    //#]
}

bool Initiator_and_dns::pDNS_C_C::OutBound_C::send(IOxfEvent* event) {
    //#[ operation send(IOxfEvent*) 
    bool res = false;
    if (event != NULL) {
      	if (itsIDNSLookupResInit != NULL){
    	     if (event->isTypeOf(evDNSLookupRes_sip_id)){
         		res = itsIDNSLookupResInit->send(event);
         	    return res;
         	}
         	
         	if (event->isTypeOf(evInitialization_sip_id)){
         		res = itsIDNSLookupResInit->send(event);
         	    return res;
         	}
         	}
    	  }
    return res;
    
    //#]
}

OMReactive* Initiator_and_dns::pDNS_C_C::OutBound_C::getItsIDNSLookupResInit() const {
    return itsIDNSLookupResInit;
}

void Initiator_and_dns::pDNS_C_C::OutBound_C::setItsIDNSLookupResInit(OMReactive* p_OMReactive) {
    itsIDNSLookupResInit = p_OMReactive;
}

void Initiator_and_dns::pDNS_C_C::OutBound_C::cleanUpRelations() {
    if(itsIDNSLookupResInit != NULL)
        {
            itsIDNSLookupResInit = NULL;
        }
}





#ifdef _OMINSTRUMENT


void OMAnimatedInitiator_and_dns::serializeAttributes(AOMSAttributes* aomsAttributes) const {
    aomsAttributes->addAttribute("dnsTable", UNKNOWN2STRING(myReal->dnsTable));
    aomsAttributes->addAttribute("nbEntries", x2String(myReal->nbEntries));
    aomsAttributes->addAttribute("i", x2String(myReal->i));
    aomsAttributes->addAttribute("address", x2String(myReal->address));
    aomsAttributes->addAttribute("portName", x2String(myReal->portName));
    OMAnimatediDNSLookupInitRes::serializeAttributes(aomsAttributes);
}

void OMAnimatedInitiator_and_dns::serializeRelations(AOMSRelations* aomsRelations) const {
    OMAnimatediDNSLookupInitRes::serializeRelations(aomsRelations);
}

void OMAnimatedInitiator_and_dns::rootState_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT");
    switch (myReal->rootState_subState) {
        case Initiator_and_dns::mainState:
        {
            mainState_serializeStates(aomsState);
            break;
        }
        default:
            break;
    }
}

void OMAnimatedInitiator_and_dns::mainState_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState");
    switch (myReal->mainState_subState) {
        case Initiator_and_dns::AllAckReceived:
        {
            AllAckReceived_serializeStates(aomsState);
            break;
        }
        case Initiator_and_dns::Initializing:
        {
            Initializing_serializeStates(aomsState);
            break;
        }
        case Initiator_and_dns::WaitForDNSQueries:
        {
            WaitForDNSQueries_serializeStates(aomsState);
            break;
        }
        default:
            break;
    }
}

void OMAnimatedInitiator_and_dns::WaitForDNSQueries_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.WaitForDNSQueries");
    switch (myReal->WaitForDNSQueries_subState) {
        case Initiator_and_dns::WaitForDNSQuery:
        {
            WaitForDNSQuery_serializeStates(aomsState);
            break;
        }
        case Initiator_and_dns::DNSQueryReceivedA:
        {
            DNSQueryReceivedA_serializeStates(aomsState);
            break;
        }
        case Initiator_and_dns::DNSEntrySentA:
        {
            DNSEntrySentA_serializeStates(aomsState);
            break;
        }
        case Initiator_and_dns::DNSQueryReceivedBh:
        {
            DNSQueryReceivedBh_serializeStates(aomsState);
            break;
        }
        case Initiator_and_dns::DNSQueryReceivedBw:
        {
            DNSQueryReceivedBw_serializeStates(aomsState);
            break;
        }
        case Initiator_and_dns::DNSEntrySentBh:
        {
            DNSEntrySentBh_serializeStates(aomsState);
            break;
        }
        case Initiator_and_dns::DNSEntrySentC:
        {
            DNSEntrySentC_serializeStates(aomsState);
            break;
        }
        case Initiator_and_dns::DNSQueryReceivedC:
        {
            DNSQueryReceivedC_serializeStates(aomsState);
            break;
        }
        case Initiator_and_dns::DNSEntrySentBw:
        {
            DNSEntrySentBw_serializeStates(aomsState);
            break;
        }
        case Initiator_and_dns::DNSEntrySentServer:
        {
            DNSEntrySentServer_serializeStates(aomsState);
            break;
        }
        case Initiator_and_dns::DNSQueryReceivedServer:
        {
            DNSQueryReceivedServer_serializeStates(aomsState);
            break;
        }
        default:
            break;
    }
}

void OMAnimatedInitiator_and_dns::WaitForDNSQuery_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.WaitForDNSQueries.ROOT.WaitForDNSQueries.WaitForDNSQuery");
}

void OMAnimatedInitiator_and_dns::DNSQueryReceivedServer_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.WaitForDNSQueries.ROOT.WaitForDNSQueries.DNSQueryReceivedServer");
}

void OMAnimatedInitiator_and_dns::DNSQueryReceivedC_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.WaitForDNSQueries.ROOT.WaitForDNSQueries.DNSQueryReceivedC");
}

void OMAnimatedInitiator_and_dns::DNSQueryReceivedBw_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.WaitForDNSQueries.ROOT.WaitForDNSQueries.DNSQueryReceivedBw");
}

void OMAnimatedInitiator_and_dns::DNSQueryReceivedBh_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.WaitForDNSQueries.ROOT.WaitForDNSQueries.DNSQueryReceivedBh");
}

void OMAnimatedInitiator_and_dns::DNSQueryReceivedA_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.WaitForDNSQueries.ROOT.WaitForDNSQueries.DNSQueryReceivedA");
}

void OMAnimatedInitiator_and_dns::DNSEntrySentServer_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.WaitForDNSQueries.ROOT.WaitForDNSQueries.DNSEntrySentServer");
}

void OMAnimatedInitiator_and_dns::DNSEntrySentC_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.WaitForDNSQueries.ROOT.WaitForDNSQueries.DNSEntrySentC");
}

void OMAnimatedInitiator_and_dns::DNSEntrySentBw_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.WaitForDNSQueries.ROOT.WaitForDNSQueries.DNSEntrySentBw");
}

void OMAnimatedInitiator_and_dns::DNSEntrySentBh_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.WaitForDNSQueries.ROOT.WaitForDNSQueries.DNSEntrySentBh");
}

void OMAnimatedInitiator_and_dns::DNSEntrySentA_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.WaitForDNSQueries.ROOT.WaitForDNSQueries.DNSEntrySentA");
}

void OMAnimatedInitiator_and_dns::Initializing_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.Initializing");
    state_61_serializeStates(aomsState);
    state_15_serializeStates(aomsState);
    state_16_serializeStates(aomsState);
    state_20_serializeStates(aomsState);
    state_21_serializeStates(aomsState);
}

void OMAnimatedInitiator_and_dns::state_61_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.Initializing.state_61");
    switch (myReal->state_61_subState) {
        case Initiator_and_dns::Ack:
        {
            Ack_serializeStates(aomsState);
            break;
        }
        case Initiator_and_dns::SentToC:
        {
            SentToC_serializeStates(aomsState);
            break;
        }
        case Initiator_and_dns::SendingToC:
        {
            SendingToC_serializeStates(aomsState);
            break;
        }
        default:
            break;
    }
}

void OMAnimatedInitiator_and_dns::SentToC_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.Initializing.state_61.SentToC");
}

void OMAnimatedInitiator_and_dns::SendingToC_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.Initializing.state_61.SendingToC");
}

void OMAnimatedInitiator_and_dns::Ack_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.Initializing.state_61.Ack");
}

void OMAnimatedInitiator_and_dns::state_21_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.Initializing.state_21");
    switch (myReal->state_21_subState) {
        case Initiator_and_dns::state_21_Ack:
        {
            state_21_Ack_serializeStates(aomsState);
            break;
        }
        case Initiator_and_dns::SentToBw:
        {
            SentToBw_serializeStates(aomsState);
            break;
        }
        case Initiator_and_dns::SendingToBw:
        {
            SendingToBw_serializeStates(aomsState);
            break;
        }
        default:
            break;
    }
}

void OMAnimatedInitiator_and_dns::SentToBw_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.Initializing.state_21.SentToBw");
}

void OMAnimatedInitiator_and_dns::SendingToBw_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.Initializing.state_21.SendingToBw");
}

void OMAnimatedInitiator_and_dns::state_21_Ack_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.Initializing.state_21.Ack");
}

void OMAnimatedInitiator_and_dns::state_20_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.Initializing.state_20");
    switch (myReal->state_20_subState) {
        case Initiator_and_dns::state_20_Ack:
        {
            state_20_Ack_serializeStates(aomsState);
            break;
        }
        case Initiator_and_dns::SentToBh:
        {
            SentToBh_serializeStates(aomsState);
            break;
        }
        case Initiator_and_dns::SendingToBh:
        {
            SendingToBh_serializeStates(aomsState);
            break;
        }
        default:
            break;
    }
}

void OMAnimatedInitiator_and_dns::SentToBh_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.Initializing.state_20.SentToBh");
}

void OMAnimatedInitiator_and_dns::SendingToBh_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.Initializing.state_20.SendingToBh");
}

void OMAnimatedInitiator_and_dns::state_20_Ack_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.Initializing.state_20.Ack");
}

void OMAnimatedInitiator_and_dns::state_16_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.Initializing.state_16");
    switch (myReal->state_16_subState) {
        case Initiator_and_dns::state_16_Ack:
        {
            state_16_Ack_serializeStates(aomsState);
            break;
        }
        case Initiator_and_dns::SentToA:
        {
            SentToA_serializeStates(aomsState);
            break;
        }
        case Initiator_and_dns::SendingToA:
        {
            SendingToA_serializeStates(aomsState);
            break;
        }
        default:
            break;
    }
}

void OMAnimatedInitiator_and_dns::SentToA_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.Initializing.state_16.SentToA");
}

void OMAnimatedInitiator_and_dns::SendingToA_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.Initializing.state_16.SendingToA");
}

void OMAnimatedInitiator_and_dns::state_16_Ack_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.Initializing.state_16.Ack");
}

void OMAnimatedInitiator_and_dns::state_15_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.Initializing.state_15");
    switch (myReal->state_15_subState) {
        case Initiator_and_dns::state_15_Ack:
        {
            state_15_Ack_serializeStates(aomsState);
            break;
        }
        case Initiator_and_dns::SentToServer:
        {
            SentToServer_serializeStates(aomsState);
            break;
        }
        case Initiator_and_dns::SendingToSever:
        {
            SendingToSever_serializeStates(aomsState);
            break;
        }
        default:
            break;
    }
}

void OMAnimatedInitiator_and_dns::SentToServer_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.Initializing.state_15.SentToServer");
}

void OMAnimatedInitiator_and_dns::SendingToSever_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.Initializing.state_15.SendingToSever");
}

void OMAnimatedInitiator_and_dns::state_15_Ack_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.Initializing.state_15.Ack");
}

void OMAnimatedInitiator_and_dns::AllAckReceived_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.mainState.AllAckReceived");
}

IMPLEMENT_REACTIVE_META_S(Initiator_and_dns, false, iDNSLookupInitRes, OMAnimatediDNSLookupInitRes, OMAnimatedInitiator_and_dns)
OMINIT_SUPERCLASS(iDNSLookupInitRes, OMAnimatediDNSLookupInitRes)
OMREGISTER_REACTIVE_CLASS
#endif // _OMINSTRUMENT


/*********************************************************************
	File Path	: DefaultComponent/DefaultConfig/Initiator_and_dns.cpp
*********************************************************************/

