/*********************************************************************
	Rhapsody	: 6.1 
	Login		: Masood Khosroshahy
	Component	: DefaultComponent 
	Configuration 	: DefaultConfig
	Model Element	: architectureSIP
//!	Generated Date	: Wed, 19, Apr 2006  
	File Path	: DefaultComponent/DefaultConfig/architectureSIP.h
*********************************************************************/


#ifndef architectureSIP_H 

#define architectureSIP_H 

#include <oxf/oxf.h>
#include <aom/aom.h>
#include "sip.h"
#include <oxf/omthread.h>
#include <oxf/omreactive.h>
#include <oxf/state.h>
#include <oxf/event.h>
// classInstance initiator_and_dns 
#include "Initiator_and_dns.h"
// classInstance sip_Redirect 
#include "SIP_Redirect.h"
// classInstance A_terminal 
#include "SIP_terminal.h"

//## package sip 

//----------------------------------------------------------------------------
// architectureSIP.h                                                                  
//----------------------------------------------------------------------------

#ifdef _OMINSTRUMENT
class OMAnimatedarchitectureSIP;
#endif // _OMINSTRUMENT


//## class architectureSIP 
class architectureSIP : public OMReactive {


////    Friends    ////
public :
    
    
#ifdef _OMINSTRUMENT
    friend  class OMAnimatedarchitectureSIP;
#endif // _OMINSTRUMENT


////    Constructors and destructors    ////
public :
    
    //## auto_generated 
    architectureSIP(IOxfActive* theActiveContext = 0);
    
    //## auto_generated 
    ~architectureSIP();


////    Additional operations    ////
public :
    
    //## auto_generated 
    SIP_terminal* getA_terminal() const;
    
    //## auto_generated 
    SIP_terminal* getB_home_terminal() const;
    
    //## auto_generated 
    SIP_terminal* getB_work_terminal() const;
    
    //## auto_generated 
    SIP_terminal* getC_terminal() const;
    
    //## auto_generated 
    Initiator_and_dns* getInitiator_and_dns() const;
    
    //## auto_generated 
    SIP_Redirect* getSip_Redirect() const;


////    Framework operations    ////
public :
    
    //## auto_generated 
    void destroy();
    
    //## auto_generated 
    virtual bool startBehavior();

protected :
    
    //## auto_generated 
    void initRelations();


////    Relations and components    ////
protected :
    
    SIP_terminal A_terminal;		//## classInstance A_terminal 
    
    
    SIP_terminal B_home_terminal;		//## classInstance B_home_terminal 
    
    
    SIP_terminal B_work_terminal;		//## classInstance B_work_terminal 
    
    
    SIP_terminal C_terminal;		//## classInstance C_terminal 
    
    
    Initiator_and_dns initiator_and_dns;		//## classInstance initiator_and_dns 
    
    
    SIP_Redirect sip_Redirect;		//## classInstance sip_Redirect 
    


};


#ifdef _OMINSTRUMENT
//## ignore 
class OMAnimatedarchitectureSIP : virtual public AOMInstance {

    
    DECLARE_META(architectureSIP, OMAnimatedarchitectureSIP)


////    Framework operations    ////
public :
    
    virtual void serializeRelations(AOMSRelations* aomsRelations) const;


};

#endif // _OMINSTRUMENT

#endif  
/*********************************************************************
	File Path	: DefaultComponent/DefaultConfig/architectureSIP.h
*********************************************************************/

