/********************************************************************
	Rhapsody	: 6.1 
	Login		: Masood Khosroshahy
	Component	: DefaultComponent 
	Configuration 	: DefaultConfig
	Model Element	: sip
//!	Generated Date	: Thu, 20, Apr 2006  
	File Path	: DefaultComponent/DefaultConfig/sip.cpp
*********************************************************************/


//#[ ignore 
#define NAMESPACE_PREFIX 
//#]

#include "sip.h"
#include "architectureSIP.h"
#include "iDNSLookupInitRes.h"
#include "iDNSLookupResInit.h"
#include "Initiator_and_dns.h"
#include "SIP_Redirect.h"
#include "SIP_terminal.h"

//## package sip 


//#[ ignore 
#define evDNSLookup_SERIALIZE OMADD_SER(domain, x2String(myEvent->domain))


#define evDNSLookup_UNSERIALIZE OMADD_UNSER(OMString, domain, OMDestructiveString2X)


#define evDNSLookup_CONSTRUCTOR evDNSLookup(domain)


#define evDNSLookupRes_SERIALIZE OMADD_SER(portName, x2String(myEvent->portName))


#define evDNSLookupRes_UNSERIALIZE OMADD_UNSER(char*, portName, OMDestructiveString2X)


#define evDNSLookupRes_CONSTRUCTOR evDNSLookupRes(portName)


#define evINVITE_SERIALIZE \
    OMADD_SER(corres, x2String(myEvent->corres)) \
    OMADD_SER(sip_headerset, UNKNOWN2STRING(myEvent->sip_headerset)) \
    OMADD_SER(sip_body, UNKNOWN2STRING(myEvent->sip_body))


#define evINVITE_UNSERIALIZE \
    OMADD_UNSER(OMString, corres, OMDestructiveString2X) \
    OMADD_UNSER(SIP_headerset, sip_headerset, OMDestructiveString2X) \
    OMADD_UNSER(SIP_body, sip_body, OMDestructiveString2X)


#define evINVITE_CONSTRUCTOR evINVITE(corres, sip_headerset, sip_body)


#define evCall_SERIALIZE OMADD_SER(string, x2String(myEvent->string))


#define evCall_UNSERIALIZE OMADD_UNSER(char*, string, OMDestructiveString2X)


#define evCall_CONSTRUCTOR evCall(string)


#define evHangup_SERIALIZE OM_NO_OP


#define evHangup_UNSERIALIZE OM_NO_OP


#define evHangup_CONSTRUCTOR evHangup()


#define evLogin_SERIALIZE OMADD_SER(string, x2String(myEvent->string))


#define evLogin_UNSERIALIZE OMADD_UNSER(char*, string, OMDestructiveString2X)


#define evLogin_CONSTRUCTOR evLogin(string)


#define evDoCallForwarding_SERIALIZE OMADD_SER(string, x2String(myEvent->string))


#define evDoCallForwarding_UNSERIALIZE OMADD_UNSER(char*, string, OMDestructiveString2X)


#define evDoCallForwarding_CONSTRUCTOR evDoCallForwarding(string)


#define evLogout_SERIALIZE OM_NO_OP


#define evLogout_UNSERIALIZE OM_NO_OP


#define evLogout_CONSTRUCTOR evLogout()


#define evDoCallFwdOnBusy_SERIALIZE OMADD_SER(string, x2String(myEvent->string))


#define evDoCallFwdOnBusy_UNSERIALIZE OMADD_UNSER(char*, string, OMDestructiveString2X)


#define evDoCallFwdOnBusy_CONSTRUCTOR evDoCallFwdOnBusy(string)


#define evACK_SERIALIZE \
    OMADD_SER(startLine, x2String(myEvent->startLine)) \
    OMADD_SER(sip_headerset, UNKNOWN2STRING(myEvent->sip_headerset)) \
    OMADD_SER(sip_body, UNKNOWN2STRING(myEvent->sip_body))


#define evACK_UNSERIALIZE \
    OMADD_UNSER(OMString, startLine, OMDestructiveString2X) \
    OMADD_UNSER(SIP_headerset, sip_headerset, OMDestructiveString2X) \
    OMADD_UNSER(SIP_body, sip_body, OMDestructiveString2X)


#define evACK_CONSTRUCTOR evACK(startLine, sip_headerset, sip_body)


#define evOPTIONS_SERIALIZE \
    OMADD_SER(startLine, x2String(myEvent->startLine)) \
    OMADD_SER(sip_headerset, UNKNOWN2STRING(myEvent->sip_headerset)) \
    OMADD_SER(sip_body, UNKNOWN2STRING(myEvent->sip_body))


#define evOPTIONS_UNSERIALIZE \
    OMADD_UNSER(char*, startLine, OMDestructiveString2X) \
    OMADD_UNSER(SIP_headerset, sip_headerset, OMDestructiveString2X) \
    OMADD_UNSER(SIP_body, sip_body, OMDestructiveString2X)


#define evOPTIONS_CONSTRUCTOR evOPTIONS(startLine, sip_headerset, sip_body)


#define evBYE_SERIALIZE \
    OMADD_SER(startLine, x2String(myEvent->startLine)) \
    OMADD_SER(sip_headerset, UNKNOWN2STRING(myEvent->sip_headerset)) \
    OMADD_SER(sip_body, UNKNOWN2STRING(myEvent->sip_body))


#define evBYE_UNSERIALIZE \
    OMADD_UNSER(OMString, startLine, OMDestructiveString2X) \
    OMADD_UNSER(SIP_headerset, sip_headerset, OMDestructiveString2X) \
    OMADD_UNSER(SIP_body, sip_body, OMDestructiveString2X)


#define evBYE_CONSTRUCTOR evBYE(startLine, sip_headerset, sip_body)


#define evCANCEL_SERIALIZE \
    OMADD_SER(startLine, x2String(myEvent->startLine)) \
    OMADD_SER(sip_headerset, UNKNOWN2STRING(myEvent->sip_headerset)) \
    OMADD_SER(sip_body, UNKNOWN2STRING(myEvent->sip_body))


#define evCANCEL_UNSERIALIZE \
    OMADD_UNSER(char*, startLine, OMDestructiveString2X) \
    OMADD_UNSER(SIP_headerset, sip_headerset, OMDestructiveString2X) \
    OMADD_UNSER(SIP_body, sip_body, OMDestructiveString2X)


#define evCANCEL_CONSTRUCTOR evCANCEL(startLine, sip_headerset, sip_body)


#define evREGISTER_SERIALIZE \
    OMADD_SER(startLine, x2String(myEvent->startLine)) \
    OMADD_SER(expires, x2String(myEvent->expires)) \
    OMADD_SER(sip_headerset, UNKNOWN2STRING(myEvent->sip_headerset))


#define evREGISTER_UNSERIALIZE \
    OMADD_UNSER(char*, startLine, OMDestructiveString2X) \
    OMADD_UNSER(OMString, expires, OMDestructiveString2X) \
    OMADD_UNSER(SIP_headerset, sip_headerset, OMDestructiveString2X)


#define evREGISTER_CONSTRUCTOR evREGISTER(startLine, expires, sip_headerset)


#define ev100_trying_SERIALIZE \
    OMADD_SER(sip_headerset, UNKNOWN2STRING(myEvent->sip_headerset)) \
    OMADD_SER(sip_body, UNKNOWN2STRING(myEvent->sip_body))


#define ev100_trying_UNSERIALIZE \
    OMADD_UNSER(SIP_headerset, sip_headerset, OMDestructiveString2X) \
    OMADD_UNSER(SIP_body, sip_body, OMDestructiveString2X)


#define ev100_trying_CONSTRUCTOR ev100_trying(sip_headerset, sip_body)


#define ev180_ringing_SERIALIZE \
    OMADD_SER(sip_headerset, UNKNOWN2STRING(myEvent->sip_headerset)) \
    OMADD_SER(sip_body, UNKNOWN2STRING(myEvent->sip_body))


#define ev180_ringing_UNSERIALIZE \
    OMADD_UNSER(SIP_headerset, sip_headerset, OMDestructiveString2X) \
    OMADD_UNSER(SIP_body, sip_body, OMDestructiveString2X)


#define ev180_ringing_CONSTRUCTOR ev180_ringing(sip_headerset, sip_body)


#define ev181_being_forwarded_SERIALIZE \
    OMADD_SER(sip_headerset, UNKNOWN2STRING(myEvent->sip_headerset)) \
    OMADD_SER(sip_body, UNKNOWN2STRING(myEvent->sip_body))


#define ev181_being_forwarded_UNSERIALIZE \
    OMADD_UNSER(SIP_headerset, sip_headerset, OMDestructiveString2X) \
    OMADD_UNSER(SIP_body, sip_body, OMDestructiveString2X)


#define ev181_being_forwarded_CONSTRUCTOR ev181_being_forwarded(sip_headerset, sip_body)


#define ev200_OK_SERIALIZE \
    OMADD_SER(sip_headerset, UNKNOWN2STRING(myEvent->sip_headerset)) \
    OMADD_SER(sip_body, UNKNOWN2STRING(myEvent->sip_body))


#define ev200_OK_UNSERIALIZE \
    OMADD_UNSER(SIP_headerset, sip_headerset, OMDestructiveString2X) \
    OMADD_UNSER(SIP_body, sip_body, OMDestructiveString2X)


#define ev200_OK_CONSTRUCTOR ev200_OK(sip_headerset, sip_body)


#define ev301_moved_perm_SERIALIZE \
    OMADD_SER(contact, x2String(myEvent->contact)) \
    OMADD_SER(sip_headerset, UNKNOWN2STRING(myEvent->sip_headerset)) \
    OMADD_SER(sip_body, UNKNOWN2STRING(myEvent->sip_body))


#define ev301_moved_perm_UNSERIALIZE \
    OMADD_UNSER(OMString, contact, OMDestructiveString2X) \
    OMADD_UNSER(SIP_headerset, sip_headerset, OMDestructiveString2X) \
    OMADD_UNSER(SIP_body, sip_body, OMDestructiveString2X)


#define ev301_moved_perm_CONSTRUCTOR ev301_moved_perm(contact, sip_headerset, sip_body)


#define ev302_moved_tmp_SERIALIZE \
    OMADD_SER(sip_headerset, UNKNOWN2STRING(myEvent->sip_headerset)) \
    OMADD_SER(sip_body, UNKNOWN2STRING(myEvent->sip_body))


#define ev302_moved_tmp_UNSERIALIZE \
    OMADD_UNSER(SIP_headerset, sip_headerset, OMDestructiveString2X) \
    OMADD_UNSER(SIP_body, sip_body, OMDestructiveString2X)


#define ev302_moved_tmp_CONSTRUCTOR ev302_moved_tmp(sip_headerset, sip_body)


#define ev305_use_proxy_SERIALIZE \
    OMADD_SER(sip_headerset, UNKNOWN2STRING(myEvent->sip_headerset)) \
    OMADD_SER(sip_body, UNKNOWN2STRING(myEvent->sip_body))


#define ev305_use_proxy_UNSERIALIZE \
    OMADD_UNSER(SIP_headerset, sip_headerset, OMDestructiveString2X) \
    OMADD_UNSER(SIP_body, sip_body, OMDestructiveString2X)


#define ev305_use_proxy_CONSTRUCTOR ev305_use_proxy(sip_headerset, sip_body)


#define ev400_bad_request_SERIALIZE \
    OMADD_SER(sip_headerset, UNKNOWN2STRING(myEvent->sip_headerset)) \
    OMADD_SER(sip_body, UNKNOWN2STRING(myEvent->sip_body))


#define ev400_bad_request_UNSERIALIZE \
    OMADD_UNSER(SIP_headerset, sip_headerset, OMDestructiveString2X) \
    OMADD_UNSER(SIP_body, sip_body, OMDestructiveString2X)


#define ev400_bad_request_CONSTRUCTOR ev400_bad_request(sip_headerset, sip_body)


#define ev401_unauth_SERIALIZE \
    OMADD_SER(sip_headerset, UNKNOWN2STRING(myEvent->sip_headerset)) \
    OMADD_SER(sip_body, UNKNOWN2STRING(myEvent->sip_body))


#define ev401_unauth_UNSERIALIZE \
    OMADD_UNSER(SIP_headerset, sip_headerset, OMDestructiveString2X) \
    OMADD_UNSER(SIP_body, sip_body, OMDestructiveString2X)


#define ev401_unauth_CONSTRUCTOR ev401_unauth(sip_headerset, sip_body)


#define ev403_forbidden_SERIALIZE \
    OMADD_SER(sip_headerset, UNKNOWN2STRING(myEvent->sip_headerset)) \
    OMADD_SER(sip_body, UNKNOWN2STRING(myEvent->sip_body))


#define ev403_forbidden_UNSERIALIZE \
    OMADD_UNSER(SIP_headerset, sip_headerset, OMDestructiveString2X) \
    OMADD_UNSER(SIP_body, sip_body, OMDestructiveString2X)


#define ev403_forbidden_CONSTRUCTOR ev403_forbidden(sip_headerset, sip_body)


#define ev404_not_found_SERIALIZE \
    OMADD_SER(sip_headerset, UNKNOWN2STRING(myEvent->sip_headerset)) \
    OMADD_SER(sip_body, UNKNOWN2STRING(myEvent->sip_body))


#define ev404_not_found_UNSERIALIZE \
    OMADD_UNSER(SIP_headerset, sip_headerset, OMDestructiveString2X) \
    OMADD_UNSER(SIP_body, sip_body, OMDestructiveString2X)


#define ev404_not_found_CONSTRUCTOR ev404_not_found(sip_headerset, sip_body)


#define ev415_unsupp_media_SERIALIZE \
    OMADD_SER(sip_headerset, UNKNOWN2STRING(myEvent->sip_headerset)) \
    OMADD_SER(sip_body, UNKNOWN2STRING(myEvent->sip_body))


#define ev415_unsupp_media_UNSERIALIZE \
    OMADD_UNSER(SIP_headerset, sip_headerset, OMDestructiveString2X) \
    OMADD_UNSER(SIP_body, sip_body, OMDestructiveString2X)


#define ev415_unsupp_media_CONSTRUCTOR ev415_unsupp_media(sip_headerset, sip_body)


#define ev480_temp_unavailable_SERIALIZE \
    OMADD_SER(sip_headerset, UNKNOWN2STRING(myEvent->sip_headerset)) \
    OMADD_SER(sip_body, UNKNOWN2STRING(myEvent->sip_body))


#define ev480_temp_unavailable_UNSERIALIZE \
    OMADD_UNSER(SIP_headerset, sip_headerset, OMDestructiveString2X) \
    OMADD_UNSER(SIP_body, sip_body, OMDestructiveString2X)


#define ev480_temp_unavailable_CONSTRUCTOR ev480_temp_unavailable(sip_headerset, sip_body)


#define ev482_loop_detected_SERIALIZE \
    OMADD_SER(sip_headerset, UNKNOWN2STRING(myEvent->sip_headerset)) \
    OMADD_SER(sip_body, UNKNOWN2STRING(myEvent->sip_body))


#define ev482_loop_detected_UNSERIALIZE \
    OMADD_UNSER(SIP_headerset, sip_headerset, OMDestructiveString2X) \
    OMADD_UNSER(SIP_body, sip_body, OMDestructiveString2X)


#define ev482_loop_detected_CONSTRUCTOR ev482_loop_detected(sip_headerset, sip_body)


#define ev486_busy_here_SERIALIZE \
    OMADD_SER(sip_headerset, UNKNOWN2STRING(myEvent->sip_headerset)) \
    OMADD_SER(sip_body, UNKNOWN2STRING(myEvent->sip_body))


#define ev486_busy_here_UNSERIALIZE \
    OMADD_UNSER(SIP_headerset, sip_headerset, OMDestructiveString2X) \
    OMADD_UNSER(SIP_body, sip_body, OMDestructiveString2X)


#define ev486_busy_here_CONSTRUCTOR ev486_busy_here(sip_headerset, sip_body)


#define ev500_server_error_SERIALIZE \
    OMADD_SER(sip_headerset, UNKNOWN2STRING(myEvent->sip_headerset)) \
    OMADD_SER(sip_body, UNKNOWN2STRING(myEvent->sip_body))


#define ev500_server_error_UNSERIALIZE \
    OMADD_UNSER(SIP_headerset, sip_headerset, OMDestructiveString2X) \
    OMADD_UNSER(SIP_body, sip_body, OMDestructiveString2X)


#define ev500_server_error_CONSTRUCTOR ev500_server_error(sip_headerset, sip_body)


#define ev501_not_impl_SERIALIZE \
    OMADD_SER(sip_headerset, UNKNOWN2STRING(myEvent->sip_headerset)) \
    OMADD_SER(sip_body, UNKNOWN2STRING(myEvent->sip_body))


#define ev501_not_impl_UNSERIALIZE \
    OMADD_UNSER(SIP_headerset, sip_headerset, OMDestructiveString2X) \
    OMADD_UNSER(SIP_body, sip_body, OMDestructiveString2X)


#define ev501_not_impl_CONSTRUCTOR ev501_not_impl(sip_headerset, sip_body)


#define ev502_bad_gateway_SERIALIZE \
    OMADD_SER(sip_headerset, UNKNOWN2STRING(myEvent->sip_headerset)) \
    OMADD_SER(sip_body, UNKNOWN2STRING(myEvent->sip_body))


#define ev502_bad_gateway_UNSERIALIZE \
    OMADD_UNSER(SIP_headerset, sip_headerset, OMDestructiveString2X) \
    OMADD_UNSER(SIP_body, sip_body, OMDestructiveString2X)


#define ev502_bad_gateway_CONSTRUCTOR ev502_bad_gateway(sip_headerset, sip_body)


#define ev600_busy_SERIALIZE \
    OMADD_SER(sip_headerset, UNKNOWN2STRING(myEvent->sip_headerset)) \
    OMADD_SER(sip_body, UNKNOWN2STRING(myEvent->sip_body))


#define ev600_busy_UNSERIALIZE \
    OMADD_UNSER(SIP_headerset, sip_headerset, OMDestructiveString2X) \
    OMADD_UNSER(SIP_body, sip_body, OMDestructiveString2X)


#define ev600_busy_CONSTRUCTOR ev600_busy(sip_headerset, sip_body)


#define ev603_decline_SERIALIZE \
    OMADD_SER(sip_headerset, UNKNOWN2STRING(myEvent->sip_headerset)) \
    OMADD_SER(sip_body, UNKNOWN2STRING(myEvent->sip_body))


#define ev603_decline_UNSERIALIZE \
    OMADD_UNSER(SIP_headerset, sip_headerset, OMDestructiveString2X) \
    OMADD_UNSER(SIP_body, sip_body, OMDestructiveString2X)


#define ev603_decline_CONSTRUCTOR ev603_decline(sip_headerset, sip_body)


#define ev604_not_exists_anywhere_SERIALIZE \
    OMADD_SER(sip_headerset, UNKNOWN2STRING(myEvent->sip_headerset)) \
    OMADD_SER(sip_body, UNKNOWN2STRING(myEvent->sip_body))


#define ev604_not_exists_anywhere_UNSERIALIZE \
    OMADD_UNSER(SIP_headerset, sip_headerset, OMDestructiveString2X) \
    OMADD_UNSER(SIP_body, sip_body, OMDestructiveString2X)


#define ev604_not_exists_anywhere_CONSTRUCTOR ev604_not_exists_anywhere(sip_headerset, sip_body)


#define evInitialization_SERIALIZE \
    OMADD_SER(dom_name, x2String(myEvent->dom_name)) \
    OMADD_SER(redirectAddress, x2String(myEvent->redirectAddress))


#define evInitialization_UNSERIALIZE \
    OMADD_UNSER(char*, dom_name, OMDestructiveString2X) \
    OMADD_UNSER(char*, redirectAddress, OMDestructiveString2X)


#define evInitialization_CONSTRUCTOR evInitialization(dom_name, redirectAddress)


#define evRes_init_SERIALIZE OMADD_SER(dom_name, x2String(myEvent->dom_name))


#define evRes_init_UNSERIALIZE OMADD_UNSER(char*, dom_name, OMDestructiveString2X)


#define evRes_init_CONSTRUCTOR evRes_init(dom_name)


#define removeServerFromViaField_SERIALIZE OM_NO_OP


#define removeServerFromViaField_UNSERIALIZE OM_NO_OP


#define removeServerFromViaField_CONSTRUCTOR removeServerFromViaField()
//#]

//----------------------------------------------------------------------------
// sip.cpp                                                                  
//----------------------------------------------------------------------------


#ifdef _OMINSTRUMENT
static void serializeGlobalVars(AOMSAttributes* aomsAttributes);
#endif // _OMINSTRUMENT
IMPLEMENT_META_PACKAGE(sip,sip)



#ifdef _OMINSTRUMENT
static void serializeGlobalVars(AOMSAttributes* aomsAttributes) {
}

#endif // _OMINSTRUMENT


evDNSLookup::evDNSLookup() {
    NOTIFY_EVENT_CONSTRUCTOR(evDNSLookup)
    setId(evDNSLookup_sip_id);
}

evDNSLookup::evDNSLookup(OMString p_domain) {
    NOTIFY_EVENT_CONSTRUCTOR(evDNSLookup)
    setId(evDNSLookup_sip_id);
    domain = p_domain;
}

bool evDNSLookup::isTypeOf(short id) const {
    if(evDNSLookup_sip_id==id)
        {
            return true;
        }
    else
        {
            return false;
        }
}


#ifdef _OMINSTRUMENT


IMPLEMENT_META_EVENT(evDNSLookup, sip, evDNSLookup(OMString))
#endif // _OMINSTRUMENT



evDNSLookupRes::evDNSLookupRes() {
    NOTIFY_EVENT_CONSTRUCTOR(evDNSLookupRes)
    setId(evDNSLookupRes_sip_id);
}

evDNSLookupRes::evDNSLookupRes(char* p_portName) {
    NOTIFY_EVENT_CONSTRUCTOR(evDNSLookupRes)
    setId(evDNSLookupRes_sip_id);
    portName = p_portName;
}

bool evDNSLookupRes::isTypeOf(short id) const {
    if(evDNSLookupRes_sip_id==id)
        {
            return true;
        }
    else
        {
            return false;
        }
}


#ifdef _OMINSTRUMENT


IMPLEMENT_META_EVENT(evDNSLookupRes, sip, evDNSLookupRes(char*))
#endif // _OMINSTRUMENT



evINVITE::evINVITE() {
    NOTIFY_EVENT_CONSTRUCTOR(evINVITE)
    setId(evINVITE_sip_id);
}

evINVITE::evINVITE(OMString p_corres, SIP_headerset p_sip_headerset, SIP_body p_sip_body) {
    NOTIFY_EVENT_CONSTRUCTOR(evINVITE)
    setId(evINVITE_sip_id);
    corres = p_corres;
    sip_headerset = p_sip_headerset;
    sip_body = p_sip_body;
}

bool evINVITE::isTypeOf(short id) const {
    if(evINVITE_sip_id==id)
        {
            return true;
        }
    else
        {
            return false;
        }
}


#ifdef _OMINSTRUMENT


IMPLEMENT_META_EVENT_NO_UNSERIALIZE(evINVITE, sip, evINVITE(OMString,SIP_headerset,SIP_body))
#endif // _OMINSTRUMENT



evCall::evCall() {
    NOTIFY_EVENT_CONSTRUCTOR(evCall)
    setId(evCall_sip_id);
}

evCall::evCall(char* p_string) {
    NOTIFY_EVENT_CONSTRUCTOR(evCall)
    setId(evCall_sip_id);
    string = p_string;
}

bool evCall::isTypeOf(short id) const {
    if(evCall_sip_id==id)
        {
            return true;
        }
    else
        {
            return false;
        }
}


#ifdef _OMINSTRUMENT


IMPLEMENT_META_EVENT(evCall, sip, evCall(char*))
#endif // _OMINSTRUMENT


evHangup::evHangup() {
    NOTIFY_EVENT_CONSTRUCTOR(evHangup)
    setId(evHangup_sip_id);
}

bool evHangup::isTypeOf(short id) const {
    if(evHangup_sip_id==id)
        {
            return true;
        }
    else
        {
            return false;
        }
}


#ifdef _OMINSTRUMENT


IMPLEMENT_META_EVENT(evHangup, sip, evHangup())
#endif // _OMINSTRUMENT



evLogin::evLogin() {
    NOTIFY_EVENT_CONSTRUCTOR(evLogin)
    setId(evLogin_sip_id);
}

evLogin::evLogin(char* p_string) {
    NOTIFY_EVENT_CONSTRUCTOR(evLogin)
    setId(evLogin_sip_id);
    string = p_string;
}

bool evLogin::isTypeOf(short id) const {
    if(evLogin_sip_id==id)
        {
            return true;
        }
    else
        {
            return false;
        }
}


#ifdef _OMINSTRUMENT


IMPLEMENT_META_EVENT(evLogin, sip, evLogin(char*))
#endif // _OMINSTRUMENT



evDoCallForwarding::evDoCallForwarding() {
    NOTIFY_EVENT_CONSTRUCTOR(evDoCallForwarding)
    setId(evDoCallForwarding_sip_id);
}

evDoCallForwarding::evDoCallForwarding(char* p_string) {
    NOTIFY_EVENT_CONSTRUCTOR(evDoCallForwarding)
    setId(evDoCallForwarding_sip_id);
    string = p_string;
}

bool evDoCallForwarding::isTypeOf(short id) const {
    if(evDoCallForwarding_sip_id==id)
        {
            return true;
        }
    else
        {
            return false;
        }
}


#ifdef _OMINSTRUMENT


IMPLEMENT_META_EVENT(evDoCallForwarding, sip, evDoCallForwarding(char*))
#endif // _OMINSTRUMENT


evLogout::evLogout() {
    NOTIFY_EVENT_CONSTRUCTOR(evLogout)
    setId(evLogout_sip_id);
}

bool evLogout::isTypeOf(short id) const {
    if(evLogout_sip_id==id)
        {
            return true;
        }
    else
        {
            return false;
        }
}


#ifdef _OMINSTRUMENT


IMPLEMENT_META_EVENT(evLogout, sip, evLogout())
#endif // _OMINSTRUMENT



evDoCallFwdOnBusy::evDoCallFwdOnBusy() {
    NOTIFY_EVENT_CONSTRUCTOR(evDoCallFwdOnBusy)
    setId(evDoCallFwdOnBusy_sip_id);
}

evDoCallFwdOnBusy::evDoCallFwdOnBusy(char* p_string) {
    NOTIFY_EVENT_CONSTRUCTOR(evDoCallFwdOnBusy)
    setId(evDoCallFwdOnBusy_sip_id);
    string = p_string;
}

bool evDoCallFwdOnBusy::isTypeOf(short id) const {
    if(evDoCallFwdOnBusy_sip_id==id)
        {
            return true;
        }
    else
        {
            return false;
        }
}


#ifdef _OMINSTRUMENT


IMPLEMENT_META_EVENT(evDoCallFwdOnBusy, sip, evDoCallFwdOnBusy(char*))
#endif // _OMINSTRUMENT



evACK::evACK() {
    NOTIFY_EVENT_CONSTRUCTOR(evACK)
    setId(evACK_sip_id);
}

evACK::evACK(OMString p_startLine, SIP_headerset p_sip_headerset, SIP_body p_sip_body) {
    NOTIFY_EVENT_CONSTRUCTOR(evACK)
    setId(evACK_sip_id);
    startLine = p_startLine;
    sip_headerset = p_sip_headerset;
    sip_body = p_sip_body;
}

bool evACK::isTypeOf(short id) const {
    if(evACK_sip_id==id)
        {
            return true;
        }
    else
        {
            return false;
        }
}


#ifdef _OMINSTRUMENT


IMPLEMENT_META_EVENT_NO_UNSERIALIZE(evACK, sip, evACK(OMString,SIP_headerset,SIP_body))
#endif // _OMINSTRUMENT



evOPTIONS::evOPTIONS() {
    NOTIFY_EVENT_CONSTRUCTOR(evOPTIONS)
    setId(evOPTIONS_sip_id);
}

evOPTIONS::evOPTIONS(char* p_startLine, SIP_headerset p_sip_headerset, SIP_body p_sip_body) {
    NOTIFY_EVENT_CONSTRUCTOR(evOPTIONS)
    setId(evOPTIONS_sip_id);
    startLine = p_startLine;
    sip_headerset = p_sip_headerset;
    sip_body = p_sip_body;
}

bool evOPTIONS::isTypeOf(short id) const {
    if(evOPTIONS_sip_id==id)
        {
            return true;
        }
    else
        {
            return false;
        }
}


#ifdef _OMINSTRUMENT


IMPLEMENT_META_EVENT_NO_UNSERIALIZE(evOPTIONS, sip, evOPTIONS(char*,SIP_headerset,SIP_body))
#endif // _OMINSTRUMENT



evBYE::evBYE() {
    NOTIFY_EVENT_CONSTRUCTOR(evBYE)
    setId(evBYE_sip_id);
}

evBYE::evBYE(OMString p_startLine, SIP_headerset p_sip_headerset, SIP_body p_sip_body) {
    NOTIFY_EVENT_CONSTRUCTOR(evBYE)
    setId(evBYE_sip_id);
    startLine = p_startLine;
    sip_headerset = p_sip_headerset;
    sip_body = p_sip_body;
}

bool evBYE::isTypeOf(short id) const {
    if(evBYE_sip_id==id)
        {
            return true;
        }
    else
        {
            return false;
        }
}


#ifdef _OMINSTRUMENT


IMPLEMENT_META_EVENT_NO_UNSERIALIZE(evBYE, sip, evBYE(OMString,SIP_headerset,SIP_body))
#endif // _OMINSTRUMENT



evCANCEL::evCANCEL() {
    NOTIFY_EVENT_CONSTRUCTOR(evCANCEL)
    setId(evCANCEL_sip_id);
}

evCANCEL::evCANCEL(char* p_startLine, SIP_headerset p_sip_headerset, SIP_body p_sip_body) {
    NOTIFY_EVENT_CONSTRUCTOR(evCANCEL)
    setId(evCANCEL_sip_id);
    startLine = p_startLine;
    sip_headerset = p_sip_headerset;
    sip_body = p_sip_body;
}

bool evCANCEL::isTypeOf(short id) const {
    if(evCANCEL_sip_id==id)
        {
            return true;
        }
    else
        {
            return false;
        }
}


#ifdef _OMINSTRUMENT


IMPLEMENT_META_EVENT_NO_UNSERIALIZE(evCANCEL, sip, evCANCEL(char*,SIP_headerset,SIP_body))
#endif // _OMINSTRUMENT



evREGISTER::evREGISTER() {
    NOTIFY_EVENT_CONSTRUCTOR(evREGISTER)
    setId(evREGISTER_sip_id);
}

evREGISTER::evREGISTER(char* p_startLine, OMString p_expires, SIP_headerset p_sip_headerset) {
    NOTIFY_EVENT_CONSTRUCTOR(evREGISTER)
    setId(evREGISTER_sip_id);
    startLine = p_startLine;
    expires = p_expires;
    sip_headerset = p_sip_headerset;
}

bool evREGISTER::isTypeOf(short id) const {
    if(evREGISTER_sip_id==id)
        {
            return true;
        }
    else
        {
            return false;
        }
}


#ifdef _OMINSTRUMENT


IMPLEMENT_META_EVENT_NO_UNSERIALIZE(evREGISTER, sip, evREGISTER(char*,OMString,SIP_headerset))
#endif // _OMINSTRUMENT



ev100_trying::ev100_trying() {
    NOTIFY_EVENT_CONSTRUCTOR(ev100_trying)
    setId(ev100_trying_sip_id);
}

ev100_trying::ev100_trying(SIP_headerset p_sip_headerset, SIP_body p_sip_body) {
    NOTIFY_EVENT_CONSTRUCTOR(ev100_trying)
    setId(ev100_trying_sip_id);
    sip_headerset = p_sip_headerset;
    sip_body = p_sip_body;
}

bool ev100_trying::isTypeOf(short id) const {
    if(ev100_trying_sip_id==id)
        {
            return true;
        }
    else
        {
            return false;
        }
}


#ifdef _OMINSTRUMENT


IMPLEMENT_META_EVENT_NO_UNSERIALIZE(ev100_trying, sip, ev100_trying(SIP_headerset,SIP_body))
#endif // _OMINSTRUMENT



ev180_ringing::ev180_ringing() {
    NOTIFY_EVENT_CONSTRUCTOR(ev180_ringing)
    setId(ev180_ringing_sip_id);
}

ev180_ringing::ev180_ringing(SIP_headerset p_sip_headerset, SIP_body p_sip_body) {
    NOTIFY_EVENT_CONSTRUCTOR(ev180_ringing)
    setId(ev180_ringing_sip_id);
    sip_headerset = p_sip_headerset;
    sip_body = p_sip_body;
}

bool ev180_ringing::isTypeOf(short id) const {
    if(ev180_ringing_sip_id==id)
        {
            return true;
        }
    else
        {
            return false;
        }
}


#ifdef _OMINSTRUMENT


IMPLEMENT_META_EVENT_NO_UNSERIALIZE(ev180_ringing, sip, ev180_ringing(SIP_headerset,SIP_body))
#endif // _OMINSTRUMENT



ev181_being_forwarded::ev181_being_forwarded() {
    NOTIFY_EVENT_CONSTRUCTOR(ev181_being_forwarded)
    setId(ev181_being_forwarded_sip_id);
}

ev181_being_forwarded::ev181_being_forwarded(SIP_headerset p_sip_headerset, SIP_body p_sip_body) {
    NOTIFY_EVENT_CONSTRUCTOR(ev181_being_forwarded)
    setId(ev181_being_forwarded_sip_id);
    sip_headerset = p_sip_headerset;
    sip_body = p_sip_body;
}

bool ev181_being_forwarded::isTypeOf(short id) const {
    if(ev181_being_forwarded_sip_id==id)
        {
            return true;
        }
    else
        {
            return false;
        }
}


#ifdef _OMINSTRUMENT


IMPLEMENT_META_EVENT_NO_UNSERIALIZE(ev181_being_forwarded, sip, ev181_being_forwarded(SIP_headerset,SIP_body))
#endif // _OMINSTRUMENT



ev200_OK::ev200_OK() {
    NOTIFY_EVENT_CONSTRUCTOR(ev200_OK)
    setId(ev200_OK_sip_id);
}

ev200_OK::ev200_OK(SIP_headerset p_sip_headerset, SIP_body p_sip_body) {
    NOTIFY_EVENT_CONSTRUCTOR(ev200_OK)
    setId(ev200_OK_sip_id);
    sip_headerset = p_sip_headerset;
    sip_body = p_sip_body;
}

bool ev200_OK::isTypeOf(short id) const {
    if(ev200_OK_sip_id==id)
        {
            return true;
        }
    else
        {
            return false;
        }
}


#ifdef _OMINSTRUMENT


IMPLEMENT_META_EVENT_NO_UNSERIALIZE(ev200_OK, sip, ev200_OK(SIP_headerset,SIP_body))
#endif // _OMINSTRUMENT



ev301_moved_perm::ev301_moved_perm() {
    NOTIFY_EVENT_CONSTRUCTOR(ev301_moved_perm)
    setId(ev301_moved_perm_sip_id);
}

ev301_moved_perm::ev301_moved_perm(OMString p_contact, SIP_headerset p_sip_headerset, SIP_body p_sip_body) {
    NOTIFY_EVENT_CONSTRUCTOR(ev301_moved_perm)
    setId(ev301_moved_perm_sip_id);
    contact = p_contact;
    sip_headerset = p_sip_headerset;
    sip_body = p_sip_body;
}

bool ev301_moved_perm::isTypeOf(short id) const {
    if(ev301_moved_perm_sip_id==id)
        {
            return true;
        }
    else
        {
            return false;
        }
}


#ifdef _OMINSTRUMENT


IMPLEMENT_META_EVENT_NO_UNSERIALIZE(ev301_moved_perm, sip, ev301_moved_perm(OMString,SIP_headerset,SIP_body))
#endif // _OMINSTRUMENT



ev302_moved_tmp::ev302_moved_tmp() {
    NOTIFY_EVENT_CONSTRUCTOR(ev302_moved_tmp)
    setId(ev302_moved_tmp_sip_id);
}

ev302_moved_tmp::ev302_moved_tmp(SIP_headerset p_sip_headerset, SIP_body p_sip_body) {
    NOTIFY_EVENT_CONSTRUCTOR(ev302_moved_tmp)
    setId(ev302_moved_tmp_sip_id);
    sip_headerset = p_sip_headerset;
    sip_body = p_sip_body;
}

bool ev302_moved_tmp::isTypeOf(short id) const {
    if(ev302_moved_tmp_sip_id==id)
        {
            return true;
        }
    else
        {
            return false;
        }
}


#ifdef _OMINSTRUMENT


IMPLEMENT_META_EVENT_NO_UNSERIALIZE(ev302_moved_tmp, sip, ev302_moved_tmp(SIP_headerset,SIP_body))
#endif // _OMINSTRUMENT



ev305_use_proxy::ev305_use_proxy() {
    NOTIFY_EVENT_CONSTRUCTOR(ev305_use_proxy)
    setId(ev305_use_proxy_sip_id);
}

ev305_use_proxy::ev305_use_proxy(SIP_headerset p_sip_headerset, SIP_body p_sip_body) {
    NOTIFY_EVENT_CONSTRUCTOR(ev305_use_proxy)
    setId(ev305_use_proxy_sip_id);
    sip_headerset = p_sip_headerset;
    sip_body = p_sip_body;
}

bool ev305_use_proxy::isTypeOf(short id) const {
    if(ev305_use_proxy_sip_id==id)
        {
            return true;
        }
    else
        {
            return false;
        }
}


#ifdef _OMINSTRUMENT


IMPLEMENT_META_EVENT_NO_UNSERIALIZE(ev305_use_proxy, sip, ev305_use_proxy(SIP_headerset,SIP_body))
#endif // _OMINSTRUMENT



ev400_bad_request::ev400_bad_request() {
    NOTIFY_EVENT_CONSTRUCTOR(ev400_bad_request)
    setId(ev400_bad_request_sip_id);
}

ev400_bad_request::ev400_bad_request(SIP_headerset p_sip_headerset, SIP_body p_sip_body) {
    NOTIFY_EVENT_CONSTRUCTOR(ev400_bad_request)
    setId(ev400_bad_request_sip_id);
    sip_headerset = p_sip_headerset;
    sip_body = p_sip_body;
}

bool ev400_bad_request::isTypeOf(short id) const {
    if(ev400_bad_request_sip_id==id)
        {
            return true;
        }
    else
        {
            return false;
        }
}


#ifdef _OMINSTRUMENT


IMPLEMENT_META_EVENT_NO_UNSERIALIZE(ev400_bad_request, sip, ev400_bad_request(SIP_headerset,SIP_body))
#endif // _OMINSTRUMENT



ev401_unauth::ev401_unauth() {
    NOTIFY_EVENT_CONSTRUCTOR(ev401_unauth)
    setId(ev401_unauth_sip_id);
}

ev401_unauth::ev401_unauth(SIP_headerset p_sip_headerset, SIP_body p_sip_body) {
    NOTIFY_EVENT_CONSTRUCTOR(ev401_unauth)
    setId(ev401_unauth_sip_id);
    sip_headerset = p_sip_headerset;
    sip_body = p_sip_body;
}

bool ev401_unauth::isTypeOf(short id) const {
    if(ev401_unauth_sip_id==id)
        {
            return true;
        }
    else
        {
            return false;
        }
}


#ifdef _OMINSTRUMENT


IMPLEMENT_META_EVENT_NO_UNSERIALIZE(ev401_unauth, sip, ev401_unauth(SIP_headerset,SIP_body))
#endif // _OMINSTRUMENT



ev403_forbidden::ev403_forbidden() {
    NOTIFY_EVENT_CONSTRUCTOR(ev403_forbidden)
    setId(ev403_forbidden_sip_id);
}

ev403_forbidden::ev403_forbidden(SIP_headerset p_sip_headerset, SIP_body p_sip_body) {
    NOTIFY_EVENT_CONSTRUCTOR(ev403_forbidden)
    setId(ev403_forbidden_sip_id);
    sip_headerset = p_sip_headerset;
    sip_body = p_sip_body;
}

bool ev403_forbidden::isTypeOf(short id) const {
    if(ev403_forbidden_sip_id==id)
        {
            return true;
        }
    else
        {
            return false;
        }
}


#ifdef _OMINSTRUMENT


IMPLEMENT_META_EVENT_NO_UNSERIALIZE(ev403_forbidden, sip, ev403_forbidden(SIP_headerset,SIP_body))
#endif // _OMINSTRUMENT



ev404_not_found::ev404_not_found() {
    NOTIFY_EVENT_CONSTRUCTOR(ev404_not_found)
    setId(ev404_not_found_sip_id);
}

ev404_not_found::ev404_not_found(SIP_headerset p_sip_headerset, SIP_body p_sip_body) {
    NOTIFY_EVENT_CONSTRUCTOR(ev404_not_found)
    setId(ev404_not_found_sip_id);
    sip_headerset = p_sip_headerset;
    sip_body = p_sip_body;
}

bool ev404_not_found::isTypeOf(short id) const {
    if(ev404_not_found_sip_id==id)
        {
            return true;
        }
    else
        {
            return false;
        }
}


#ifdef _OMINSTRUMENT


IMPLEMENT_META_EVENT_NO_UNSERIALIZE(ev404_not_found, sip, ev404_not_found(SIP_headerset,SIP_body))
#endif // _OMINSTRUMENT



ev415_unsupp_media::ev415_unsupp_media() {
    NOTIFY_EVENT_CONSTRUCTOR(ev415_unsupp_media)
    setId(ev415_unsupp_media_sip_id);
}

ev415_unsupp_media::ev415_unsupp_media(SIP_headerset p_sip_headerset, SIP_body p_sip_body) {
    NOTIFY_EVENT_CONSTRUCTOR(ev415_unsupp_media)
    setId(ev415_unsupp_media_sip_id);
    sip_headerset = p_sip_headerset;
    sip_body = p_sip_body;
}

bool ev415_unsupp_media::isTypeOf(short id) const {
    if(ev415_unsupp_media_sip_id==id)
        {
            return true;
        }
    else
        {
            return false;
        }
}


#ifdef _OMINSTRUMENT


IMPLEMENT_META_EVENT_NO_UNSERIALIZE(ev415_unsupp_media, sip, ev415_unsupp_media(SIP_headerset,SIP_body))
#endif // _OMINSTRUMENT



ev480_temp_unavailable::ev480_temp_unavailable() {
    NOTIFY_EVENT_CONSTRUCTOR(ev480_temp_unavailable)
    setId(ev480_temp_unavailable_sip_id);
}

ev480_temp_unavailable::ev480_temp_unavailable(SIP_headerset p_sip_headerset, SIP_body p_sip_body) {
    NOTIFY_EVENT_CONSTRUCTOR(ev480_temp_unavailable)
    setId(ev480_temp_unavailable_sip_id);
    sip_headerset = p_sip_headerset;
    sip_body = p_sip_body;
}

bool ev480_temp_unavailable::isTypeOf(short id) const {
    if(ev480_temp_unavailable_sip_id==id)
        {
            return true;
        }
    else
        {
            return false;
        }
}


#ifdef _OMINSTRUMENT


IMPLEMENT_META_EVENT_NO_UNSERIALIZE(ev480_temp_unavailable, sip, ev480_temp_unavailable(SIP_headerset,SIP_body))
#endif // _OMINSTRUMENT



ev482_loop_detected::ev482_loop_detected() {
    NOTIFY_EVENT_CONSTRUCTOR(ev482_loop_detected)
    setId(ev482_loop_detected_sip_id);
}

ev482_loop_detected::ev482_loop_detected(SIP_headerset p_sip_headerset, SIP_body p_sip_body) {
    NOTIFY_EVENT_CONSTRUCTOR(ev482_loop_detected)
    setId(ev482_loop_detected_sip_id);
    sip_headerset = p_sip_headerset;
    sip_body = p_sip_body;
}

bool ev482_loop_detected::isTypeOf(short id) const {
    if(ev482_loop_detected_sip_id==id)
        {
            return true;
        }
    else
        {
            return false;
        }
}


#ifdef _OMINSTRUMENT


IMPLEMENT_META_EVENT_NO_UNSERIALIZE(ev482_loop_detected, sip, ev482_loop_detected(SIP_headerset,SIP_body))
#endif // _OMINSTRUMENT



ev486_busy_here::ev486_busy_here() {
    NOTIFY_EVENT_CONSTRUCTOR(ev486_busy_here)
    setId(ev486_busy_here_sip_id);
}

ev486_busy_here::ev486_busy_here(SIP_headerset p_sip_headerset, SIP_body p_sip_body) {
    NOTIFY_EVENT_CONSTRUCTOR(ev486_busy_here)
    setId(ev486_busy_here_sip_id);
    sip_headerset = p_sip_headerset;
    sip_body = p_sip_body;
}

bool ev486_busy_here::isTypeOf(short id) const {
    if(ev486_busy_here_sip_id==id)
        {
            return true;
        }
    else
        {
            return false;
        }
}


#ifdef _OMINSTRUMENT


IMPLEMENT_META_EVENT_NO_UNSERIALIZE(ev486_busy_here, sip, ev486_busy_here(SIP_headerset,SIP_body))
#endif // _OMINSTRUMENT



ev500_server_error::ev500_server_error() {
    NOTIFY_EVENT_CONSTRUCTOR(ev500_server_error)
    setId(ev500_server_error_sip_id);
}

ev500_server_error::ev500_server_error(SIP_headerset p_sip_headerset, SIP_body p_sip_body) {
    NOTIFY_EVENT_CONSTRUCTOR(ev500_server_error)
    setId(ev500_server_error_sip_id);
    sip_headerset = p_sip_headerset;
    sip_body = p_sip_body;
}

bool ev500_server_error::isTypeOf(short id) const {
    if(ev500_server_error_sip_id==id)
        {
            return true;
        }
    else
        {
            return false;
        }
}


#ifdef _OMINSTRUMENT


IMPLEMENT_META_EVENT_NO_UNSERIALIZE(ev500_server_error, sip, ev500_server_error(SIP_headerset,SIP_body))
#endif // _OMINSTRUMENT



ev501_not_impl::ev501_not_impl() {
    NOTIFY_EVENT_CONSTRUCTOR(ev501_not_impl)
    setId(ev501_not_impl_sip_id);
}

ev501_not_impl::ev501_not_impl(SIP_headerset p_sip_headerset, SIP_body p_sip_body) {
    NOTIFY_EVENT_CONSTRUCTOR(ev501_not_impl)
    setId(ev501_not_impl_sip_id);
    sip_headerset = p_sip_headerset;
    sip_body = p_sip_body;
}

bool ev501_not_impl::isTypeOf(short id) const {
    if(ev501_not_impl_sip_id==id)
        {
            return true;
        }
    else
        {
            return false;
        }
}


#ifdef _OMINSTRUMENT


IMPLEMENT_META_EVENT_NO_UNSERIALIZE(ev501_not_impl, sip, ev501_not_impl(SIP_headerset,SIP_body))
#endif // _OMINSTRUMENT



ev502_bad_gateway::ev502_bad_gateway() {
    NOTIFY_EVENT_CONSTRUCTOR(ev502_bad_gateway)
    setId(ev502_bad_gateway_sip_id);
}

ev502_bad_gateway::ev502_bad_gateway(SIP_headerset p_sip_headerset, SIP_body p_sip_body) {
    NOTIFY_EVENT_CONSTRUCTOR(ev502_bad_gateway)
    setId(ev502_bad_gateway_sip_id);
    sip_headerset = p_sip_headerset;
    sip_body = p_sip_body;
}

bool ev502_bad_gateway::isTypeOf(short id) const {
    if(ev502_bad_gateway_sip_id==id)
        {
            return true;
        }
    else
        {
            return false;
        }
}


#ifdef _OMINSTRUMENT


IMPLEMENT_META_EVENT_NO_UNSERIALIZE(ev502_bad_gateway, sip, ev502_bad_gateway(SIP_headerset,SIP_body))
#endif // _OMINSTRUMENT



ev600_busy::ev600_busy() {
    NOTIFY_EVENT_CONSTRUCTOR(ev600_busy)
    setId(ev600_busy_sip_id);
}

ev600_busy::ev600_busy(SIP_headerset p_sip_headerset, SIP_body p_sip_body) {
    NOTIFY_EVENT_CONSTRUCTOR(ev600_busy)
    setId(ev600_busy_sip_id);
    sip_headerset = p_sip_headerset;
    sip_body = p_sip_body;
}

bool ev600_busy::isTypeOf(short id) const {
    if(ev600_busy_sip_id==id)
        {
            return true;
        }
    else
        {
            return false;
        }
}


#ifdef _OMINSTRUMENT


IMPLEMENT_META_EVENT_NO_UNSERIALIZE(ev600_busy, sip, ev600_busy(SIP_headerset,SIP_body))
#endif // _OMINSTRUMENT



ev603_decline::ev603_decline() {
    NOTIFY_EVENT_CONSTRUCTOR(ev603_decline)
    setId(ev603_decline_sip_id);
}

ev603_decline::ev603_decline(SIP_headerset p_sip_headerset, SIP_body p_sip_body) {
    NOTIFY_EVENT_CONSTRUCTOR(ev603_decline)
    setId(ev603_decline_sip_id);
    sip_headerset = p_sip_headerset;
    sip_body = p_sip_body;
}

bool ev603_decline::isTypeOf(short id) const {
    if(ev603_decline_sip_id==id)
        {
            return true;
        }
    else
        {
            return false;
        }
}


#ifdef _OMINSTRUMENT


IMPLEMENT_META_EVENT_NO_UNSERIALIZE(ev603_decline, sip, ev603_decline(SIP_headerset,SIP_body))
#endif // _OMINSTRUMENT



ev604_not_exists_anywhere::ev604_not_exists_anywhere() {
    NOTIFY_EVENT_CONSTRUCTOR(ev604_not_exists_anywhere)
    setId(ev604_not_exists_anywhere_sip_id);
}

ev604_not_exists_anywhere::ev604_not_exists_anywhere(SIP_headerset p_sip_headerset, SIP_body p_sip_body) {
    NOTIFY_EVENT_CONSTRUCTOR(ev604_not_exists_anywhere)
    setId(ev604_not_exists_anywhere_sip_id);
    sip_headerset = p_sip_headerset;
    sip_body = p_sip_body;
}

bool ev604_not_exists_anywhere::isTypeOf(short id) const {
    if(ev604_not_exists_anywhere_sip_id==id)
        {
            return true;
        }
    else
        {
            return false;
        }
}


#ifdef _OMINSTRUMENT


IMPLEMENT_META_EVENT_NO_UNSERIALIZE(ev604_not_exists_anywhere, sip, ev604_not_exists_anywhere(SIP_headerset,SIP_body))
#endif // _OMINSTRUMENT



evInitialization::evInitialization() {
    NOTIFY_EVENT_CONSTRUCTOR(evInitialization)
    setId(evInitialization_sip_id);
}

evInitialization::evInitialization(char* p_dom_name, char* p_redirectAddress) {
    NOTIFY_EVENT_CONSTRUCTOR(evInitialization)
    setId(evInitialization_sip_id);
    dom_name = p_dom_name;
    redirectAddress = p_redirectAddress;
}

bool evInitialization::isTypeOf(short id) const {
    if(evInitialization_sip_id==id)
        {
            return true;
        }
    else
        {
            return false;
        }
}


#ifdef _OMINSTRUMENT


IMPLEMENT_META_EVENT(evInitialization, sip, evInitialization(char*,char*))
#endif // _OMINSTRUMENT



evRes_init::evRes_init() {
    NOTIFY_EVENT_CONSTRUCTOR(evRes_init)
    setId(evRes_init_sip_id);
}

evRes_init::evRes_init(char* p_dom_name) {
    NOTIFY_EVENT_CONSTRUCTOR(evRes_init)
    setId(evRes_init_sip_id);
    dom_name = p_dom_name;
}

bool evRes_init::isTypeOf(short id) const {
    if(evRes_init_sip_id==id)
        {
            return true;
        }
    else
        {
            return false;
        }
}


#ifdef _OMINSTRUMENT


IMPLEMENT_META_EVENT(evRes_init, sip, evRes_init(char*))
#endif // _OMINSTRUMENT


removeServerFromViaField::removeServerFromViaField() {
    NOTIFY_EVENT_CONSTRUCTOR(removeServerFromViaField)
    setId(removeServerFromViaField_sip_id);
}

bool removeServerFromViaField::isTypeOf(short id) const {
    if(removeServerFromViaField_sip_id==id)
        {
            return true;
        }
    else
        {
            return false;
        }
}


#ifdef _OMINSTRUMENT


IMPLEMENT_META_EVENT(removeServerFromViaField, sip, removeServerFromViaField())
#endif // _OMINSTRUMENT


/*********************************************************************
	File Path	: DefaultComponent/DefaultConfig/sip.cpp
*********************************************************************/

